// (c) NPAC
// Author: Mehmet Sen at NPAC
// Note :    This applet is written based on the first version which is
//           implemented by Ozgur Balsoy and Mehmet Sen.
//
import java.applet.*;
import java.awt.*;
import java.util.*;
//*******************************************************************//
// APPLET                                                           *//
//*******************************************************************//

public class GridApplet extends Applet {
  ControlPanel cp;
public void init() {
  Label status = new Label("Welcome!", Label.CENTER);
  status.setBackground(Color.pink);
  GridCanvas canvas = new GridCanvas(status,getImage(getDocumentBase(),"grenbull.gif"),getImage(getDocumentBase(),"redbull.gif"));
  cp= new ControlPanel(canvas, status);

  setLayout(new BorderLayout());

  add("North", cp);
  add("Center", canvas);
  add("South", status);
}
public void start()
  {
    cp.cellMode.showUp();
  }
}
//************************************************************************
// Control Panel
//*******************************************************************/

class ControlPanel extends Panel {

  int MAXLINES=20;
public choiceCanvas cellMode ;
  GridCanvas canvas;
  Label statusLine;
  Choice rows, cols;
  //    Choice cellMode;
public ControlPanel(GridCanvas canvas, Label statusLine) {
  //setBackground(Color.gray);
  //setForeground(Color.yellow);

  this.canvas = canvas;
  this.statusLine = statusLine;
  this.cellMode=new choiceCanvas(canvas);

  rows=new Choice();
  cols=new Choice();
  for(int i=1; i<MAXLINES; i++) {
    rows.addItem(Integer.toString(i));
    cols.addItem(Integer.toString(i));
  }
  //cellMode =new Choice();
  //cellMode.addItem("Brick");
  //cellMode.addItem("Left Brace");
  //cellMode.addItem("Right Brace");

  setLayout(new GridLayout(2,5));

  add(new Label("Rows:  ", Label.RIGHT));
  add(rows);
  add(new Label(" CELL MODE ", Label.LEFT));
  //add(cellMode,Label.CENTER);
  //add(canvas);

  add(new Button("New"));
  add(new Button("Graph"));

  add(new Label("Columns:  ", Label.RIGHT));
  add(cols);
  add(cellMode);

  //add(mymenu);


  add(new Button("Check"));
  add(new Button("Back"));
}

public boolean action(Event evt, Object what) {
  if(evt.target instanceof Button) {
    String s=(String)what;
    statusLine.setText(s);
    if(s.equals("New")) {
      canvas.draw(rows.getSelectedIndex()+1,
		  cols.getSelectedIndex()+1);
    } else if(s.equals("Check")) {
      canvas.check();
    } else if(s.equals("Back")) {
      canvas.back();
    }else if(s.equals("Graph")) {
      canvas.graph();
    }
    return true;
  }
  //else if ( evt.target instanceof Choice) {
  //   String s=(String) what;
  //canvas.setCellMode(s);
  // return true;
  //}
  return false;
}

}
//************************************************************************
// CANVAS
//*******************************************************************/
class GridCanvas extends Canvas {
  int WHITE=0,GRAY=2,BLACK=5,CYAN=34;
  int LEFT=1,RIGHT=2,BOTH=3,NONE=0;
  int UNDEFINED=-111;

  int visits=0;
  int sccvisits=0;
  int component=0;
  int dir=1;

  GraphComponent[] finish;
  GraphComponent[] strongConnComp;

  int  GRID=1;
  int GRAPH=0;
  int BRICK=0,LEFT_BRACE=1,RIGHT_BRACE=2;
  int displayMode=GRID;
  int cellMode=BRICK;
  Label statusLine;
  double MARGINS = 0.15;
  Image ballg;
  Image ballr;
  boolean rigid=false;
  int rows, cols, length;
  Point gridCorner;
  GraphComponent[] rowComps, colComps;
  GridCell[][] cells;
  boolean gridExist = false;

  int startRow,startCol; //internal usage, no meaning

public GridCanvas(Label statusLine,Image ballg,Image ballr) {
  this.ballg=ballg;
  this.ballr=ballr;
  this.statusLine = statusLine;
}

public void setCellMode(int mode) { //String mode){
  this.cellMode=mode;
  //if(mode.equals("Brick"))
  //	cellMode=BRICK;
  //else if (mode.equals("Left Brace"))
  //	cellMode=LEFT_BRACE;
  //else if (mode.equals("Right Brace"))
  //	cellMode=RIGHT_BRACE;
}
public void draw(int rows, int cols) {
  Graphics g=getGraphics();
  g.drawImage(ballg,-30,-30,null);
  g.drawImage(ballr,-60,-60,null);
  g.dispose();
  // asctual statrt

  displayMode=GRID;
  statusLine.setText("Drawing " + rows + " by " + cols + " grid.");
  cells=new GridCell[rows][cols];


  rowComps = new GraphComponent[rows];
  for(int i=0; i<rows; i++) {
    rowComps[i] = new GraphComponent( i );
    rowComps[i].setRowType();
  }

  colComps = new GraphComponent[cols];
  for(int i=0; i<cols; i++){
    colComps[i] = new GraphComponent( i );
    colComps[i].setColType();
  }

  int width = (int)(size().width * (1.0 - MARGINS * 2.0));
  int height = (int)(size().height * (1.0 - MARGINS * 2.0));
  length = Math.min( width / cols, height / rows);

  gridCorner=new Point((size().width - length * cols) / 2,
		       (size().height - length * rows) / 2);

  for(int r=0; r<rows; r++)
    for(int c=0; c<cols; c++)
      cells[r][c] = new GridCell(gridCorner.x + c * length,
				 gridCorner.y + r * length,
				 length, r, c );
  this.rows = rows;
  this.cols = cols;
  gridExist = true;
  repaint();
}

public GraphComponent calculateComponentOLD(){
  GraphComponent[] comp=new GraphComponent[cols];
  for(int c=0; c<cols; c++) {
    comp[c]=new GraphComponent(colComps[c]);
  }
  for(int r=0; r<rows; r++) {   // finds individual components
    Vector v=rowComps[r].getCells();
    if(!v.isEmpty()) {
      GridCell c=(GridCell)(v.firstElement());
      for(Enumeration e=rowComps[r].getCells().elements(); e.hasMoreElements(); ) {

	GridCell cell= (GridCell)(e.nextElement());

	int firstElementID = comp[c.colIndex].ID;
	int currentCellID = comp[cell.colIndex].ID;

	comp[c.colIndex].merge(comp[cell.colIndex]);

	int greatID = Math.max(firstElementID, currentCellID  );

	for(int j=0; j<cols; j++)
	  if(comp[j].ID == greatID)
	    if( firstElementID < currentCellID )
	      comp[j] = comp[c.colIndex];
	    else
	      comp[j] = comp[cell.colIndex];
      }
    }
  }
  for(int i=0;i<cols;i++)
    if ( !comp[i].getCells().isEmpty()) {
      return comp[i];
    }
  return null;
}
  //***************************************************************//
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
public void  calculateComponent(){

  /// .... initialize for the Depth First Search .... /////

  for(int c=0; c<cols; c++) {
    colComps[c].color=WHITE;
    colComps[c].rigid=false;
    colComps[c].rotation=null;
  }
  for(int r=0; r<rows; r++) {
    rowComps[r].color=WHITE;
    rowComps[r].rigid=false;
    rowComps[r].rotation=null;
  }

  strongConnComp= new GraphComponent[cols+rows];
  finish= new GraphComponent[cols+rows];
  component=0;
  visits=0;

  /// do Depth First Search
  for(int c=0; c<cols; c++)
    if (colComps[c].color==WHITE) {
      visits=0;
      DFSforward(colComps[c]);
      findStrCCs();
    }
  for(int r=0; r<rows; r++)
    if (rowComps[r].color==WHITE){
      DFSforward(rowComps[r]);
      findStrCCs();
    }
} //calculateComponent()



public void  findStrCCs()
  {
    /// .... initialize for the Depth First Search .... /////
    for(int i=0; i<visits; i++) {
      finish[i].color=WHITE;
    }

    for(int i=visits-1;i>=0;i--) {
      if (finish[i].color==WHITE) {
	sccvisits=0;
	//System.out.println("-bc--------->"+(1+finish[i].ID)+finish[i].colType() );
	DFSbackward(finish[i]);
	if (sccvisits > 1) {
	  //  System.out.println("OLAY");
	  Rotate rot=new Rotate(UNDEFINED);
	  rot.id=component++;
	  for (int a=0;a<sccvisits;a++) {
	    strongConnComp[a].rigid=true;
	    strongConnComp[a].rotation=rot;
	  }
	}
      }
    }
    if (sccvisits==rows+cols)
      rigid=true;
    else   rigid=false;
  }
public void DFSforward(GraphComponent gc)
  {
    gc.color=GRAY;
    Vector v=gc.getCells();
    for(Enumeration e=v.elements(); e.hasMoreElements(); ) {
      GridCell cell= (GridCell)(e.nextElement());
      if (gc.rowType() && cell.rightBrace() && colComps[cell.colIndex].color==WHITE )
	DFSforward(colComps[cell.colIndex]);
      else if (gc.colType() && cell.leftBrace() && rowComps[cell.rowIndex].color==WHITE )
	DFSforward(rowComps[cell.rowIndex]);
    }
    gc.color=BLACK;
    gc.cmpcolor=GRAY;
    finish[visits]=gc;
    visits++;
  }

public void DFSbackward(GraphComponent gc)
  {
    gc.color=GRAY;
    Vector v=gc.getCells();
    for(Enumeration e=v.elements(); e.hasMoreElements(); ) {
      GridCell cell= (GridCell)(e.nextElement());
      if (gc.rowType()&&cell.leftBrace() && colComps[cell.colIndex].color==WHITE&& colComps[cell.colIndex].cmpcolor==GRAY )
	DFSbackward(colComps[cell.colIndex]);
      else if (gc.colType() && cell.rightBrace() && rowComps[cell.rowIndex].color==WHITE && rowComps[cell.rowIndex].cmpcolor==GRAY )
	DFSbackward(rowComps[cell.rowIndex]);
    }
    gc.color=BLACK;
    gc.cmpcolor=BLACK;
    strongConnComp[sccvisits]=gc;
    sccvisits++;
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  // assume only strong conn. comp  are checked ,i.e., coming in the parameter
public void   find_pzf_ngf(GraphComponent gc)
  {
    //if (gc.rotation==null) {
    //  Rotate rt=new Rotate(UNDEFINED);
    //  gc.rotation=rt;
    //}

    Vector v=gc.getCells();
    for(Enumeration e=v.elements(); e.hasMoreElements(); ) {
      GridCell cell= (GridCell)(e.nextElement());

      if ( gc.rotation.negatif&&gc.rotation.pozitif)   /// break the loop
	return;
      
      if (rowComps[cell.rowIndex].rotation!=gc.rotation) {
	if (cell.leftBrace() )
	  gc.rotation.negatif=true;
	else
	  gc.rotation.pozitif=true;
      }
      else if (colComps[cell.colIndex].rotation!=gc.rotation){
	if (cell.leftBrace() )
	  gc.rotation.pozitif=true;
	else
	  gc.rotation.negatif=true;
      }
    }
  }

public void   pzf_2_my_followers(GraphComponent gc)
  {
    gc.color=CYAN;
    if (gc.rotation==null) {
      Rotate rt=new Rotate(UNDEFINED);
      gc.rotation=rt;
    }
    gc.rotation.pozitif=true;   // THINK ABOUT LATER
    gc.rotation.negatif=false;   // THINK ABOUT LATER

    Vector v=gc.getCells();
    for(Enumeration e=v.elements(); e.hasMoreElements(); ) {
      GridCell cell= (GridCell)(e.nextElement());
      if (gc.rowType() && cell.rightBrace() && colComps[cell.colIndex].color!=CYAN )
	pzf_2_my_followers(colComps[cell.colIndex]);
      else if (gc.colType() && cell.leftBrace() && rowComps[cell.rowIndex].color!=CYAN )
	pzf_2_my_followers(rowComps[cell.rowIndex]);
    }
  }
public void   find_simple_pzf_ngf(GraphComponent gc)
  {
    if (gc.rotation==null) {
      Rotate rt=new Rotate(UNDEFINED);
      gc.rotation=rt;
    }

    Vector v=gc.getCells();
    for(Enumeration e=v.elements(); e.hasMoreElements(); ) {
      GridCell cell= (GridCell)(e.nextElement());

      if ( gc.rotation.negatif&&gc.rotation.pozitif)   /// break the loop
	return;
      if ( gc.colType() ) {
	if (cell.leftBrace() )
	  gc.rotation.negatif=true;
	else
	  gc.rotation.pozitif=true;
      }
      else {
	if (cell.leftBrace() )
	  gc.rotation.pozitif=true;
	else
	  gc.rotation.negatif=true;
      }
	
      
    }
  }

public void  calculateDirections(){
  boolean alternated=true;

  for(int c=0; c<cols; c++) {
    if (!colComps[c].rigid )
      find_simple_pzf_ngf(colComps[c]);
  }
  for(int r=0; r<rows; r++) {
    if (!rowComps[r].rigid )
      find_simple_pzf_ngf(rowComps[r]);
  }

  // **********
  for(int r=0; r<rows; r++) {
    if (rowComps[r].rigid &&  !(rowComps[r].rotation.pozitif && rowComps[r].rotation.negatif)) {
      find_pzf_ngf(rowComps[r]);
      ///System.out.println(rowComps[r].rotation.pozitif+"   "+rowComps[r].rotation.negatif);
      
    }
  }
  for(int c=0; c<cols; c++) {
    if (colComps[c].rigid && ! (colComps[c].rotation.pozitif && colComps[c].rotation.negatif)) {
      find_pzf_ngf(colComps[c]);
    }
    ///System.out.println(colComps[c].rotation.pozitif+" + -  "+colComps[c].rotation.negatif);
    
  }
  

  for(int c=0; c<cols; c++) {   
    if (colComps[c].rigid &&!colComps[c].rotation.pozitif && !colComps[c].rotation.negatif) {
      colComps[c].rotation.pozitif=alternated;
      colComps[c].rotation.negatif=!alternated;
      alternated=!alternated;
    }
    ///    System.out.println("--->"+colComps[c].rotation.pozitif+" + -  "+colComps[c].rotation.negatif);
  }

  // **********
  for(int c=0; c<cols; c++) {
     if (colComps[c].rigid &&colComps[c].rotation.pozitif && colComps[c].rotation.negatif)
   {    pzf_2_my_followers(colComps[c]);
     colComps[c].rotation.negatif=false;
   }
  }
   for(int r=0; r<rows; r++) {
     if (rowComps[r].rigid && rowComps[r].rotation.pozitif && rowComps[r].rotation.negatif)
    {   pzf_2_my_followers(rowComps[r]);
     rowComps[r].rotation.negatif=false;
    }
  }
/*
  for(int c=0; c<cols; c++) {
    if (colComps[c].rotation.pozitif && colComps[c].rotation.negatif)
      System.out.println("col +-"+(c+1));
  }
  for(int r=0; r<rows; r++) {
    if ( rowComps[r].rotation.pozitif && rowComps[r].rotation.negatif)
      System.out.println("row +-"+(r+1));
  }
*/
}


public void check(){
  if ( !gridExist ) {
    statusLine.setText("Check :    Please define the grid first!");
    return;
  }
  displayMode=GRID;
  calculateComponent();
  calculateDirections();

  Graphics g=getGraphics();
  for(int k=0; k<5; k++) {
    animate(k*3);
    paint(g);
    //    try {
    //Thread.sleep(200);
    //    }
    //  catch(InterruptedException e) {};
  }
  g.dispose();

  // check the rigidity
  if (rigid)
    statusLine.setText("RIGID");
  else statusLine.setText("NOT rigid");
}


public int getMyDirection(GraphComponent gc,int defaultd) {
  if (gc.rotation==null)
    System.out.println("BIG MISTAKE");
  else if (gc.rotation.pozitif&&gc.rotation.negatif)
     return 0;
  else if (!gc.rotation.pozitif&&!gc.rotation.negatif)
    return defaultd; 
  else if (gc.rotation.pozitif)
    return -1;
  else if (gc.rotation.negatif)
    return 1;
  return 0;
}


public void animate(int angle){
  int direction=-1;

  cells[0][0].updateAngle(angle);
  cells[0][0].place(gridCorner);

  direction=getMyDirection(colComps[0],direction*-1);
  if (   direction !=0  )
    cells[0][0].rotateTop(null,direction);
  direction=getMyDirection(rowComps[0],direction*-1);
  if (   direction !=0  )
    cells[0][0].rotateLeft(null,direction);


  for(int i=1; i<cols; i++) {
    direction=getMyDirection(colComps[i],direction*-1);
    if (   direction !=0  )
      cells[0][i].rotateTop(cells[0][i-1],direction);
    else cells[0][i].translateTop(cells[0][i-1]);
  }

  for(int i=1; i<rows; i++){
    direction=getMyDirection(rowComps[i],direction*-1);
    if (  direction !=0   )
      cells[i][0].rotateLeft(cells[i-1][0],direction);
    else cells[i][0].translateLeft(cells[i-1][0]);
  }

  GridCell below, corner, right;
  for(int m=0; m<rows; m++)
    for(int n=0; n<cols; n++) {
      if( m < rows-1) below=cells[m+1][n];
      else  below=null;

      if( n < cols-1) right=cells[m][n+1];
      else  right=null;

      if ( below==null || right == null ) corner = null;
      else corner=cells[m+1][n+1];

      cells[m][n].finish(below,right,corner);
    }
  cells[0][0].findShifting(size().height/2,rows*cols);
  for(int m=0; m<rows; m++)
    for(int n=0; n<cols; n++)
      cells[m][n].shift();
}

  //*********************************************************************//

public void back()
  {  	if ( !gridExist ) {
    statusLine.setText("Back :   Please define the grid first!");
    return;
  }
  displayMode=GRID;
  Graphics g=getGraphics();
  for(int k=4; k>-1; k--) {
    animate(k*3);
    paint(g);
    //    try {
    //Thread.sleep(200);
    //    }
    //  catch(InterruptedException e) {};
  }
  g.dispose();
  }


public boolean mouseDown(Event evt, int x, int y) {
  if ( !gridExist || displayMode==GRAPH)
    return true;
  //x -= gridCorner.x;
  //y -= gridCorner.y;
  //if(x<(gridCorner.x+length*cols) && y<(gridCorner.y+length*rows)
  //   && x>gridCorner.x && y>gridCorner.y ) {
  int i,c=-1; //= x / length;
  int j,r=-1;//= y / length;

  for (i=0;i<rows;i++)
    for (j=0;j<cols;j++)
      if ( cells[i][j].myframe().inside(x,y)) {
	r=i;
	c=j;
	break;
      }
  if ( r==-1 ) return true;

  cells[r][c].toggleRigid(cellMode);
  Graphics g=getGraphics();
  cells[r][c].paint(g);
  g.dispose();

  if(cells[r][c].rigid) {
    rowComps[r].addCell(cells[r][c]);
    colComps[c].addCell(cells[r][c]);

  } else {
    rowComps[r].removeCell(cells[r][c]);
    colComps[c].removeCell(cells[r][c]);
  }

  return true;
}
public void graph()    {
  displayMode=GRAPH;
  calculateComponent();
  repaint();
  repaint();
}
public void plotGraph(Graphics g)
  {
    int [] tx=new int[3];
    int [] ty=new int[3];


    int colonsY = (int)(size().height * ( MARGINS ));
    int rowsY = (int)(size().height * (1.0 - MARGINS ));
    int stepY = (int)(size().height * ( .08 ));
    int stepX = (int)(size().width * ( .05 ));
    int X = (int)(size().width/2);
    if ( rows > cols )  X -=stepX*rows/2;
    else X -=stepX*cols/2;
    double SIN=0.42261826, COS=0.90630779;


    for (int i=0;i<rows;i++)
      for (int j=0;j<cols;j++)
	if ( rowComps[i].getCells().contains( cells[i][j] ) &&
	     colComps[j].getCells().contains( cells[i][j] ) )  {
	  if ( rowComps[i].rigid&&colComps[j].rigid)
	    g.setColor(Color.red);
	  else g.setColor(Color.black);
	  int x1=X+i*stepX+8,  y1=rowsY-3*stepY+8;
	  int x2=X + j*stepX+8, y2=colonsY+2*stepY+8;
	  double alfa=-Math.atan( (double)(x2-x1)/(double)(y2-y1));

	  if (cells[i][j].rightBrace() )
	    {
	      tx[0]=x2;
	      ty[0]=y2;
	      tx[1]=(int) (x2- 15*Math.sin(alfa-0.230)+1);
	      ty[1]=(int) (y2+15*Math.cos(alfa-0.230));
	      tx[2]=(int) (x2- 15*Math.sin(alfa+0.230));
	      ty[2]=(int) (y2+15*Math.cos(alfa+0.230));
	      g.fillPolygon(tx,ty,3);
	    }
	  if (cells[i][j].leftBrace() )
	    {
	      tx[0]=x1;
	      ty[0]=y1;
	      tx[1]=(int) (x1+ 15*Math.sin(alfa-0.230)+1);
	      ty[1]=(int) (y1-15*Math.cos(alfa-0.230));
	      tx[2]=(int) (x1+ 15*Math.sin(alfa+0.230));
	      ty[2]=(int) (y1-15*Math.cos(alfa+0.230));
	      g.fillPolygon(tx,ty,3);
	    }

	  g.drawLine(x1,y1,x2,y2);
	}
    g.setColor(Color.black);
    g.drawString ("COLUMNS",X+stepX*cols/2 -40,colonsY);
    for (int j=0; j < cols ;j++) {
      g.drawString(Integer.toString(j+1),X + j*stepX,colonsY+stepY);
      g.drawImage(ballg,X + j*stepX,colonsY+2*stepY-3,null);
    }

    for (int i=0; i < rows ;i++){
      g.drawString(Integer.toString(i+1),X + i*stepX,rowsY-stepY);
      g.drawImage(ballr,X + i*stepX,rowsY-3*stepY,null);
    }
    g.drawString ("ROWS",X+stepX*rows/2 -15,rowsY);

  }


public void update(Graphics g) {
  paint(g);
}

public void paint(Graphics g) {

  // draw a rectangle inside canvas to separate canvas from buttons.

  
  g.clearRect(6, 6, size().width-6, size().height-6);
  g.setColor(Color.yellow);
  g.fillRect(0,0,size().width-1,4);
  g.fillRect(0,0,4,size().height-1);
  g.fillRect(size().width-4,0,4,size().height-1);
  g.fillRect(0,size().height-4,size().width-1,4);
  g.setColor(Color.black);
  g.drawRect(5,5,size().width-11, size().height-11);
  if(gridExist)
    if ( displayMode == GRID )
      for(int m=0; m<rows; m++)
	for(int n=0; n<cols; n++)
	  cells[m][n].paint(g);
    else if ( displayMode == GRAPH ) plotGraph(g);
  
}
  
} //canvas

/*
  for (int i=0;i<255;i++)
    {
      g.setColor(new Color((int)(Math.random()*100+100)));
      g.drawLine(0,0,300,i);
      g.setColor(new Color((float)Math.random(),(float)Math.random(),(float)Math.random()));
      g.drawLine(600,0,300,i);
    
    }
*/


// canvas ends here
//****************************************************************************
//CELL
//****************************************************************************/
class GridCell {

    public Point topLeft;
    Point topRight, bottomLeft, bottomRight;
    public int rowIndex, colIndex;
    public boolean rigid = false;
    int BRICK=0, LEFT_BRACE=1, RIGHT_BRACE=2;
    public int rigidType = BRICK;

     int length;
     double diagonal;
    static double COS= 0.9961947, SIN = 0.087155743; // cos(5) , sin(5)
    static double angle =0.0;
    static int centery,deltay=0;

    public GridCell(int x, int y, int length, int rowIndex, int colIndex) {

	  topLeft  = new Point(x, y);
	  topRight = new Point(x + length, y);

	  bottomLeft  = new Point(x, y + length);
	  bottomRight = new Point(x + length, y + length);

	  this.length=length;
	  this.diagonal=Math.sqrt(2*length*length);
	  this.rowIndex = rowIndex;
	  this.colIndex = colIndex;
      }
    public void place(Point p)
      {
	  topLeft.x=p.x;
	  topLeft.y=p.y;
	  topRight.x=p.x+length;
	  topRight.y=p.y;
	  bottomLeft.x =p.x;
	  bottomLeft.y =p.y+length;
	  bottomRight.x = p.x+length;
	  bottomRight.y = p.y+length;
	  centery=0;
	  deltay=0;

      }


    public void updateAngle(int angle){
	//if ( angle >= 15.0 )
	//  angle=0.0;
	//angle +=3.0;
	this.angle=angle;

	COS= Math.cos((angle*Math.PI)/180.0);
	SIN= Math.sin((angle*Math.PI)/180.0);
      }

    public void toggleRigid(int type) {
	rigid = !rigid;
	rigidType = type;
      }
    public boolean leftBrace() {
	return rigid&&(LEFT_BRACE==rigidType||BRICK==rigidType);
    }
     public boolean rightBrace() {
	return rigid&&(RIGHT_BRACE==rigidType||BRICK==rigidType);
    }

    public void rotateTop(GridCell neighbor,int direction){
       	if (neighbor!=null) {
	    topLeft.x=neighbor.topRight.x;
	    topLeft.y=neighbor.topRight.y;
	}

	topRight.x =(int)(topLeft.x +(double)length*COS);
	topRight.y =(int)(topLeft.y -(double)length*SIN*direction);
      }
    public void rotateLeft(GridCell neighbor,int direction){
       	if (neighbor!=null) {
	    topLeft.x=neighbor.bottomLeft.x;
	    topLeft.y=neighbor.bottomLeft.y;
	}

	bottomLeft.x = (int) (topLeft.x +(double)length*SIN*direction);
	bottomLeft.y = (int) (topLeft.y +(double)length*COS);
      }
    public void translateTop(GridCell neighbor){
       	if (neighbor!=null) {
	    topLeft.x=neighbor.topRight.x;
	    topLeft.y=neighbor.topRight.y;
	}

	topRight.x =topLeft.x +length;
	topRight.y =topLeft.y;
      }
    public void translateLeft(GridCell neighbor){
       	if (neighbor!=null) {
	   topLeft.x=neighbor.bottomLeft.x;
	   topLeft.y=neighbor.bottomLeft.y;
	}

	bottomLeft.x =topLeft.x ;
	bottomLeft.y =topLeft.y +length;
      }

    public void finish(GridCell below,GridCell right, GridCell corner){
	bottomRight.x= bottomLeft.x + (topRight.x-topLeft.x);
	bottomRight.y= bottomLeft.y + (topRight.y-topLeft.y);

	if ( below != null ) {
	    below.topRight.x = this.bottomRight.x;
	    below.topRight.y = this.bottomRight.y;
	}
	if ( right != null ){
	    right.bottomLeft.x = this.bottomRight.x;
	    right.bottomLeft.y = this.bottomRight.y;
	}

	if ( corner != null ) {
	    corner.topLeft.x= this.bottomRight.x;
	    corner.topLeft.y= this.bottomRight.y;
	}

	centery += bottomRight.y+bottomLeft.y+topRight.y +topLeft.y;


      }
    public void shift(){
	topLeft.y += deltay;
	bottomLeft.y += deltay;
	bottomRight.y += deltay;
	topRight.y += deltay;
    }
    public void findShifting(int originy,int n )  // how many cells
     {
	 centery =centery/( 4*n);
	 deltay=originy-centery;
    }
    public Polygon myframe()
    {
	Polygon frame=new Polygon();
	frame.addPoint(topLeft.x,topLeft.y);
	frame.addPoint(bottomLeft.x,bottomLeft.y);
	frame.addPoint(bottomRight.x,bottomRight.y);
	frame.addPoint(topRight.x,topRight.y);
	frame.addPoint(topLeft.x,topLeft.y);
	return frame;
    }



    public void paint(Graphics g) {
      Polygon frame=myframe();

	if(rigid) {
	  if (rigidType==BRICK) {
	    //g.setColor(Color.red);
	    /// g.fillPolygon(frame);
	    //BrickMe(g);
	    BraceMeFromRight(g);
	    BraceMeFromLeft(g);
	  }
	  else if(rigidType==LEFT_BRACE)
	    BraceMeFromLeft(g);
	  else BraceMeFromRight(g);
	} else {
	  g.setColor(Color.lightGray);
	  g.fillPolygon(frame);
	}
	g.setColor(Color.black);
	g.drawPolygon(frame);
      }
    public void BraceMeFromLeft(Graphics g){
      int[] x=new int[4];
      int[] y=new int[4];
      g.setColor(Color.black);
      g.drawLine(topLeft.x,topLeft.y,bottomRight.x,bottomRight.y);
      double longDiagonal=Math.sqrt( (topLeft.x- bottomRight.x) *  (topLeft.x-bottomRight.x) +
                                   (topLeft.y- bottomRight.y)*(topLeft.y-bottomRight.y));
      double rate=1.0 - (double)(diagonal)*.90/(double)longDiagonal ;
      rate/=2.0;

      if (rate < 0.0) rate=0.0;


      int x1= (int)  (topLeft.x +(-topLeft.x+ bottomRight.x)*rate);
      int y1= (int)  (topLeft.y + (-topLeft.y+ bottomRight.y)*rate);
      int x2= (int)  (bottomRight.x +  ( topLeft.x- bottomRight.x)*rate);
      int y2= (int)  (bottomRight.y +  ( topLeft.y-bottomRight.y)*rate);
      g.setColor(Color.yellow);
      x[0]=x1+2; y[0]=y1;
      x[1]=x2; y[1]=y2-3;
      x[2]=x2-2; y[2]=y2;
      x[3]=x1; y[3]=y1+3;
      g.fillPolygon(x,y,4);
      //      g.drawLine(x1,y1,x2,y2);
//      g.drawLine(x1+1,y1,x2+1,y2);g.drawLine(x1,y1+1,x2,y2+1);

    }
    public void BraceMeFromRight(Graphics g){
	int[] x=new int[4];
	int[] y=new int[4];

	g.setColor(Color.black);
	g.drawLine(topRight.x,topRight.y,bottomLeft.x,bottomLeft.y);

	double longDiagonal=Math.sqrt( (bottomLeft.x- topRight.x) *  (bottomLeft.x-topRight.x) +
                                      (bottomLeft.y- topRight.y)*(bottomLeft.y-topRight.y));
	double rate=1.0 - (double)diagonal*.90/(double)longDiagonal ;
	rate/=2.0;
	if (rate < 0.0) rate=0.0;
	int x1= (int)  (bottomLeft.x +(-bottomLeft.x+ topRight.x)*rate);
	int y1= (int)   (bottomLeft.y + (-bottomLeft.y+ topRight.y)*rate);
	int x2= (int)  (topRight.x +  ( bottomLeft.x- topRight.x)*rate);
	int y2=  (int)  (topRight.y +  ( bottomLeft.y-topRight.y)*rate);
	x[0]=x1+3; y[0]=y1;
	x[1]=x2; y[1]=y2+3;
	x[2]=x2-2; y[2]=y2;
	x[3]=x1; y[3]=y1-2;

	g.setColor(Color.cyan);
	g.fillPolygon(x,y,4);

/*      g.drawLine(x1,y1,x2,y2);
      g.drawLine(x1+1,y1,x2+1,y2);g.drawLine(x1,y1+1,x2,y2+1);
      */
    }
    public void BrickMe(Graphics g){
     
    g.setColor(Color.black);

    Point topMid = new Point((topRight.x+topLeft.x)/2,(topRight.y+topLeft.y)/2);
    Point bottomMid = new Point((bottomRight.x+bottomLeft.x)/2,(bottomRight.y+bottomLeft.y)/2);
    Point leftMid = new Point((topLeft.x+bottomLeft.x)/2,(bottomLeft.y+topLeft.y)/2);
    Point rightMid = new Point((bottomRight.x+topRight.x)/2,(bottomRight.y+topRight.y)/2);
    Point mid =new Point((leftMid.x+rightMid.x)/2, (rightMid.y+leftMid.y)/2);

    Point closeTopLeft = new Point((topLeft.x+leftMid.x)/2,(topLeft.y+leftMid.y)/2);
    Point closeBottomLeft = new Point((leftMid.x+bottomLeft.x)/2,(leftMid.y+bottomLeft.y)/2);
    Point closeTopRight = new Point((topRight.x+rightMid.x)/2,(topRight.y+rightMid.y)/2);
    Point closeBottomRight = new Point((rightMid.x+bottomRight.x)/2,(rightMid.y+bottomRight.y)/2);

    Point closeTopMid = new Point ( (closeTopLeft.x + closeTopRight.x)/2, (closeTopLeft.y + closeTopRight.y)/2);
    Point closeBottomMid= new Point ( (closeBottomLeft.x + closeBottomRight.x)/2, (closeBottomLeft.y + closeBottomRight.y)/2);

    Point closeTopCloseLeft  = new Point( (closeTopLeft.x+closeTopMid.x)/2, (closeTopLeft.y+closeTopMid.y)/2);
    Point closeTopCloseRight = new Point( (closeTopRight.x+closeTopMid.x)/2, (closeTopRight.y+closeTopMid.y)/2);
    Point closeBottomCloseLeft = new Point( (closeBottomLeft.x+closeBottomMid.x)/2, (closeBottomLeft.y+closeBottomMid.y)/2);
    Point closeBottomCloseRight = new Point( (closeBottomRight.x+closeBottomMid.x)/2, (closeBottomRight.y+closeBottomMid.y)/2);

    Point closeLeftMid =new Point ( (leftMid.x+mid.x)/2, (leftMid.y+mid.y)/2);
    Point closeRightMid =new Point ( (rightMid.x+mid.x)/2, (rightMid.y+mid.y)/2);

    Point bottomCloseLeft = new Point ( (bottomLeft.x+bottomMid.x)/2 , (bottomLeft.y+bottomMid.y)/2);
    Point bottomCloseRight= new Point ( (bottomRight.x+bottomMid.x)/2 , (bottomRight.y+bottomMid.y)/2);

    g.drawLine ( closeTopLeft.x,closeTopLeft.y,closeTopRight.x,closeTopRight.y);
    g.drawLine ( closeBottomLeft.x,closeBottomLeft.y,closeBottomRight.x,closeBottomRight.y );
    g.drawLine ( leftMid.x,leftMid.y,rightMid.x,rightMid.y);

    g.drawLine ( topMid.x,topMid.y,closeTopMid.x,closeTopMid.y );

    g.drawLine ( closeTopCloseLeft.x,closeTopCloseLeft.y,closeLeftMid.x,closeLeftMid.y );
    g.drawLine ( closeTopCloseRight.x,closeTopCloseRight.y,closeRightMid.x,closeRightMid.y );

    g.drawLine ( mid.x,mid.y,closeBottomMid.x,closeBottomMid.y);

    g.drawLine ( bottomCloseLeft.x,bottomCloseLeft.y,closeBottomCloseLeft.x,closeBottomCloseLeft.y );
    g.drawLine ( bottomCloseRight.x,bottomCloseRight.y,closeBottomCloseRight.x,closeBottomCloseRight.y );

  }
} // cell ends here
  class Rotate
  {
    int id;

    int direction;
    boolean pozitif;
    boolean negatif;

    Rotate(int dir)
    {
      direction=dir;
      pozitif=false;
      negatif=false;
      
    }
  }

//****************************************************************************
// COMPONENT
//****************************************************************************
class GraphComponent {
    int color;
  int cmpcolor;

    int type=0;
    boolean rigid=false;
    Vector cells;
    public int ID;
    Rotate  rotation;

    public GraphComponent(int ID) {
	this.ID = ID;
	cells = new Vector();
      }

    public GraphComponent(GraphComponent gc) {
	this.ID = gc.ID;
	cells = new Vector();
	for(Enumeration e=gc.getCells().elements(); e.hasMoreElements(); )
	          addCell((GridCell)(e.nextElement()));
      }

    public void addCell(GridCell cell) {
	cells.addElement(cell);
      }

    public void removeCell(GridCell cell) {
	cells.removeElement(cell);
      }

    public Vector getCells() {
	return cells;
      }

    public void listCells() {
	for(Enumeration e=cells.elements(); e.hasMoreElements(); ) {
	    GridCell cell=(GridCell)(e.nextElement());
	    System.out.print("("+cell.rowIndex + "," + cell.colIndex + ")");
	  }
	System.out.println(" ");
      }

    public void merge(GraphComponent comp) {
	if(comp.ID == this.ID) return;
	if(comp.ID < this.ID) comp.merge(this);
	else for(Enumeration e=comp.getCells().elements(); e.hasMoreElements(); )
	          addCell((GridCell)(e.nextElement()));
      }
    public void print(String s) {
	System.out.println(s);

      for(Enumeration e=getCells().elements(); e.hasMoreElements(); ){
	GridCell cell =(GridCell)(e.nextElement());
	int r=cell.rowIndex+1;
	int c=cell.colIndex+1 ;
	if(cell.leftBrace())
	  System.out.println(c + " --> " + r);
	else if (cell.rightBrace())
	  System.out.println(c + " <-- " + r);
	  else System.out.println("ERROR");

      }
    }
   public void setRowType() {type=0;   }
   public void setColType() {type=1;   }
   public boolean colType() {return type==1;}
   public boolean rowType() {return type==0;}
  }
//****************************************************************************
// selection buttons
//****************************************************************************

class choiceCanvas extends Canvas
{
    GridCell[] cells;
    boolean[] selection;
    GridCanvas canvas;
    int length;
    choiceCanvas(GridCanvas canvas)
    {
	cells=new GridCell[3];
        selection=new boolean[3];
	this.canvas=canvas;
    }
    public void showUp()
    {
	int width = size().width ;
	int height = size().height ;

//	height=width=20;
	length = Math.min( width, height);
	//System.out.println(width + " showup  "+height);


	for(int n=0; n<3; n++) {
	    cells[n] = new GridCell(n * length,
				    0 ,
				    length, 0, n );
	    cells[n].toggleRigid(n);
	    selection[n]=false;
	}
	selection[0]=true;
	canvas.setCellMode(0);
	repaint();
    }


    public void update(Graphics g) {
	paint(g);
      }

    public void paint(Graphics g) {
	g.clearRect(0,0,size().width,size().height);
  

	for(int n=0; n<3; n++) {
	    cells[n].paint(g);
	    //if(selection[n]) {
		g.setColor(Color.white);
		g.draw3DRect(cells[n].topLeft.x+2,cells[n].topLeft.y+2,
			     length-4,length-4,!selection[n]);
		g.draw3DRect(cells[n].topLeft.x+1,cells[n].topLeft.y+1,
			     length-2,length-2,!selection[n]);
	    // }


	}
    }

    public boolean mouseDown(Event evt, int x, int y) {
	for (int j=0;j<3;j++)
	    if ( cells[j].myframe().inside(x,y)) {
		selection[j]=true;
		canvas.setCellMode(j);
	    }  else selection[j]=false;
	Graphics g=getGraphics();
	paint(g);
	g.dispose();
	return true;
    }
}

