/* create some radio buttons */

import java.awt.*;

public class CheckboxGroupTest extends java.applet.Applet {

  private Label label;
  private int n = 6;  // number of radio buttons
  private Checkbox[] radioButton = new Checkbox[n];
  private CheckboxGroup radioButtons = new CheckboxGroup();
  
  public void init() {
    setBackground(Color.white);

    String[] colorLabel = new String[n];
    colorLabel[0] = "Red";    colorLabel[1] = "Blue";
    colorLabel[2] = "Yellow"; colorLabel[3] = "Green";
    colorLabel[4] = "Orange"; colorLabel[5] = "Purple";
    
    Panel radioButtonPanel = new Panel();
    for ( int i = 0; i < n; i++ ) {
      radioButton[i] = new Checkbox(colorLabel[i], radioButtons, false);
      radioButton[i].setBackground(Color.white);
      radioButtonPanel.add(radioButton[i]);
    }
    radioButtons.setCurrent(radioButton[0]);
    
    setLayout(new GridLayout(2,1,5,5));
    add(radioButtonPanel);
    label = new Label("", Label.LEFT);
    label.setBackground(Color.white);
    add(label);
  }

  public boolean action(Event event, Object arg) {
    if ( event.target instanceof Checkbox ) {
      updateLabel();
      return true;
    }
    return super.action(event, arg);
  }
  
  public void updateLabel() {
    int i = 0;
    while ( !radioButton[i].getState() && i < n ) i++;
    String str = "   You chose color ";
    str += radioButton[i].getLabel() + "!";
    label.setText(str);
  }
  
}
