/* create a scrolling list */

import java.awt.*;

public class ListTest extends java.applet.Applet {

  private Label label;
  // Allow five visible items in the list and 
  // disallow multiple selections:
  private List list = new List(5, false);

  public void init() {
    setBackground(Color.white);

    list.addItem("Hamlet");
    list.addItem("Claudius");
    list.addItem("Gertrude");
    list.addItem("Polonius");
    list.addItem("Horatio");
    list.addItem("Laertes");
    list.addItem("Ophelia");
    list.addItem("Caesar");
    list.addItem("Brutus");
    list.addItem("Alexandrius");
    list.setBackground(Color.white);
    
    setLayout(new BorderLayout(100,40));
    add("Center", list);
    label = new Label("", Label.CENTER);
    label.setBackground(Color.white);
    add("South", label);
    // Add blank labels for spacing:
    add("North", new Label(""));
    add("East", new Label(""));
    add("West", new Label(""));
  }
  
  // Double-clicking an item triggers an action event:
  public boolean action(Event event, Object arg) {
    if ( event.target instanceof List ) {
      // Handling List event:
      if ( event.target == list ) {
        String s = "You chose ";
        s += list.getSelectedItem() + "!";
        label.setText(s);
      } else {
        return super.action(event, arg);
      }
      return true;
    }
    return super.action(event, arg);
  }

}
