/*
 *  File:  RectangleTest.java
 *
 *  Rotate a rectangle
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class RectangleTest extends Applet {

   // constant number of rotations:
   private final int N = 8;
   
   // rotation angle:
   private final double angle = 2 * Math.PI/N;
      
   // create an array of rectangles:
   private Rectangle rectangle[] = new Rectangle[ N ];
   
   public void init() {
   
      // top left-hand corner of the rectangle:
      int x = 100, y = 100;
      // width and height of the rectangle:
      int w =  75, h =  50;
      
      // initialize rectangle array:
      double theta = 0;
      for ( int i = 0; i < N; i++ ) {
         theta += angle;
         rectangle[i] = new Rectangle( x, y, w, h, theta );
      }

   }
   
   public void paint( Graphics g ) {

      g.setColor( Color.red );

      // draw the rectangles:
      for ( int i = 0; i < N; i++ ) {
         rectangle[i].draw( g );
      }

   }
   
}
