/*
 *  File:  RhombusTest.java
 *
 *  Draw a rhombus
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class RhombusTest extends Applet {

   // create a reference to a rhombus:
   private Rhombus rhombus;
   
   // rhombus parameters:
   private final int length = 20;
   private final double alpha = 3 * Math.PI/5;
   private int d, h;
   
   public void init() {
   
      // the displacement from the vertical:
      d = ( int ) Math.round( length * Math.cos( Math.PI - alpha ) );
      // the height of the rhombus:
      h = ( int ) Math.round( length * Math.sin( Math.PI - alpha ) );
      
   }

   public void paint( Graphics g ) {

      // local variables:
      int x, y;
      int xoffset = ( d < 0 ) ? 0: 8*d; 
      
      g.setColor( Color.magenta );

      // draw a checkerboard of rhombi:
      y = 0;
      for ( int i = 0; i < 8; i++ ) {
         x = xoffset + i * (-d); y += h;
         for ( int j = 0; j < 8; j++ ) {
            x += length;
            rhombus = new Rhombus( x, y, length, alpha );
            rhombus.draw( g );
         }
      }

   }
   
}
