//
// PixelGrabber Example
//
// by Ozgur Balsoy 
// November 20, 1996
//
// Reference: Sun On-line documentation.
// 		http://www.npac.syr.edu/projects/tutorials/Java/
//				Sun/api/java.awt.image.PixelGrabber.html
//

import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.util.*;

public class grabber extends Applet {
    private TextField tf;
    private TextArea ta;
    private Label status;
    private Canvas drawarea;
    private Image img=null;
    int ppmline=0;

    public void init() {

	setLayout(new GridLayout(1,2));
	
	Panel left=new Panel();
        left.setLayout(new BorderLayout());

        Panel topleft = new Panel();
        topleft.setLayout(new GridLayout(1, 4));

        topleft.add(tf=new TextField());

	Panel buttonsP = new Panel();
        buttonsP.add(new Button("Load GIF"));
	buttonsP.add(new Button("PPM Output"));
	topleft.add(buttonsP);

        left.add("North", topleft);

        left.add("Center", drawarea=new Canvas());

	left.add("South", status=new Label());

	add(left);			// left side of the applet.
	add(ta=new TextArea());		// right side.

	status.setText("See GIF files below.");  
    }

    public void paint(Graphics appletg) {
	
	Graphics g=drawarea.getGraphics();
	if (img != null) {
		g.drawImage(img, 0, 0, this);
		g.dispose();
	}
    }

    public boolean action(Event evt, Object arg) {
	String s=(String) arg;

	if(s.equals("Load GIF")) {
		img=getImage(getCodeBase(), tf.getText());
		repaint();
	}
	else if (s.equals("PPM Output")) getPixs();

        return true;
    }

    void getPixs() {
	
	int w=30, h=30;

	// PPM output starts.
	ta.setText("P3\n");
	ta.appendText(Integer.toString(w) + " " + Integer.toString(h) + "\n");
	ta.appendText("255\n");
	handlepixels(img, 0, 0, w, h);
	
    }

public void handlesinglepixel(int x, int y, int pixel) {


	// pixel is in RGB model. It is a 4-byte long integer.
	// It is converted into the string representation of PPM pixels.
	// ie. Hex 0x00102030 becomes "16 32 48"
	String s= Integer.toString((pixel & 0x00FF0000) >> 16) + " "
		+ Integer.toString((pixel & 0x0000FF00) >> 8) + " "
		+ Integer.toString(pixel & 0x000000FF) + " ";
//
// If we use PPM RAW format, then we have to use ascii characters instead.
// 
//
//	char c[]= {(char) ((pixel & 0x00FF0000) >> 16),
//		   (char) ((pixel & 0x0000FF00) >> 8) ,
//		   (char) (pixel & 0x000000FF) };
//	String s=new String(c);

	if (ppmline++>=3) { 			// comment out if you use RAW format.
		ta.appendText(s + "\n"); 	// comment out if you use RAW format. 
		ppmline=0;			// comment out if you use RAW format.
	} else 					// comment out if you use RAW format.
		ta.appendText(s);
}

public void handlepixels(Image img, int x, int y, int w, int h) {
        int[] pixels = new int[w * h];
        PixelGrabber pg = new PixelGrabber(img, x, y, w, h, pixels, 0, w);
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            System.err.println("interrupted waiting for pixels!");
            return;
        }
        if ((pg.status() & ImageObserver.ABORT) != 0) {
            System.err.println("image fetch aborted or errored");
            return;
        }
        for (int j = 0; j < h; j++) {
            for (int i = 0; i < w; i++) {
                handlesinglepixel(x+i, y+j, pixels[j * w + i]);
            }
        }
}	
}



