#! /usr/local/bin/perl
#############################################################################
#  
#   File: pizza2.pl
#
#   Author:  Nancy McCracken
#
#   Input: pizza2.html
#          CGI input ('QUERY_STRING') 
#          QUERY_STRING: Entries = address; 
#                                  phone; 
#                                  topping: pepperoni, sausage, anchovies.
#    				   specialorder: 
#   Output: HTML version of pizza order.
#
#   Description: Creates a pizza order from the information gained from
#                the pizza order form.  
#
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&PrintHeader;
&ReadEntry;
&PrintOrder;


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################


sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form
   $address = $in{'address'};
   $phone = $in{'phone'};
   $topping = $in{'topping'};
   $specialorder = $in{'specialorder'};
   return 1;
}


sub PrintOrder {
  print "Pizza Order \n";
  if ($specialorder eq '')
  { print "$topping pizza\n"; }
  else
  { print "$specialorder\n"; }
 
  print "Deliver to $address \n";
  print "Telephone $phone \n";
  $date = `date`;
  print "Order came in at $date ";
  return 1;
}


##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
  print "\n";
}


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
    }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}


