#! /usr/local/bin/perl
#############################################################################
#  
#   File: pizzaspecials.pl
#
#   Author:  Nancy McCracken
#
#   Input: pizza2.html
#          CGI input ('QUERY_STRING') 
#          QUERY_STRING: Entries = none
#   Output: HTML version of specials
#
#   Files: specials.txt - reads this file (with : separated fields) to
#	list pizza specials
#
#   
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&PrintHeader;
&ReadEntry;
&PrintSpecials;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################


sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form
   $todayspec=$in{'todayspecials'};
   return 1;
}


sub PrintSpecials
{
#  print "Pizza Specials Today ";
#  print "\n";
  open (SP, "specials.txt") || die "can't open specials file";
  while ($record = <SP>)
   {
    ($spname,$spprice,$sptime,$spdesc)=split(/:/,$record);
    print "$spname, $spprice, $spdesc \n";
   }
   if ($todayspec eq "Yes") {   	
	print "Today's specials are \n";   
	open (TSP, "Todaysspecials.txt") || die "can't open specials file";	
	while ($record = <TSP>)
   	{
   	 ($spname,$spprice,$sptime,$spdesc)=split(/:/,$record);
    	 print "$spname, $spprice, $spdesc \n";
   	} 
   }	
  return 1;
}

##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
#  print "\n";
}


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
    }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}






