#! /usr/local/bin/perl
#############################################################################
#  
#   File: pizzatime.pl
#
#   Author:  Nancy McCracken
#
#   Input: pizza2.html
#          CGI input ('QUERY_STRING') 
#          QUERY_STRING: Entries = 
#                                  topping: pepperoni, sausage, anchovies.
#    				   
#   Output: HTML version of time to prepare that kind of topping pizza
#
#
#   Other Programs: computetime - calls this compiled C program with 
#	command line input of a topping (string) and gets back the 
#	number of minutes to prepare.
#
#
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&PrintHeader;
&ReadEntry;
&ComputeTime;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################


sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form
   $topping = $in{'topping'};
   return 1;
}


sub ComputeTime
{ 
 # print "Time to Prepare Pizza \n ";

  open (SYS, "computetime $topping|");
  $result = <SYS>;
  print "Your pizza will take $result minutes to prepare";
  printf "\n";
  return 1;
}


##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
  print "\n";
}


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
    }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}


