
package origjava.jdbctest;

import origjava.test.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.Vector;
import java.util.Enumeration;
import java.net.URL;
import java.sql.*;
import java.io.*;
/**
 * DBDisplay: a class for displaying the values in a ResultSet
 */
public class DBDisplay extends Panel 
    {
    private Vector presentationRow = new Vector(); // holds displayObjects
    private ScrollPane sP;                         // contains presentationRow DisplayPanel
    private RjlResultSetMetaData c_rsmd;           // A little extra to ResultSetMetaData
    private ResultSet c_rs;                        // SQL Query Results
    private int c_numCols = 0;                     // ResultSetMetaData.getColumnCount ?needed?
    private int totalRows = 0;                     // number of RJLDatabaseRows in DBDisplay
    private int currentRow = 0;                    // currentRow being dispayed
    private Vector dbRowVector = new Vector();     // conatiner for ResultSet loaded into RJLDatabaseRow Objects
    private Vector deletedDbRows = new Vector();   // container for rows deleted from display
                                                   // but not deleted from relational DB
    private String updateTable = "[Time Cards]";   // Needed if driver does not support
                                                   // getTableName()
    private RjlDatabaseRow deletedRow;             // holder for deleted row
    private RjlDatabaseRow newRow ;                // holder for a "null" newRow (Inserts to display)
    private Connection c_con;                      // holder for Connection Object (needed for SQLprepare)
    private boolean isVisible = true;
    private RJLRuntime runTime = new RJLRuntime(); // utility class

public DBDisplay() {
    }
public void setConnection(Connection theValue) {
    c_con = theValue;
    }
public RjlDatabaseRow getDeletedRow() {
    return deletedRow;
    }
public RjlDatabaseRow getNewRow() {
    return newRow;
    }
public void setDeletedRow(RjlDatabaseRow theValue) {
    deletedRow = theValue;
    }
public void setNewRow(RjlDatabaseRow theValue) {
    newRow = theValue;
    }
public String getTheUpdateTable() {
    return updateTable;
    }
public void setUpdateTable(String theValue) {
    updateTable = theValue;
    }
public int getCurrentRow() {
    return currentRow;
    }
public int getTotalRows() {
    return totalRows;
    }
public Vector getDbRowVector() {
    return dbRowVector;
    }
public Vector getDeletedDbRows() {
    return deletedDbRows;
    }

/**
* getPresentationRow: returns the Vector which holds the ResultSet Display Objects.
*/
public Vector getPresentationRow() {
    return presentationRow;
    }

/**
* setResultSet: initialiazes RJLResultMetaData Object,thePresentationRow
* and caches the ResultSet.
*/

public int setResultSet (ResultSet rs)
{
	int i;

	// Get the ResultSetMetaData.  This will be used for
	// the column headings
 try {
	    RjlResultSetMetaData rsmd = new RjlResultSetMetaData(rs.getMetaData (),true,new Frame("DBDisplay"),runTime.ACTIONTEXT);
        c_rsmd = rsmd;
        c_rs = rs;
	    // Get the number of columns in the result set

	    c_numCols = c_rsmd.getColumnCount ();

	    for (i=1; i<=c_numCols; i++) {
            actionText at =  new actionText(c_rsmd.getColumnLabel(i),c_rsmd.getColumnLabel(i));
            at.setBackground(Color.white);
            at.setForeground(Color.black);
            getPresentationRow().addElement(at);
       	    }
      }
 catch (SQLException e) { runTime.displayExceptionMessage(e,isVisible,new Frame("DBDisplay.setResultSet")); }

    return cacheResults(rs);
	
   }
/**
* cacheResult : stores ResultSet in RjlDatabaseRow and stores in dbRowVector
*/

private int cacheResults(ResultSet rs)
{
    if (rs == null) return 0;
    currentRow = -1;
    totalRows = 0;

    try 
    {
        //boolean flag = rs.next();
        //totalRows = flag ? 0 : 0;//-1;
        //for (; flag; flag = rs.next())
        //boolean flag = true;
		while (rs.next())
        {
            totalRows++;
            RjlDatabaseRow rjlDatabaseRow = new RjlDatabaseRow(c_rsmd, rs,c_con,
                updateTable);
            dbRowVector.addElement(rjlDatabaseRow);
        }
    }
    catch (SQLException e) { runTime.displayExceptionMessage(e,isVisible,new Frame("DBDisplay.cacheResult")); }

    System.out.println("totalRows : " + totalRows);
    //if (totalRows < 0) return 0;
    dbRowVector.setSize(totalRows);
    return totalRows;
    
}

/**
* setDeleted : creates deletedRow object and deletes from dbRowVector and adds to deletedDbRows
*/

public void setDeleted(int current ) 
{
int former = 0 ;
if (current >= 0 && current < dbRowVector.size()) 
     {
      deletedRow = null;
          try {
               deletedRow = (RjlDatabaseRow) dbRowVector.elementAt(current);
              }
          catch (Exception ex) {
              System.out.println("setDeleted :dbRowVector.elementAt exception");
              }
     }
 deletedRow.setEditState(RjlDatabaseRow.ScreenDeleted);
 if (deletedRow != null) {
     try {dbRowVector.removeElementAt(current);
          totalRows--;
          dbRowVector.setSize(totalRows);
          deletedDbRows.addElement(deletedRow);
         }
     catch (ArrayIndexOutOfBoundsException aex) { System.out.println("arrayIndexOut of Bounds exception");}
     }
 if (current >= 0 && current < dbRowVector.size()) 
     {
      removeTextListeners( deletedRow) ;
      displayRow(current,former);
     }
}

/**
* insertNewRow : creates new null RjlDatabaseRow based on c_rsmd, c_con, updateTable
* and inserts into dbRowVector
*/

public void insertNewRow(int current ) 
{
int former = current + 1; // dbRowVector current occupant of this inserts 
                          // soon to be location
if (current >= 0 && current < dbRowVector.size()) 
     {
     try {
      newRow = new RjlDatabaseRow(c_rsmd,null,c_con,updateTable);
         }
     catch (SQLException e) 
         { runTime.displayExceptionMessage(e,isVisible,new Frame("DBDisplay.insertNewRow")); }
      if (newRow != null ) {
          try {
               dbRowVector.insertElementAt(newRow,current);
               totalRows++;
               dbRowVector.setSize(totalRows);
              }
          catch (Exception ex) {
               System.out.println("dbRowVector.insert exception");
              }
          }
      else { return ;}
     }
 newRow.setEditState(RjlDatabaseRow.ScreenInserted);
 if (former >= 0 && former < dbRowVector.size()) 
     {
      displayRow(current,former);
     }
}
/**
* doSQLAction : executes Delete,Insert or Update With Database
*/

 public void doSQLAction() 
     {
      RjlDatabaseRow rjlRow = (RjlDatabaseRow) dbRowVector.elementAt(currentRow);        
      rjlRow.buildSQL();
      if (deletedDbRows.size() > 0)
          {
          for (int j = 0; j < deletedDbRows.size(); j++)
              {

              RjlDatabaseRow theRow = (RjlDatabaseRow) deletedDbRows.elementAt(j);        
              if (theRow != null ) {
                  if ( theRow.getSqlState() == RjlDatabaseRow.pending) {
                      theRow.doSQLUpdate();
                      }
                  }
              }
          }
      for (int j = 0; j < dbRowVector.size(); j++)
          {

          RjlDatabaseRow theRow = (RjlDatabaseRow) dbRowVector.elementAt(j);        
          if (theRow != null ) {
              if ( theRow.getSqlState() == RjlDatabaseRow.pending) {
                  theRow.doSQLUpdate();
                  }
              }
          }

     }

public void doLast()
{   
         int oldRow = currentRow;
		 currentRow = dbRowVector.size() -1;	
		 displayRow(currentRow,oldRow ) ;
}     

public void doFirst()
{   
         int oldRow = currentRow;
		 currentRow = 0 ;	
		 displayRow(currentRow,oldRow ) ;
}     

public void doNext()
{   
     if ( currentRow  < dbRowVector.size() -1  ){ 
		  currentRow++;	
	      displayRow(currentRow,currentRow - 1 ) ;
     }
}     
public void doInsert()
{       		
     if ( currentRow  < dbRowVector.size() -1  ){ 
		  insertNewRow(currentRow) ;
     }
}     
public void doDelete()
{       		
     if ( currentRow  < dbRowVector.size() -1  ){ 
		  setDeleted(currentRow) ;
     }
}     
public void doPrev()
{     
     if ( currentRow > 0 ){ 
          currentRow--;
		  displayRow(currentRow,currentRow + 1 ) ;
     }
}
/**
* displayRow: displays dbRowVector values to DisplayPanel Objects
*/

public void displayRow(int current , int former) 
    {
        RjlDatabaseRow rjlRow = null;
        RjlDatabaseRow rjlRow1 = null;
        if (current >= 0 && current < dbRowVector.size()) 
             {
              rjlRow = (RjlDatabaseRow) dbRowVector.elementAt(current);
             }
     
         if (former >= 0 && former < dbRowVector.size()) 
             {
              rjlRow1 = (RjlDatabaseRow) dbRowVector.elementAt(former);
             }
         if (rjlRow == null ) return ;
         if (rjlRow1 != null ) {
             removeTextListeners( rjlRow1) ;
             }

         for (int i=1; i<= c_numCols; i++) 
             {
              actionText at = (actionText) getPresentationRow().elementAt(i-1) ;
              RjlDatabaseColumn rjlColumn = rjlRow.getColumn(i-1);
              if ( rjlColumn != null) 
                 {
                     String l_string = rjlColumn.getOriginalString();
                     if ( l_string != null ) 
                         {
                          at.tf.setText(l_string);
                         }
                     else
                         {
                          at.tf.setText("null");
                         }
                 }
		     }
         addTextListeners(rjlRow) ;
    }
/**
* removeTextListeners: removes textListeners (editState) from DisplayPanel Objects
*/

public void removeTextListeners(RjlDatabaseRow rjlRow) 
    {
         if (rjlRow == null ) return ;
         for (int i=0; i<= c_numCols -1; i++) 
             {
              actionText at = (actionText) getPresentationRow().elementAt(i) ;
              RjlDatabaseColumn rjlColumn = rjlRow.getColumn(i);
              if ( rjlColumn != null) 
                  {
                   at.tf.removeTextListener(rjlColumn);
                  }
		     }
         rjlRow.buildSQL();
    }
/**
* addTextListeners: adds textListeners (editState) to DisplayPanel Objects
*/

public void addTextListeners(RjlDatabaseRow rjlRow) 
    {
         if (rjlRow == null ) return ;
         for (int i=0; i<= c_numCols -1; i++) 
             {
         	     actionText at = (actionText) getPresentationRow().elementAt(i) ;
                 RjlDatabaseColumn rjlColumn = rjlRow.getColumn(i);
                 if ( rjlColumn != null)
                     {
                      at.tf.addTextListener(rjlColumn);
                     }
     	     }
    }

public ScrollPane buildDBDisplayPanel() {
           Panel vP = new Panel();
           int numRows = (getPresentationRow().size() > 0 ) ? getPresentationRow().size() : 1;
           int numCols = 1;
           if (numRows == 0) numRows = 1;
           GridLayout gl = new GridLayout();
           vP.setLayout(gl);
           gl.setRows(numRows);
           gl.setColumns(numCols);
           gl.setHgap(2);
           gl.setVgap(2);

           for (int j = 0; j < getPresentationRow().size(); j++)
             {
                actionText lb = (actionText) getPresentationRow().elementAt(j);
                vP.add(lb);
             }
           vP.doLayout();
           vP.setSize(vP.getPreferredSize());
           int preferredWidth = vP.getPreferredSize().width;
           int preferredHeight = vP.getPreferredSize().height;
           ScrollPane sP = new ScrollPane();
           sP.add(vP);
           sP.doLayout();
           sP.setSize(preferredWidth + 80,preferredHeight + 40);
           return sP;
    }

}