package origjava.jdbctest;

import origjava.test.*;

import java.sql.*;
import java.lang.*;
import java.awt.TextField;
import java.awt.event.*;


public class RjlDatabaseColumn implements java.awt.event.TextListener ,java.lang.Cloneable
{
    protected boolean changed = false;
    protected Object current;
    protected Object original;
    protected String currentASFormattedString;
    protected String originalASFormattedString;
    protected int scale;
    protected int type;
    protected String tableName;
    protected String columnName;
    protected String databaseName;
    protected String hostName;
    protected String hostIPAddress;
    private Util uT;

    public void setOriginal(Object theDefault) {
        original = theDefault;
        }
    public void setCurrent(Object theDefault) {
        current = theDefault;
        }
    public int getType() {
        return type;
        }
    public void setType(int value) {
        type = value;
        }
    public void setScale(int value) {
        scale = value;
        }

    public void setTableName(String name) {
        tableName = name;
        }
    public String getTableName() {
        return tableName;
        }

    public void setColumnName(String name) {
        columnName = name;
        }

    public String getColumnName() {
        return columnName;
        }

    public void setDatabaseName(String name) {
        databaseName = name;
        }

    public String getDatabaseName() {
        return databaseName;
        }

    public void setHostName(String name) {
        hostName = name;
        }

    public String getHostName() {
        return hostName;
        }
    
    public void setHostIPAddress(String name) {
        hostIPAddress = name;
        }

    public String getHostIPAddress() {
        return hostIPAddress;
        }
    

    public void textValueChanged(TextEvent e) {
        TextField tf = ( (TextField) e.getSource());
        if (tf != null) {
            current = objectFromString(tf.getText(),type,scale);
            }
        }

    public Object getOriginal() {
        return original;
    }
    public String getOriginalString() {
        return originalASFormattedString;
    }
    public String getCurrentString() {
        return currentASFormattedString;
    }

    public Boolean setBooleanProperty()
    {
        Boolean Bool = new Boolean(false);
//        switch (type)
//        {
//        case -1:
//        case 1:
//        case 12:
//            Bool = new Boolean((String)current);
//            break;

//        case 2:
//        case 3:
//            Bool = new Boolean((((java.sql.NUMERIC)current).intValue() == 0) ? 0 : 1);
//            break;

//        case -7:
//            Bool = (Boolean)current;
//            break;

//        case -6:
//        case 4:
//        case 5:
//            Bool = new Boolean((((Integer)current).intValue() == 0) ? 0 : 1);
//            break;

//        case -5:
//            Bool = new Boolean((((Long)current).intValue() == 0) ? 0 : 1);
//            break;

//        case 7:
//            Bool = new Boolean((((NUMERIC)current).intValue() == 0) ? 0 : 1);
//            break;

//        case 6:
//        case 8:
//            Bool = new Boolean((((NUMERIC)current).intValue() == 0) ? 0 : 1);
//            break;

//        default:
//            Bool = null;
//            break;
//        }
        return Bool;
    }

    public static Object objectFromString(String string, int i, int j)
        /** build a java sql.Type.Object from a string
        *@param String
        *@param int Type
        *@param int Scale
        */
     {

        Object object = null;
        if (string == null || string.equals(RJLRuntime.EmptyString))
            return null;
        switch (i)
        {
        case -1://LONGVARCHAR 	=  -1;
        case 1: //	CHAR		=   1;
        case 12://	VARCHAR 	=  12;
            object = string;
            break;

        case -7://	BIT 		=  -7;
            object = Boolean.valueOf(string);
            break;

        case -6://TINYINT 	=  -6;
        case 4://	INTEGER 	=   4;
        case 5: //SMALLINT	=   5;
            object = Integer.valueOf(string);
            break;
   
        case -5://	 BIGINT 		=  -5;
            object = Long.valueOf(string);
            break;

        case 2://	NUMERIC 	=   2;
        case 3: //DECIMAL		=   3;
        case 7://REAL 		=   7;
        case 6://FLOAT 		=   6;
            object = Float.valueOf(string);
            break;

        case 8://DOUBLE 		=   8;
            object = Double.valueOf(string);
            break;

        case 0://NULL		=   0;
            object = null;
            break;

       case 91: //DATE 		=  91;
            object = Date.valueOf(string);
            break;

        case 92://TIME 		=  92;
            object = Time.valueOf(string);
            break;

        case 93://TIMESTAMP 	=  93;
            object = Timestamp.valueOf(string);
            break;

        case -4://LONGVARBINARY 	=  -4;
        case -3://VARBINARY 	=  -3;
        case -2://BINARY		=  -2;
            object = Byte.valueOf(string);
            break;

        default:
            object = string;
            break;
            /**
                 * OTHER indicates that the SQL type is database specific and
                 * gets mapped to a Java object which can be accessed via
                 * getObject and setObject.
                 * public final static int OTHER		= 1111;
                 */
	
        }
        return object;
    }

    public RjlDatabaseColumn(Object object, int i, int j,String cName, String tabName)
    {
        uT.setVerbose(true);
        changed = false;
        original = object;
        current = object;
        type = i;
        scale = j;
        columnName = cName;
        tableName = tabName;

        originalASFormattedString = ( original != null ? getStringProperty(original) : RJLRuntime.EmptyString);
        currentASFormattedString = ( current != null ? getStringProperty(current) : RJLRuntime.EmptyString);

    }

    public RjlDatabaseColumn(Object object, int i, int j,
                             String dbName,String hName,String tabName,String cName,String hostIP)
    {
        this(object,i,j,cName,tabName);
        databaseName = dbName;
        hostName = hName;
        hostIPAddress = hostIP;
    }

    public static Object objectFromBoolean(Boolean Bool, int i, int j)
    {
        Object object = null;
        switch (i)
        {
        case -1:
        case 1:
        case 12:
            object = Bool.toString();
            break;

        case 2:
        case 3:
            boolean flag = Bool.booleanValue();
            //object = new Numeric(flag, j);
            break;

        case -7:
            object = Bool;
            break;

        case -6:
        case 4:
        case 5:
            object = new Integer(Bool.booleanValue() ? 1 : 0);
            break;

        case -5:
            object = new Long((long)(Bool.booleanValue() ? 1 : 0));
            break;

        case 7:
            object = new Float(Bool.booleanValue() ? 1.0 : 0.0);
            break;

        case 6:
        case 8:
            object = new Double(Bool.booleanValue() ? 1.0 : 0.0);
            break;

        case -4:
        case -3:
        case -2:
            object = null;
            break;

        case 0:
        case 91:
        case 92:
        case 93:
            object = null;
            break;

        default:
            object = Bool;
            break;
        }
        return object;
    }

//    public void getPartProperty(RjlPart RjlPart, PropertyDescriptor propertyDescriptor)
//    {
//        if (propertyDescriptor == null)
//        {
//            current = null;
//            return;
//        }
//        Method method = propertyDescriptor.getReadMethod();
//        if (method == null)
//        {
//            current = null;
//            return;
//        }
//        try
//        {
//            Descriptor descriptor = propertyDescriptor.getPropertyType();
//            if (descriptor.equals(new Descriptor(RjlRuntime.EmptyString + 76 + "java.lang.String" + 59)))
//            {
//                String string = (String)method.invoke(RjlPart, new Object[0]);
//                current = objectFromString(string, type, scale);
//                return;
//            }
//            if (descriptor.equals(new Descriptor(RjlRuntime.EmptyString + 90)))
//            {
//                boolean Bool = (boolean)method.invoke(RjlPart, new Object[0]);
//                current = objectFromBoolean(Bool, type, scale);
//                return;
//            }
//            current = null;
//        }
//        catch (Exception e)
//        {
//            current = null;
//        }
//        return;
//    }

//    public void setPartProperty(RjlPart RjlPart, PropertyDescriptor propertyDescriptor)
//    {
//        Object aobject[] = new Object[1];
//        if (propertyDescriptor == null)
//            return;
//        Method method = propertyDescriptor.getWriteMethod();
//        if (method == null)
//        {
//            current = null;
//            return;
//        }
//        Descriptor descriptor = propertyDescriptor.getPropertyType();
//        if (current == null)
//            aobject[0] = null;
//        else if (descriptor.equals(new Descriptor(RjlRuntime.EmptyString + 76 + "java.lang.String" + 59)))
//            aobject[0] = setStringProperty();
//        else if (descriptor.equals(new Descriptor(RjlRuntime.EmptyString + 90)))
//            aobject[0] = setBooleanProperty();
//        if (aobject[0] != null)
//            method.invoke(RjlPart, aobject);
//    }

    public String getStringProperty(Object theObject)
    {
        String string = RJLRuntime.EmptyString;
        if (theObject == null )//|| theObject.equals(nullObject))
            return RJLRuntime.EmptyString;
		if (theObject.toString() != null) {
		    string = theObject.toString();
		}
		else
		{

            try {
                switch (type)
                {

                case -1://LONGVARCHAR 	=  -1;
                case 1: //	CHAR		=   1;
                case 12://	VARCHAR 	=  12;
                    string = String.valueOf((String)theObject);
                    break;

                case -7://	BIT 		=  -7;
                case -6://TINYINT 	=  -6;
                case 4://	INTEGER 	=   4;
                case 5: //SMALLINT	=   5;
                    string = String.valueOf((Integer)theObject);
                    break;

                case -5://	 BIGINT 		=  -5;
                    string = String.valueOf((Long)theObject);
                    break;

                case 2://	NUMERIC 	=   2;
                case 3: //DECIMAL		=   3;
                case 7://REAL 		=   7;
                case 6://FLOAT 		=   6;
                case 8://DOUBLE 		=   8;
                    string = String.valueOf((Float)theObject);
                    break;

                case 0://NULL		=   0;
                    string = RJLRuntime.EmptyString;
                    break;

                case 91:
                    string = ((Date)theObject).toString();
                    break;

                case 92:
                    string = ((Time)theObject).toString();
                    break;

                case 93:
                    string = ((Timestamp)theObject).toString();
                    break;

                case -4://LONGVARBINARY 	=  -4;
                case -3://VARBINARY 	=  -3;
                case -2://BINARY		=  -2;
                    string = ((Byte)theObject).toString();
                    break;

                default:
                    string = (String)theObject;

                    /**
                         * OTHER indicates that the SQL type is database specific and
                         * gets mapped to a Java object which can be accessed via
                         * getObject and setObject.
                         * public final static int OTHER		= 1111;
                         */
                }
               }
               catch (ClassCastException ex) {
                   System.out.println("ClassCastException " + columnName);
                   return string;
                   }
           }

        return string;
    }
}
