package origjava.jdbctest;

import origjava.test.*;
import sun.jdbc.odbc.*;
import java.sql.*;
import java.util.Vector;
import java.awt.*;
import java.lang.*;


public class RjlDatabaseRow  implements Cloneable
    /**
     * Placeholder for SQL fetches, Consists of RjlDatabaseColumn objects.
     * Provides methods for building SQL expressions based on
     * properties of RjlDatabase Column objects in RjlDatabaseRow.
     */

{
    RJLRuntime runTime = new RJLRuntime();
    final static protected int ScreenOriginal = 1;
    final static protected int ScreenInserted = 2;
    final static protected int ScreenDeleted = 3;
    final static protected int retrieved = 4;
    final static protected int pending = 5;
    final static protected int updated = 6;
    private int editState = 0;
    private int sqlState = 0;
    protected boolean changed;
    protected boolean isNew;
    protected Vector columns;
    protected String updateTableName;
    protected ResultSetMetaData rsmd;
    protected RjlResultSetMetaData rjlrsmd;
    protected ResultSet rs;
    private Util uT;
    private PreparedStatement updateStatement;
    private PreparedStatement insertStatement;
    private PreparedStatement deleteStatement;
    private Connection c_con;
    private int numSetParams;
    private int numWhereParams;


 public void doSQLUpdate() 
     {
     System.out.println("before executeUpdate ");
     try {
          if ( updateStatement != null )
              {updateStatement.executeUpdate();
               System.out.println(updateStatement.toString());
              }
          if ( insertStatement != null )
              {insertStatement.executeUpdate();
               System.out.println(insertStatement.toString());
              }
          if ( deleteStatement != null )
              {deleteStatement.executeUpdate();
               System.out.println(deleteStatement.toString());
              }
         }
       catch (SQLException ex) {runTime.displayExceptionMessage(ex,false,new Frame("doSQLUpdate "));}
       setSqlState(updated);
       System.out.println("after executeUpdate ");
     }


public void buildSQL() {
    // case on rjlRow.getEditState() (ScreenInserted,ScreenDeleted,ScreenOriginal)
    updateStatement = null;
    insertStatement = null;
    deleteStatement = null;
        switch (getEditState())
            {
            case ScreenOriginal:


                     String l_string = createSetUpdateString();
                     if (l_string != RJLRuntime.EmptyString) {
                        System.out.println("l_string " + l_string);
                        try {updateStatement = c_con.prepareStatement(l_string);}
                        catch (NullPointerException ex1) {System.out.println( "c_con.prepareStatement NullPointerException "); }
                        catch (SQLException ex) {runTime.displayExceptionMessage(ex,true,new Frame());}
						if (updateStatement != null) {
                            numSetParams =   fillSetParms(updateStatement);
                            numWhereParams = fillWhereParms(updateStatement,numSetParams);
                            setSqlState(pending);
						  }
                         }

                break;

            case ScreenInserted:

                try { insertStatement = c_con.prepareStatement(createInsertString("", updateTableName)); }
                catch (SQLException ex1) {runTime.displayExceptionMessage(ex1,true,new Frame());}
                fillInsertParms(insertStatement, updateTableName);
                setSqlState(pending);


                break;

            case ScreenDeleted:

                try {deleteStatement = c_con.prepareStatement(createDeleteString("", updateTableName,null));}
                catch (SQLException ex1) {runTime.displayExceptionMessage(ex1,true,new Frame());}
                numSetParams = fillDeleteParms(deleteStatement);
                setSqlState(pending);

                break;
            default:

            }
    }


    public synchronized Object clone() {
        RjlDatabaseRow v = null;
	try { 
	     v = (RjlDatabaseRow) super.clone();//new RjlDatabaseRow(rjlrsmd,rs);
	    } 
    catch (CloneNotSupportedException e) {System.out.println("CloneNotSupportedException ");}
        return v;

        }

    public synchronized RjlDatabaseRow createRowClone() {
        RjlDatabaseRow v = null;
        v = (RjlDatabaseRow) clone();
        return v;
     }
    public void setConnection(Connection theValue) {
        c_con = theValue;
        }

    public int getSqlState() {
        return sqlState;
        }
    public void setSqlState(int state) {
        sqlState = state;
        }

    public int getEditState() {
        return editState;
        }
    public void setEditState(int state) {
        editState = state;
        }
    public String getUpdateTableName() {
        if (updateTableName == null) return RJLRuntime.EmptyString;
        return updateTableName;
    }
    public int getNumCols() {
        return columns.size();
        }
    public RjlDatabaseColumn getColumn(int i) {
        if ( i > columns.size()) return null;
        return (RjlDatabaseColumn) columns.elementAt(i);
    }
    public String createDeleteString(String string1, String string2, String string3)
        throws SQLException
        // 1=HostName 2=tableName, 3=whereClause
    {
        int i = 0;
        i = columns.capacity();
        String string4 = RJLRuntime.SQLDelete + cleanTableName(string2);
        if (string3 != null)
            string4 = string4 + RJLRuntime.SQLWhereCurrent + string3;
        else
        {
            string4 = string4 + RJLRuntime.SQLWhere;
            int k = 0;
            for (int j = 0; j < i; j++)
            {
                RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(j);
                if (isColumnInTable(j, string2))
                {
                    if (k > 0)
                        string4 = string4 + RJLRuntime.SQLAnd;
                    if (RjlDatabaseColumn.original == null)
                        string4 = string4 + fullColumnName(j, string1, string2) + RJLRuntime.SQLIsNull;
                    else
                        string4 = string4 + columnNameSet(j, string1) + RJLRuntime.SQLEquals + RJLRuntime.SQLParm + RJLRuntime.BlankString;
                    k++;
                }
            }
        }
        RJLRuntime.trace(2, string4);
        return string4;
    }

    public String createInsertString(String string1, String string2)
        throws SQLException
        // 1=HostName 2=tableName, 3=whereClause
    {
        int i1 = 0;
        int i2 = 0;
        i1 = columns.capacity();
        String string3 = RJLRuntime.SQLInsert + cleanTableName(string2);
        if (i1 > 0)
        {
            for (int j = 0; j < i1; j++)
            {
                if (isColumnInTable(j, string2))
                {
                    if (i2 == 0)
                        string3 = string3 + RJLRuntime.BlankString + RJLRuntime.OpenParen;
                    RjlDatabaseColumn RjlDatabaseColumn1 = (RjlDatabaseColumn)columns.elementAt(j);
                    string3 = string3 + columnNameSet(j, string1);
                    if (++i2 < i1)
                        string3 = string3 + ",";
                    else
                        string3 = string3 + RJLRuntime.CloseParen;
                }
            }
            i2 = 0;
            for (int k = 0; k < i1; k++)
            {
                if (isColumnInTable(k, string2))
                {
                    if (i2 == 0)
                        string3 = string3 + RJLRuntime.SQLValues;
                    RjlDatabaseColumn RjlDatabaseColumn2 = (RjlDatabaseColumn)columns.elementAt(k);
                    string3 = string3 + RJLRuntime.SQLParm;
                    if (++i2 < i1)
                        string3 = string3 + ",";
                    else
                        string3 = string3 + RJLRuntime.CloseParen;
                }
            }
        }
        else
            string3 = RJLRuntime.EmptyString;
        RJLRuntime.trace(2, string3);
        return string3;
    }

    public void fillUpdateWhereParms(PreparedStatement preparedStatement, int i1, String string)
        throws SQLException
                // where parameter
    {
        int j = i1;
        int k = columns.capacity();
        for (int i2 = 0; i2 < k; i2++)
        {
            if (isColumnInTable(i2, string))
            {
                RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(i2);
                j++;
                if (RjlDatabaseColumn.original != null)
                    preparedStatement.setObject(j, RjlDatabaseColumn.original, RjlDatabaseColumn.type, RjlDatabaseColumn.scale);
            }
        }
    }

    public String createUpdateString(String string1, String string2, String string3)
        throws SQLException
        // 1=HostName 2=tableName, 3=whereClause
    {
        int i1 = 0;
        int j1 = 0;
        int k2 = 0;
        j1 = columns.capacity();
        String string4 = RJLRuntime.SQLUpdate + cleanTableName(string2);
        for (int k1 = 0; k1 < j1; k1++)
        {
            if (isColumnInTable(k1, string2))
            {
                RjlDatabaseColumn RjlDatabaseColumn1 = (RjlDatabaseColumn)columns.elementAt(k1);
                if ((RjlDatabaseColumn1.original != null || RjlDatabaseColumn1.current != null) && (RjlDatabaseColumn1.original == null && RjlDatabaseColumn1.current != null || RjlDatabaseColumn1.original != null && RjlDatabaseColumn1.current == null || !RjlDatabaseColumn1.original.equals(RjlDatabaseColumn1.current)))
                {
                    RjlDatabaseColumn1.changed = true;
                    i1++;
                }
            }
        }
        if (i1 > 0)
        {
            for (int i2 = 0; i2 < j1; i2++)
            {
                if (isColumnInTable(i2, string2))
                {
                    RjlDatabaseColumn RjlDatabaseColumn2 = (RjlDatabaseColumn)columns.elementAt(i2);
                    if (RjlDatabaseColumn2.changed)
                    {
                        if (k2 == 0)
                            string4 = string4 + RJLRuntime.SQLSet;
                        string4 = string4 + columnNameSet(i2, string1) + RJLRuntime.SQLEquals + RJLRuntime.SQLParm;
                        if (++k2 < i1)
                            string4 = string4 + ",";
                        else
                            string4 = string4 + RJLRuntime.BlankString;
                    }
                }
            }
            if (string3 != null)
                string4 = string4 + RJLRuntime.SQLWhereCurrent + string3;
            else
            {
                string4 = string4 + RJLRuntime.SQLWhere;
                k2 = 0;
                for (int j2 = 0; j2 < j1; j2++)
                {
                    if (isColumnInTable(j2, string2))
                    {
                        RjlDatabaseColumn RjlDatabaseColumn3 = (RjlDatabaseColumn)columns.elementAt(j2);
                        if (k2 > 0)
                            string4 = string4 + RJLRuntime.SQLAnd;
                        if (RjlDatabaseColumn3.original == null)
                            string4 = string4 + fullColumnName(j2, string1, string2) + RJLRuntime.SQLIsNull;
                        else
                            string4 = string4 + fullColumnName(j2, string1, string2) + RJLRuntime.SQLEquals + RJLRuntime.SQLParm + RJLRuntime.BlankString;
                        k2++;
                    }
                }
            }
        }
        else
        string4 = RJLRuntime.EmptyString;
        return string4;
    }

    public String createSetUpdateString()
    {
        int i1 = 0;
        int j1 = 0;
        int k2 = 0;
        j1 = columns.capacity();
        String string4 = " ";
        for (int k1 = 0; k1 < j1; k1++)
        {
            RjlDatabaseColumn RjlDatabaseColumn1 = (RjlDatabaseColumn)columns.elementAt(k1);
            if ((RjlDatabaseColumn1.original != null || RjlDatabaseColumn1.current != null) && (RjlDatabaseColumn1.original == null && RjlDatabaseColumn1.current != null || RjlDatabaseColumn1.original != null && RjlDatabaseColumn1.current == null || !RjlDatabaseColumn1.original.equals(RjlDatabaseColumn1.current)))
            {
                RjlDatabaseColumn1.changed = true;
                if (updateTableName != null)
                    {
                     if (
                         !(updateTableName.equals(RjlDatabaseColumn1.getTableName()))
                        )
                         {
                         String messg = "updateTableName was : " + updateTableName +
                                        " will be changed to : " + 
                                        RjlDatabaseColumn1.getTableName();

                           messageBox errorBox = new messageBox(new Frame(),messg,
                              "Warning",messageBoxButtons.OK);

                         }
                    }
                updateTableName = RjlDatabaseColumn1.getTableName();
				System.out.println(" columnChanged " + RjlDatabaseColumn1.getColumnName()); 
				try {
				System.out.println(" original " + RjlDatabaseColumn1.original.toString());
                System.out.println(" current " + RjlDatabaseColumn1.current.toString());
				}
				catch (NullPointerException ex1) {
				System.out.println(" null column ");
				}
                i1++;
            }
        }
        if (i1 > 0)
        {
            for (int i2 = 0; i2 < j1; i2++)
            {
                RjlDatabaseColumn RjlDatabaseColumn2 = (RjlDatabaseColumn)columns.elementAt(i2);
                if (RjlDatabaseColumn2.changed)
                {
                    if (k2 == 0)
                        string4 = string4 + RJLRuntime.SQLSet;
                        string4 = string4 + RjlDatabaseColumn2.getColumnName() + RJLRuntime.SQLEquals + RJLRuntime.SQLParm;
                    if (++k2 < i1)
                        string4 = string4 + ",";
                    else
                        string4 = string4 + RJLRuntime.BlankString;
                }
            }
            if (!(updateTableName.equals(RJLRuntime.EmptyString) ) )
                {
                 string4 = RJLRuntime.SQLUpdate + updateTableName + string4;
                }
            string4 = string4 + RJLRuntime.SQLWhere;
            k2 = 0;
            for (int j2 = 0; j2 < j1; j2++)
            {

                RjlDatabaseColumn RjlDatabaseColumn3 = (RjlDatabaseColumn)columns.elementAt(j2);
                if (k2 > 0)
                    string4 = string4 + RJLRuntime.SQLAnd;
                if (RjlDatabaseColumn3.original == null)
                    string4 = string4 + RjlDatabaseColumn3.getColumnName() + RJLRuntime.SQLIsNull;
                else
                    string4 = string4 + RjlDatabaseColumn3.getColumnName() + RJLRuntime.SQLEquals + RJLRuntime.SQLParm + RJLRuntime.BlankString;
                k2++;
            }
        }
        else
            {
             string4 = RJLRuntime.EmptyString;
            }
		return string4;
    }

    public String createSelectForUpdateString(String string1, String string2, boolean flag)
        throws SQLException
    {
        int i1 = 0;
        int j1 = 0;
        String string4 = new String();
        int k2 = 0;
        j1 = columns.capacity();
        String string3 = RJLRuntime.SQLSelect;
        for (int k1 = 0; k1 < j1; k1++)
        {
            if (isColumnInTable(k1, string2))
            {
                RjlDatabaseColumn RjlDatabaseColumn1 = (RjlDatabaseColumn)columns.elementAt(k1);
                if ((RjlDatabaseColumn1.original != null || RjlDatabaseColumn1.current != null) && (RjlDatabaseColumn1.original == null && RjlDatabaseColumn1.current != null || RjlDatabaseColumn1.original != null && RjlDatabaseColumn1.current == null || !RjlDatabaseColumn1.original.equals(RjlDatabaseColumn1.current)))
                {
                    RjlDatabaseColumn1.changed = true;
                    i1++;
                }
            }
        }
        if (flag)
            i1 = j1;
        if (i1 > 0 || flag)
        {
            for (int i2 = 0; i2 < j1; i2++)
            {
                if (isColumnInTable(i2, string2))
                {
                    RjlDatabaseColumn RjlDatabaseColumn2 = (RjlDatabaseColumn)columns.elementAt(i2);
                    if (RjlDatabaseColumn2.changed || flag)
                    {
                        string4 = string4 + fullColumnName(i2, string1, string2);
                        if (++k2 < i1)
                            string4 = string4 + ",";
                        else
                            string4 = string4 + RJLRuntime.BlankString;
                    }
                }
            }
        }
        else
            string3 = RJLRuntime.EmptyString;
        if (!string3.equals(RJLRuntime.EmptyString))
        {
            string3 = string3 + string4 + RJLRuntime.SQLFrom + cleanTableName(string2) + RJLRuntime.SQLWhere;
            k2 = 0;
            for (int j2 = 0; j2 < j1; j2++)
            {
                if (isColumnInTable(j2, string2))
                {
                    RjlDatabaseColumn RjlDatabaseColumn3 = (RjlDatabaseColumn)columns.elementAt(j2);
                    if (k2 > 0)
                        string3 = string3 + RJLRuntime.SQLAnd;
                    if (RjlDatabaseColumn3.original == null)
                        string3 = string3 + fullColumnName(j2, string1, string2) + RJLRuntime.SQLIsNull;
                    else
                        string3 = string3 + fullColumnName(j2, string1, string2) + RJLRuntime.SQLEquals + RJLRuntime.SQLParm + RJLRuntime.BlankString;
                    k2++;
                }
            }
            string3 = string3 + RJLRuntime.SQLForUpdate + string4;
        }
        RJLRuntime.trace(2, string3);
        return string3;
    }

    public RjlDatabaseRow(RjlResultSetMetaData resultSetMetaData, ResultSet resultSet,
        Connection theCon, String updateTable)
        throws SQLException
    {
        uT.setVerbose(true);
        rjlrsmd = resultSetMetaData;
        rsmd = resultSetMetaData.getResultSetMetaData();
        rs = resultSet;
        int i1 = rsmd.getColumnCount();
        changed = false;
        columns = new Vector(i1, 1);
        String columnName = null;
        String tableName = null;
        String databaseName = null;
        String hostName = null;
        String hostIPAddress = null;
        updateTableName = updateTable;
        editState = ScreenOriginal;
        setConnection(theCon);
        for (int j = 1; j <= i1; j++)
        {
            int i2;
            int k = rsmd.getColumnType(j);
            if (k == 2 || k == 3)
                i2 = rsmd.getScale(j);
            else
                i2 = 0;//false;
            tableName = null;
            databaseName = null;
            hostName = null;
            hostIPAddress = null;
            isNew = false;

            tableName = resultSetMetaData.getTableName(j);
            if (tableName.length() == 0 ) {
                tableName = updateTableName;
                if (resultSetMetaData.isTableNameSupported()) {
                    System.out.println("getTableName not Supported !! \n Must provide UpdateTableName");
                    resultSetMetaData.setTableNameSupported(false);
                    }
                }
            databaseName = resultSetMetaData.getCatalogName(j);
            if (databaseName.length() == 0) {
                if (resultSetMetaData.isCatalogNameSupported()) {
                    System.out.println("getCatalogName not Supported ");
                    resultSetMetaData.setCatalogNameSupported(false);
                    }
                }
            columnName = resultSetMetaData.getColumnName(j);
            if (columnName.length() == 0) {System.out.println("getColumnName Not Supported");}     

            if (resultSet != null)
            {
                columns.
                    addElement(
                         new RjlDatabaseColumn(
                             resultSet.getObject(j), k, i2,
                             databaseName,hostName,tableName,columnName,hostIPAddress
                             )
                         );
                setSqlState(retrieved);
            }
            else
            {
                isNew = true;
                columns.addElement(new RjlDatabaseColumn(null, k, i2,columnName,tableName));
            }
        }
    }

    private boolean isColumnInTable(int i, String string1)
    {
        int j = i + 1;
        boolean flag = false;

        String string2 = RJLRuntime.EmptyString;
        try {
            string2 = rsmd.getTableName(j);
            }
        catch (SQLException ex) {runTime.displayExceptionMessage(ex,true,new Frame("isColumnInTable"));}
        if (string2.length() == 0)
            flag = true;
        else
            flag = string2.equalsIgnoreCase(cleanTableName(string1));
        return flag;
    }

    public void fillInsertParms(PreparedStatement preparedStatement, String string)
    {
        int i = 0;
        int j = columns.capacity();
        for (int k = 0; k < j; k++)
        {
            if (isColumnInTable(k, string))
            {
                RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(k);
                i++;
                try {
                if (RjlDatabaseColumn.current != null)
                    preparedStatement.setObject(i, RjlDatabaseColumn.current, RjlDatabaseColumn.type, RjlDatabaseColumn.scale);
                else
                    preparedStatement.setNull(i, RjlDatabaseColumn.type);
                    }
                catch (SQLException ex) {runTime.displayExceptionMessage(ex,true,new Frame("fillInsertParams"));}
            }
        }
    }

    public int fillSetParms(PreparedStatement preparedStatement)
    {
        int i = 0;
        int j = columns.capacity();
        for (int k = 0; k < j; k++)
        {

            RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(k);
            if (RjlDatabaseColumn.changed)
            {
                i++;
                try {
                if (RjlDatabaseColumn.current != null){
                    
                    try {
                         preparedStatement.setObject(i,
                             RjlDatabaseColumn.current, RjlDatabaseColumn.type,
                             RjlDatabaseColumn.scale);
                        }
                    catch (ClassCastException ex1){
                        System.out.println("ClassCastException " + RjlDatabaseColumn.getColumnName());
                        System.out.println(RjlDatabaseColumn.current.toString());
                         preparedStatement.setObject(i,
                             RjlDatabaseColumn.current);
                        }
                    }
                else
                    {preparedStatement.setNull(i, RjlDatabaseColumn.type);}
                    }
                catch (SQLException ex) {runTime.displayExceptionMessage(ex,true,new Frame("fillSetParams"));}
            }       

        }
        return i;
    }

    public int fillDeleteParms(PreparedStatement preparedStatement)
    {
        int i = 0;
        int j = columns.capacity();
        for (int k = 0; k < j; k++)
        {

            RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(k);
            if (!RjlDatabaseColumn.changed)
            {
                i++;
                try {
                if (RjlDatabaseColumn.current != null)
                    preparedStatement.setObject(i, RjlDatabaseColumn.current, RjlDatabaseColumn.type, RjlDatabaseColumn.scale);
                else
                    preparedStatement.setNull(i, RjlDatabaseColumn.type);
                    }
                catch (SQLException ex) {runTime.displayExceptionMessage(ex,true,new Frame("fillDeleteParams"));}
            }
        }
        return i;
    }


    public int fillWhereParms(PreparedStatement preparedStatement, int numSetParam)
        //throws SQLException
    {
        int i = numSetParam;
        int j = columns.capacity();
        for (int k = 0; k < j; k++)
        {

            RjlDatabaseColumn RjlDatabaseColumn = (RjlDatabaseColumn)columns.elementAt(k);
            if (RjlDatabaseColumn.original != null )
            {
                i++;//start after set parameters (update x set t=y where a=b)
                if (RjlDatabaseColumn.original != null )
                    try {
                         preparedStatement.
                             setObject(i , RjlDatabaseColumn.original, 
                             RjlDatabaseColumn.type, RjlDatabaseColumn.scale);
                         }
                     catch (SQLException  e)
                         {runTime.displayExceptionMessage(e,true,new Frame("fillWhereParams " + RjlDatabaseColumn.getColumnName() + " : " +
                           RjlDatabaseColumn.original.toString()));}
                else
                    try {
                         preparedStatement.
                             setObject(i ,
                             RJLRuntime.EmptyString
                             , 
                             0//RjlDatabaseColumn.type
                             ,
                             0//RjlDatabaseColumn.scale
                             );                             
/*
                             setNull(i 
                             ,
                             RjlDatabaseColumn.type
                             );
*/
                         }
                     catch (SQLException  ex)
                         {
                         runTime.displayExceptionMessage(ex,false,new Frame());
                         // concats a null and blows up visible displayExeceptionMessage
                         }
            }
        }
        return i - numSetParam; // num of WhereParams
    }

    private String fullColumnName(int i, String string1, String string2)
        throws SQLException
    {
        String string5 = "";
        boolean flag;
        int j = i + 1;
        String string3 = rsmd.getTableName(j);
        if (string1.equals(RJLRuntime.BlankString))
            string1 = RJLRuntime.EmptyString;
        if (rsmd.getColumnName(j).indexOf(RJLRuntime.BlankString) >= 0)
            flag = true;
        else
            flag = false;
        if (!string3.equals(RJLRuntime.EmptyString))
        {
            string5 = rsmd.getTableName(j) + RJLRuntime.SQLDot;
            if (flag)
                string5 = string5 + string1;
            string5 = string5 + rsmd.getColumnName(j);
            if (flag)
                string5 = string5 + string1;
        }
        else if (string2 != null)
        {
            String string4 = cleanTableName(string2) + RJLRuntime.SQLDot;
            if (flag)
                string4 = string4 + string1;
            string4 = string4 + rsmd.getColumnName(j);
            if (flag)
                string5 = string4 + string1;
        }
        else
            string5 = rsmd.getColumnName(j);
        return string5;
    }

    private String cleanTableName(String string1)
    {
        String string2;
        int i = string1.indexOf(".");
        if (i >= 0)
            string2 = string1.substring(0, i);
        else
            string2 = string1;
        return string2;
    }

    private String columnNameSet(int i, String string1)
        throws SQLException
    {
        boolean flag;
        int j = i + 1;
        String string2 = RJLRuntime.EmptyString;
        if (string1.equals(RJLRuntime.BlankString))
            string1 = RJLRuntime.EmptyString;
        if (rsmd.getColumnName(j).indexOf(RJLRuntime.BlankString) >= 0)
            flag = true;
        else
            flag = false;
        if (flag)
            string2 = string2 + string1;
            string2 = string2 + rsmd.getColumnName(j);
        if (flag)
            string2 = string2 + string1;
        return string2;
    }
}
