package origjava.jdbctest;

import origjava.test.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.Vector;
import java.util.Enumeration;
import java.net.URL;
import java.sql.*;
import java.io.*;


public class jdbcSqlTest extends Panel implements RjlListener, Serializable,WindowListener {

    public  jdbcSqlTest (Frame l_frame,databaseConnection db) {
       this.c_cont = l_frame;
       setDatabaseConnection(db);
       isVisible = true;
       init();
     }

    public void setDatabaseConnection(databaseConnection db) {
        this.db = db;
        this.c_dma = db.getC_dma();
        this.c_con = db.getConnection();
        dBDisplay.setConnection(db.getConnection());
        }

    public void createAndShow() {
        createDisplayFrame();
        if ((dBDisplay.getPresentationRow()).size() > 0 ) showDisplayFrame();
        }

    public void inspectConnection(Connection theConnection) {
        if (theConnection == null )
            {
             Util.debug(theConnection); 
             return;
            }
        try {
		     DatabaseMetaData dma = theConnection.getMetaData ();
             ResultSet catalogs = null;
             ResultSet schema = null;
             ResultSet tables = null;
             try { catalogs = dma.getCatalogs();}
             catch (SQLException ex1) {runTime.displayExceptionMessage(ex1,isVisible,new Frame("getCatalog"));}
			 if ( catalogs != null) System.out.println("getCatalog is not null");

			 try {schema = dma.getSchemas();}
             catch (SQLException ex2) {runTime.displayExceptionMessage(ex2,isVisible,new Frame("getSchema"));}
			 try {tables = dma.getTables(
			                          "",//catalog,
                                      "*",//schemaPattern,
                                      "*",//tableNamePattern,
                                      null//types[]
									  );
                 }
             catch (SQLException ex3) {runTime.displayExceptionMessage(ex3,isVisible,
                                        new Frame("getTables"));}
			 if ( schema != null) System.out.println("getSchema is not null");
			 if (catalogs != null ) runTime.dispResultSet(catalogs);
			 if (schema != null ) runTime.dispResultSet(schema);
			 if (tables != null ) runTime.dispResultSet(tables);
        }
		catch (SQLException ex) {runTime.displayExceptionMessage(ex,isVisible,new Frame("inspectConnection"));}
        }

    public void getResultSet() {
        if (c_con == null )
            {
             uT.debug(c_con); 
             return;
            }
        try {
             PreparedStatement ps =  c_con.prepareStatement(selectString);
             ResultSet rs = ps.executeQuery(); //db.getSchemas();
             dBDisplay.setUpdateTable(updateTable);
             if (rs != null ) jB.setText4("TotalRows : " + dBDisplay.setResultSet(rs));

        }
		catch (SQLException ex) {runTime.displayExceptionMessage(ex,isVisible,new Frame("execute Query"));}

    }

public  void addToPanel (Component l_cmp, GridBagConstraints theConstraints) {

       l_cmp.setSize(l_cmp.getPreferredSize());
       add(l_cmp,theConstraints);
       setSize(getPreferredSize());
}

public  jdbcSqlTest (Frame l_frame) {
       isVisible = true;
       this.c_cont = l_frame;
       init();
}

public  jdbcSqlTest () {
       isVisible = true;
       promptBox pb1 = new promptBox("Title ","Enter updateTable",updateTable);
       promptBox pb2 = new promptBox("Title ","Enter selectString",selectString);
       updateTable =  pb1.getResponse();
       selectString = pb2.getResponse();
       System.out.println("updateTable " + updateTable);
       System.out.println("selectString " + selectString);
       init();
    }

public void setDefaultFrame() {
    this.c_cont = uT.findFrame(this );
    this.c_cont.addWindowListener(this);
    }
public GridBagConstraints setConstraints(
                                         int gridx,
                                         int gridy,
                                         int gridwidth,
                                         int gridheight,
                                         double weightx,
                                         double weighty,
                                         int anchor,
                                         int fill,
                                         Insets insets,
                                         int ipadx,
                                         int ipady
                                         )
    {
     GridBagConstraints theValue = new GridBagConstraints();
         theValue.gridx = gridx;
         theValue.gridy = gridy;
         theValue.gridwidth = gridwidth;
         theValue.gridheight = gridheight;
         theValue.weightx = weightx;
         theValue.weighty= weighty;
         theValue.anchor = anchor;
         theValue.fill = fill;
         theValue.insets = insets;
         theValue.ipadx = ipadx;
         theValue.ipady = ipady;
         return theValue;
    }
public  void init () {       
        theLayout = new GridBagLayout();
	    setLayout(theLayout);
       setForeground(Color.black.brighter());
       setBackground(Color.lightGray);
       ibLeft.setImageURL("./images/LEFT24E.GIF");
       ibRight.setImageURL("./images/RIGHT24E.GIF");
       uT.setVerbose(true);
     }
public void initTestButtons() {
           objectList  = new Vector();
           nextBN.removeRjlListener(nextLN);
           firstBN.removeRjlListener(firstLN);
           lastBN.removeRjlListener(lastLN);
           prevBN.removeRjlListener(prevLN);
           doSQLBN.removeRjlListener(doSQLLN);
           deleteBN.removeRjlListener(deleteLN);
           insertBN.removeRjlListener(insertLN);

           nextBN.addRjlListener(nextLN);
           firstBN.addRjlListener(firstLN);
           lastBN.addRjlListener(firstLN);
           prevBN.addRjlListener(prevLN);
           doSQLBN.addRjlListener(doSQLLN);
           deleteBN.addRjlListener(deleteLN);
           insertBN.addRjlListener(insertLN);

           objectList.addElement(nextBN);
           objectList.addElement(firstBN);
           objectList.addElement(lastBN);
           objectList.addElement(prevBN);
           objectList.addElement(doSQLBN);
           objectList.addElement(deleteBN);
           objectList.addElement(insertBN);
    }

public Panel buildTestButtonPanel() {
       Panel bP = new Panel();
       bP.setLayout(new FlowLayout());
       for (int j1 = 0; j1 < objectList.size(); j1++)
         {
            Component lc = (Component) objectList.elementAt(j1);
            bP.add(lc);
         }
       return bP;
    }
public  void createDisplayFrame() {       
       if (c_con != null ) {
           getResultSet();
           initTestButtons();

           removeAll();
           testToolBarAdd();

           addToPanel(dBDisplay.buildDBDisplayPanel(),setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         dBDisplay.getPresentationRow().size(),//double weighty,
                                         GridBagConstraints.NORTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
               );

           addToPanel(buildTestButtonPanel(),setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         objectList.size(),//double weighty,
                                         GridBagConstraints.SOUTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady

                )
               );

           addToPanel(jB,setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         1.0,//double weighty,
                                         GridBagConstraints.SOUTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady

               )
               );

          }
       
     }

public  void showDisplayFrame() {       

    if ( dBDisplay.getPresentationRow().size() > 0 ) 
        {
           doLayout();
           Dimension cSdim = getPreferredSize();//p.getPreferredSize();
           setSize(getPreferredSize().width ,getPreferredSize().height );
           cS.add( this);//p);
           if (c_cont == null ) return;
           cS.setSize(getPreferredSize().width + 30,getPreferredSize().height + 30);
           c_cont.setSize(getPreferredSize().width + 150,getPreferredSize().height + 150);
           c_cont.add(cS);
           c_cont.setBackground(Color.green);
           int pWidth =  600;
           int pHeight = 500;
           Dimension theScreen = tlkt1.getScreenSize();
           if ( pWidth > theScreen.width  ) pWidth =   theScreen.width ;
           if ( pHeight > theScreen.height ) pHeight =   theScreen.height ;
          // cS.setSize(new Dimension(pWidth - 10,pHeight - 10));
           //c_cont.setSize(new Dimension(pWidth - 10,pHeight - 10));
/*           cS1.setSize(new Dimension(tpreferredWidth + 80,//cS1.getVScrollbarWidth(),
                                     tpreferredHeight + 30//cS1.getHScrollbarHeight()
                                     )
                                     );
*/           
           c_cont.show();
           //c_cont.repaint();
        }
    
     }

public void testToolBarAdd() {


           addToPanel(new toolPanel(),setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         1.0,//double weighty,
                                         GridBagConstraints.NORTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
               );

    }
 public void RjlAction(RjlEvent pbe) {
    
     Object l_object = pbe.getTopic();
     String l_string = pbe.getDescription();
     if ( l_string == "Prev" ) {
         dBDisplay.doPrev();
     }
      if ( l_string == "Next" ) {
         dBDisplay.doNext();
     }
      if ( l_string == "First" ) {
         dBDisplay.doFirst();
     }
      if ( l_string == "Last" ) {
          dBDisplay.doLast();
     }
     if ( l_string == "doSQL" ) {
         dBDisplay.doSQLAction();
     }
     if ( l_string == "Insert" ) {
         dBDisplay.doInsert();
     }
     if ( l_string == "Delete" ) {
         dBDisplay.doDelete();
     }


 }


    private void catchSQLException(SQLException e)
    {
        runTime.displayExceptionMessage(e,isVisible,c_cont);
    }

    public void  doNext() {
          dBDisplay.doNext(); 
        }
    public void  doFirst() {
          dBDisplay.doFirst(); 
        }
    public void  doLast() {
          dBDisplay.doLast(); 
        }
    public void  doInsert() {
          dBDisplay.doInsert(); 
        }

    public void  doPrev() {
         dBDisplay.doPrev();
        }


    // Methods for registering/deregistering event listeners

    /**
     * The specified ActionListeners <b>actionPerformed</b> method will 
     * be called each time the button is clicked.  The ActionListener
     * object is added to a list of ActionListeners managed by 
     * this button, it can be removed with removeActionListener.
     * Note: the JavaBeans specification does not require ActionListeners
     * to run in any particular order.
     * 
     * @see #removeActionListener
     * @param l the ActionListener
     */      

    public synchronized void addActionListener(ActionListener l) {
	actionListeners.addElement(l);
    }

    /** 
     * Remove this ActionListener from the buttons internal list.  If the
     * ActionListener isn't on the list, silently do nothing.
     * 
     * @see #addActionListener
     * @param l the ActionListener
     */      
    public synchronized void removeActionListener(ActionListener l) {
	actionListeners.removeElement(l);
    }

    /** 
     * This method has the same effect as pressing the button.
     * 
     * @see #addActionListener
     */      
    public void fireAction() {
	Vector targets;
	synchronized (this) 
        {
	     targets = (Vector) actionListeners.clone();
        }
	ActionEvent actionEvt = new ActionEvent(this, 0, null);
	for (int i = 0; i < targets.size(); i++) 
        {
	     ActionListener target = (ActionListener)targets.elementAt(i);
	     if ( target != null ) target.actionPerformed(actionEvt);
        }
    }

    /**
     * The specified PropertyChangeListeners <b>propertyChange</b> method will
     * be called each time the value of any bound property is changed.
     * The PropertyListener object is addded to a list of PropertyChangeListeners
     * managed by this button, it can be removed with removePropertyChangeListener.
     * Note: the JavaBeans specification does not require PropertyChangeListeners
     * to run in any particular order.
     *
     * @see #removePropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void addPropertyChangeListener(PropertyChangeListener l) {
	changes.addPropertyChangeListener(l);
    }

    /** 
     * Remove this PropertyChangeListener from the buttons internal list.  
     * If the PropertyChangeListener isn't on the list, silently do nothing.
     * 
     * @see #addPropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void removePropertyChangeListener(PropertyChangeListener l) {
	changes.removePropertyChangeListener(l);
    }

    public String getSelectString() {
        return selectString;
        }
    public String getUpdateSetString() {
        return updateSetString;
        }
    public String getDeleteString() {
        return deleteString;
        }                                                         
    public String getInsertString() {
        return insertString;
        }
     public void setSelectString(String newValue) {
        String oldValue = selectString;
        selectString = newValue;
	    changes.firePropertyChange("selectString", oldValue, newValue);
        }

     public void createSetUpdateString(String newValue) {
        String oldValue = updateSetString;
        updateSetString = newValue;
	    changes.firePropertyChange("updateSetString", oldValue, newValue);
        }
     public void setDeleteString(String newValue) {
        String oldValue = deleteString;
        deleteString = newValue;
	    changes.firePropertyChange("deleteString", oldValue, newValue);
        }
     public void setInsertString(String newValue) {
        String oldValue = insertString;
        insertString = newValue;
	    changes.firePropertyChange("insertString", oldValue, newValue);
        }

    public void windowClosing(WindowEvent e)
    {
        System.out.println("jdbcSqlTest windowClosing called");
        System.exit( 0 );
    }

    public void windowOpened(WindowEvent e)      {}
    public void windowClosed(WindowEvent e)      {}
    public void windowIconified(WindowEvent e)   {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e)   {}
    public void windowDeactivated(WindowEvent e) {}

    private DBDisplay dBDisplay = new DBDisplay();
    private StatusPanel jB = new StatusPanel();
    private GridBagLayout theLayout;
    private int height1 = 3;
    private int width1;

    private int numSetParams = 0;
    private int numWhereParams = 0;
    private PreparedStatement updateStatement;
    private PreparedStatement insertStatement;
    private PreparedStatement deleteStatement;
    private Util uT ;
    private String selectString = "select * from [Time Cards]";
    private String updateSetString;
    private String deleteString;
    private String insertString;
    private String updateTable = "[Time Cards]";
    private PropertyChangeSupport changes = new PropertyChangeSupport(this);
    private Vector actionListeners = new Vector();


    RJLRuntime runTime = new RJLRuntime();
    Vector objectList ;// = new Vector();
    actionButton firstBN = new actionButton("First");
    actionButton lastBN = new actionButton("Last");
    actionButton nextBN = new actionButton("Next");
    actionButton prevBN = new actionButton("Prev");
    actionButton doSQLBN = new actionButton("doSQL");
    actionButton insertBN = new actionButton("Insert");
    actionButton deleteBN = new actionButton("Delete");
    ImageButton ibLeft = new ImageButton();
    ImageButton ibRight = new ImageButton();
    databaseConnection db;
    ScrollPane cS = new ScrollPane();
    ScrollPane cS1 = new ScrollPane();
    int tpreferredWidth = 0;
    int tpreferredHeight = 0;
    DatabaseMetaData c_dma;
    Connection c_con;
    Frame c_cont = new Frame();
    protected boolean isVisible ;
    private String seperator = "\n";  
    private  jdbcSqlTestListener firstLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener lastLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener nextLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener prevLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener doSQLLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener deleteLN = new jdbcSqlTestListener(this);
    private  jdbcSqlTestListener insertLN = new jdbcSqlTestListener(this);
    Toolkit tlkt1 =  java.awt.Toolkit.getDefaultToolkit();

 }
