package origjava.test;
//package sunw.demo.buttons;

import java.beans.*;


/**
 * BeanInfo for an ExplicitButton.
 * 
 * @see sunw.demo.buttons.ExplicitButton
 */
public class HoverLabelBeanInfo extends SimpleBeanInfo {

    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor background =
			new PropertyDescriptor("background", beanClass);
	        PropertyDescriptor foreground =
			new PropertyDescriptor("foreground", beanClass);
	        PropertyDescriptor font =
			new PropertyDescriptor("font", beanClass);
            PropertyDescriptor hoverText =
			new PropertyDescriptor("hoverText", beanClass);
            PropertyDescriptor TipOffsetX =
            new PropertyDescriptor("TipOffsetX",beanClass);
            PropertyDescriptor TipOffsetY =
            new PropertyDescriptor("TipOffsetY",beanClass);
            PropertyDescriptor IsMoveable =
            new PropertyDescriptor("IsMoveable",beanClass);

            background.setBound(true);
            foreground.setBound(true);
            font.setBound(true);
            hoverText.setBound(true);
            TipOffsetX.setBound(true);
            TipOffsetY.setBound(true);
            IsMoveable.setBound(true);

            PropertyDescriptor rv[] = {background, foreground, font, hoverText,
                                       TipOffsetX,TipOffsetY,IsMoveable};
            return rv;
        } catch (IntrospectionException e) {
            throw new Error(e.toString());
        }
    }


    public int getDefaultPropertyIndex() {
	// the index for the "label" property
        return 3; 
    }


    public EventSetDescriptor[] getEventSetDescriptors() {
        try {

            EventSetDescriptor changed = new EventSetDescriptor(beanClass,
			"propertyChange",
			java.beans.PropertyChangeListener.class,
			"propertyChange");

            changed.setDisplayName("bound property change");
	
            EventSetDescriptor[] rv = {changed};
            return rv;
        } catch (IntrospectionException e) {
            throw new Error(e.toString());
        }
    }

    public java.awt.Image getIcon(int iconKind) {
	if (iconKind == BeanInfo.ICON_MONO_16x16 ||
	    iconKind == BeanInfo.ICON_COLOR_16x16 ) {
	    java.awt.Image img = loadImage("images/ExplicitButtonIcon16.gif");
	    return img;
	}
	if (iconKind == BeanInfo.ICON_MONO_32x32 ||
	    iconKind == BeanInfo.ICON_COLOR_32x32 ) {
	    java.awt.Image img = loadImage("images/ExplicitButtonIcon32.gif");
	    return img;
	}
	return null;
    }

    private final static Class beanClass = HoverLabel.class;
}

