package origjava.test;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.Serializable;
import java.util.Vector;

public class ImageButton extends Canvas implements Serializable , Timeable ,MouseListener,MouseMotionListener
{

    private boolean debug;
    private PropertyChangeSupport changes = new PropertyChangeSupport(this);
    private Vector pushListeners = new Vector();
    private String label;
    private String imageURL;
    private String frameClass;
    private boolean down;
    private boolean hasFocus;
    private boolean sized;

    static final int TEXT_XPAD = 12;
    static final int TEXT_YPAD = 8;
    private static String _sccsID;
    private static int _insetOffset;
    private static int _defaultThickness;
    private PaintedRectangle border;
    private int width;
    private int height;
    private int shadowThickness;
    private Image image;
    private boolean mouseEntered = false;
    private boolean mouseExited = false;
    private HoverLabel hoverLabel;
    private String hoverText = " Bob Leurck \n bobl@conceptsdyn.com ";
    protected TipTimer timer ;
    private long theTipDelay = 2500;
    private Container theFrame ;
    private boolean wasAdded = false;
    private boolean isWrapped = false;
    private Point wrapperPoint = new Point(0,0);
    private Container theWrapper;
    private Integer TipOffsetX = new Integer(5);
    private Integer TipOffsetY = new Integer (8);
    private Vector containerLocations;
    private Boolean isMoveable = new Boolean(false);

    public void mouseDragged(MouseEvent me) {
        if (getShadow() != SHADOW.RAISED)
            if (isInside(me.getX(), me.getY()) == false) //0)
                paint(SHADOW.RAISED);
        else if (isInside(me.getX(), me.getY()) == true)//1)
            paint(SHADOW.INSET);
    }

    public void mouseMoved(MouseEvent me) {
    }

    public void mouseClicked(MouseEvent me) {
    }

    public void mouseEntered(MouseEvent me) {
    }
    public void mouseExited(MouseEvent me) {
    }
    public void mousePressed(MouseEvent me) {
        paint(SHADOW.INSET);
        fireAction();
    }

    public void mouseReleased(MouseEvent me) {
        paint(SHADOW.RAISED);
    }

    public  void tick()
    {
    }
    public void createHoverLabel() {
        hoverLabel = new HoverLabel();
        hoverLabel.setText(hoverText);
    }
    public void setTheFrame(Container theFrm) {
        this.theFrame = theFrm;
        }
    public Container getTheFrame() {
        return theFrame;
        }



    public java.awt.Image loadImage(String resourceName) {
    try {
         java.net.URL url = getClass().getResource(resourceName);
         java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
         return tk.createImage((java.awt.image.ImageProducer) url.getContent());
        } catch (Exception ex) {
          return null;
        }
    }
    public ImageButton() {
        super();
        border = new PaintedRectangle(this);
        label = "Tip";
        setFont(new Font("Dialog", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        imageURL = "images/ExplicitButtonIcon32.gif";
        initImage(loadImage("images/ExplicitButtonIcon32.gif"));
        addMouseListener(this);
        addMouseMotionListener(this);
        createHoverLabel();
        hoverLabel.setVisible(false);
        addMouseListener(hoverLabel);

    }
    public ImageButton(Container theFrame) {
        this("Tip","images/ExplicitButtonIcon32.gif",theFrame);
    }
    public ImageButton(String l,String img, Container theFrame) {
        super();
        border = new PaintedRectangle(this);
        label = l;
        setFont(new Font("Dialog", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        imageURL = img;
        initImage(loadImage(img));
        addMouseListener(this);
        addMouseMotionListener(this);
        createHoverLabel();
        hoverLabel.setVisible(false);
        addMouseListener(hoverLabel);


    }
    public ImageButton(Image img, Frame f) {
        super();
        border = new PaintedRectangle(this);
        label = "Tip";
        setFont(new Font("Dialog", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        initImage(img);
        addMouseListener(this);
        addMouseMotionListener(this);
        createHoverLabel();
        hoverLabel.setVisible(false);


    }

    public ImageButton(Image img) {
        super();
        border = new PaintedRectangle(this);
        label = "Tip";
        setFont(new Font("Dialog", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        initImage(img);
        addMouseListener(this);
        addMouseMotionListener(this);
        createHoverLabel();
        hoverLabel.setVisible(false);

    }

    public void initImage(Image image)
    {
        setImageAndBorder(image, _defaultThickness);
    }

    public void setImageAndBorder(Image image, int i)
    {
        border.setThickness(shadowThickness = i);
        setImage(image);
        sizeToFit();
        repaint();
    }

    public void setImage(Image image)
    {
        if (image != null)
        {
            Util.waitForImage(this, this.image = image);
            width = image.getWidth(this) + 2 * shadowThickness - _insetOffset;
            height = image.getHeight(this) + 2 * shadowThickness - _insetOffset;
            return;
        }
        width = 2 * shadowThickness - _insetOffset;
        height = 2 * shadowThickness - _insetOffset;
    }
    /**
     * Returns the ImageButton's image.
     */
    public Image getImage() {
    return this.image;
    }

    public Dimension getMinimumSize()
    {
        return getPreferredSize();
    }

    public Dimension getPreferredSize()
    {
        if (image != null) return new Dimension(width, height);
        return new Dimension(5,5);
    }

    public SHADOW getShadow()
    {
        return border.getShadow();
    }


    /**
     * Paint the button: the label is centered in both dimensions.
     * 
     */
    public synchronized void paint(String label) {
    int width = getSize().width;
    int height = getSize().height;
    Graphics g = getGraphics();

    g.setColor(getBackground());

    g.setColor(getForeground());
    g.setFont(getFont());

    FontMetrics fm = g.getFontMetrics();
    g.drawString(label, (width - fm.stringWidth(label)) / 2, 
                  (height + fm.getMaxAscent() - fm.getMaxDescent()) / 2);
    }   


    public void paint(SHADOW sHADOW)
    {
        border.clearInterior();
        if (sHADOW == SHADOW.INSET) {
            if (image != null) getGraphics().drawImage(image, shadowThickness, shadowThickness, this);
        } else if (sHADOW == SHADOW.RAISED){
            if (image != null) getGraphics().drawImage(image, shadowThickness - _insetOffset, shadowThickness - _insetOffset, this);
        }
        border.paint(sHADOW);  
     }

    public void paint(Graphics g)
    {
        if (image != null) paint(border.getShadow());
        
    }

    public void setSize(int i, int j)
    {
        super.setSize(i, j);
        border.setSize(i, j);
    }

    public void setBounds(int i1, int j, int k, int i2)
    {
        super.setBounds(i1, j, k, i2);
        border.setSize(k, i2);
    }

    public boolean isInside(int i, int j)
    {
        Dimension dimension = getSize();
        if (i < 0 || i >= dimension.width || j < 0 || j >= dimension.height)
            return false;
        else
            return true;
    }

    public String getClassVersion()
    {
        return _sccsID;
    }

    //----------------------------------------------------------------------

    // Methods for registering/deregistering event listeners

    /**
     * The specified ActionListeners <b>actionPerformed</b> method will 
     * be called each time the button is clicked.  The ActionListener
     * object is added to a list of ActionListeners managed by 
     * this button, it can be removed with removeActionListener.
     * Note: the JavaBeans specification does not require ActionListeners
     * to run in any particular order.
     * 
     * @see #removeActionListener
     * @param l the ActionListener
     */      

    public synchronized void addActionListener(ActionListener l) {
	pushListeners.addElement(l);
    }

    /** 
     * Remove this ActionListener from the buttons internal list.  If the
     * ActionListener isn't on the list, silently do nothing.
     * 
     * @see #addActionListener
     * @param l the ActionListener
     */      
    public synchronized void removeActionListener(ActionListener l) {
	pushListeners.removeElement(l);
    }

    /**
     * The specified PropertyChangeListeners <b>propertyChange</b> method will
     * be called each time the value of any bound property is changed.
     * The PropertyListener object is addded to a list of PropertyChangeListeners
     * managed by this button, it can be removed with removePropertyChangeListener.
     * Note: the JavaBeans specification does not require PropertyChangeListeners
     * to run in any particular order.
     *
     * @see #removePropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void addPropertyChangeListener(PropertyChangeListener l) {
	changes.addPropertyChangeListener(l);
    }

    /** 
     * Remove this PropertyChangeListener from the buttons internal list.  
     * If the PropertyChangeListener isn't on the list, silently do nothing.
     * 
     * @see #addPropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void removePropertyChangeListener(PropertyChangeListener l) {
	changes.removePropertyChangeListener(l);
    }

    //----------------------------------------------------------------------


    /** 
     * This method has the same effect as pressing the button.
     * 
     * @see #addActionListener
     */      
    public void fireAction() {
	if (debug) {
	    System.err.println("Button " + getLabel() + " pressed.");
	}
	Vector targets;
	synchronized (this) {
	    targets = (Vector) pushListeners.clone();
	}
	ActionEvent actionEvt = new ActionEvent(this, 0, null);
	for (int i = 0; i < targets.size(); i++) {
	    ActionListener target = (ActionListener)targets.elementAt(i);
	    target.actionPerformed(actionEvt);
	}

        Component parent = getParent();
	if (parent != null) {
	   // parent.dispatchEvent(new MouseEvent(this,MouseEvent.MOUSE_PRESSED,nullWHEN,nullModifiers,));//postEvent(new Event(this, Event.MOUSE_DOWN, null));
	}
    }



    /** 
     * Enable debugging output.  Currently a message is printed each time
     * the button is clicked.  This is a bound property.
     * 
     * @see #getDebug
     * @see #addPropertyChangeListener
     */      
    public void setDebug(boolean x) {
	boolean old = debug;
	debug = x;
	changes.firePropertyChange("debug", new Boolean(old), new Boolean(x));
    }

    /** 
     * Returns true if debugging output is enabled.  
     * 
     * @see #setDebug
     */
    public boolean getDebug() {
	return debug;
    }


    /** 
     * Set the font size to 18 if true, 12 otherwise.  This property overrides
     * the value specified with setFontSize.  This is a bound property.
     * 
     * @see #isLargeFont
     * @see #addPropertyChangeListener
     */      
    public void setLargeFont(boolean b) {
	if (isLargeFont() == b) {
	    return;
	}
	int size = 12;
	if (b) {
	   size = 18;
	}
	Font old = getFont();
	setFont(new Font(old.getName(), old.getStyle(), size));
	changes.firePropertyChange("largeFont", new Boolean(!b), new Boolean(b));
    }

    /** 
     * Returns true if the font is "large" in the sense defined by setLargeFont.
     * 
     * @see #setLargeFont
     * @see #setFont
     */      
    public boolean isLargeFont() {
        if (getFont().getSize() >= 18) {
	    return true;
	} else {
	    return false;
	}
    }
   public Boolean getIsMoveable() {
       return isMoveable;
       }

   public void setIsMoveable(Boolean newValue) {
       Boolean oldValue = isMoveable;
       isMoveable = newValue;
       changes.firePropertyChange("isMoveable",oldValue,newValue);
       }
   /** 
     * Set the point size of the current font.  This is a bound property.
     * 
     * @see #getFontSize
     * @see #setFont
     * @see #setLargeFont
     * @see #addPropertyChangeListener
     */      
    public void setFontSize(int x) {
	Font old = getFont();
	setFont(new Font(old.getName(), old.getStyle(), x));
	changes.firePropertyChange("fontSize", new Integer(old.getSize()), new Integer(x));
    }

    /** 
     * Return the current font point size.
     * 
     * @see #setFontSize
     */
    public int getFontSize() {
         return getFont().getSize();
    }

    /**
     * Set the current font and change its size to fit.  This is a 
     * bound property.
     *
     * @see #setFontSize
     * @see #setLargeFont
     */
    public void setFont(Font f) {
	Font old = getFont();
	super.setFont(f);
	sizeToFit();
	changes.firePropertyChange("font", old, f);
    }

    /** 
     * Set the buttons label and change it's size to fit.  This is a 
     * bound property.
     * 
     * @see #getLabel
     */
    public void setLabel(String newLabel) {
	String oldLabel = label;
	label = newLabel;
	sizeToFit();
	changes.firePropertyChange("label", oldLabel, newLabel);
    }
    /** 
     * Set the buttons image and change it's size to fit.  This is a 
     * bound property.
     * 
     * @see #getImage
     */
    public void setImageURL(String newImage) {
	String oldImage = imageURL;
	imageURL = newImage;
    Image img =  loadImage(newImage);
    if (img != null ) {
        initImage(img);
	    changes.firePropertyChange("imageURL", oldImage, newImage);
        }
    }


        /** 

     * Set the buttons image and change it's size to fit.  This is a 
     * bound property.
     * 
     * @see #getImage
     */
    public void setFrameClass(String newValue) {
	String oldValue = frameClass;
	frameClass = newValue;
    changes.firePropertyChange("frameClass", oldValue, newValue);
    }

    public String getFrameClass() {
        return frameClass;
    }

    /**
     * Returns the buttons label.
     * 
     * @see #setLabel
     */
    public String getLabel() {
	return label;
    }

    /**
     * Returns the buttons image URL as string.
     * 
     * @see #setImageURL
     */
    public String getImageURL() {
	return imageURL;
    }

    private void sizeToFit() {
	Dimension d = getPreferredSize();
	setSize(d.width, d.height);
	Component p = getParent();
	if (p != null) {
	    p.invalidate();
	    p.doLayout();
	}
    }

    /**
     * Set the color the buttons label is drawn with.  This is a bound property.
     */
    public void setForeground(Color c) {
	Color old = getForeground();
	super.setForeground(c);
	changes.firePropertyChange("foreground", old, c);
    }


    /**
     * Set the color the buttons background is drawn with.  This is a bound property.
     */
    public void setBackground(Color c) {
	Color old = getBackground();
	super.setBackground(c);
	changes.firePropertyChange("background", old, c);
    }


    static 
    {
        _sccsID = "%W%\t%E% SMI";
        _insetOffset = 2;
        _defaultThickness = 2;
    }
}
