package origjava.test;
import java.awt.*  ;
import java.io.Serializable;
import java.awt.event.*;
import java.beans.*;
import java.io.Serializable;
import java.util.Vector;


public class toolPanel extends Panel implements Serializable
    {
      buttonImages buttonImg ;
      int top = 4;
      int y_space = 2;
      int x_space = 4;
      Color backColor = Color.lightGray;
      boolean debug = false;
      private PropertyChangeSupport changes = new PropertyChangeSupport(this);
      private Vector pushListeners = new Vector();

    /**
     * The panel which contains the toolbar contents.
     */
    protected toolBarPanel componentPanel;

    /**
     * The current location within the toolbar with which to place new components.
     */
    protected int topLeft = 2;//locationCounter = 3;

    /**
     * Flag to indicate whether or not inlcude a line at the top of the toolbar.
     * If this toolbar is below another toolbar, it should be set to false so that
     * there are not two lines between the toolbars.
     */
    protected boolean useTopBar = true;

    /**
     * A MediaTracker to automatically track images for the toolbar.
     */
    protected MediaTracker mediaTracker;

    /**
     * Flag to indicate whether or not inlcude a line at the top of the toolbar.
     * If this toolbar is below another toolbar, it should be set to false so that
     * there are not two lines between the toolbars.
     */
    public void useTopBar(boolean useTopBar) {
    this.useTopBar = useTopBar;
    if (useTopBar)
        componentPanel.setLocation(13, 15);
    else
        componentPanel.setLocation(13, 13);
    
    }


    /**
     * Track an image contained within the toolbar.
     *
     * @param image the image to track
     */
    public void trackImage(Image image) {
    mediaTracker.addImage(image, 0);
    }

    /**
     * Wait until all images tracked by the toolbar have loaded.
     *
     * @exception InterruptedException thrown if image loading is interrupted.
     */
    public void waitForImages() throws InterruptedException {
    mediaTracker.waitForAll();
    }

    /**
     * Try to wait until all images tracked by the toolbar have loaded.  If there
     * is an exception, continue processing.
     */
    public void tryToWaitForImages() {
    try {
        waitForImages();
    }
    catch (InterruptedException e) {
    }
    }

   /** 
     * Set the point size of the current font.  This is a bound property.
     * 
     * @see #getFontSize
     * @see #setFont
     * @see #setLargeFont
     * @see #addPropertyChangeListener
     */      
    public void setFontSize(int x) {
	Font old = getFont();
	setFont(new Font(old.getName(), old.getStyle(), x));
	changes.firePropertyChange("fontSize", new Integer(old.getSize()), new Integer(x));
    }

    /** 
     * Return the current font point size.
     * 
     * @see #setFontSize
     */
    public int getFontSize() {
         return getFont().getSize();
    }

    /**
     * Set the current font and change its size to fit.  This is a 
     * bound property.
     *
     * @see #setFontSize
     * @see #setLargeFont
     */
    public void setFont(Font f) {
	Font old = getFont();
	super.setFont(f);
	sizeToFit();
	changes.firePropertyChange("font", old, f);
    }
     /**
     * Set the color the buttons label is drawn with.  This is a bound property.
     */
    public void setForeground(Color c) {
	Color old = getForeground();
	super.setForeground(c);
	changes.firePropertyChange("foreground", old, c);
    }


    /**
     * Set the color the buttons background is drawn with.  This is a bound property.
     */
    public void setBackground(Color c) {
	Color old = getBackground();
	super.setBackground(c);
	changes.firePropertyChange("background", old, c);
    }



    public void setBackColor(Color c) {
        Color oldColor = backColor;
        backColor = c;
	    changes.firePropertyChange("backColor", oldColor, c);
        }
    public Color getBackColor() {
        return backColor;
        }
    public void setButtonImages(buttonImages newValue) {
        buttonImages oldValue = buttonImg;
        buttonImg = newValue;
   	    changes.firePropertyChange("buttonImages", oldValue, newValue);
        }
    public buttonImages getButtonImages() {
        return buttonImg;
        }
    public void setTopLeft(int i) {
        topLeft = i;
        }
    public int getTopLeft() {
        return topLeft;
        }
    public void setTop(int i) {
        top = i;
        }
    public int getTop() {
        return top;
        }
    public void setY_Space(int i) {
        y_space = i;
        }
    public int getY_Space() {
        return y_space;
        }
    public void setX_Space(int i) {
        x_space = i;
        }
    public int getX_Space() {
        return x_space;
        }
 protected void init() {
     setLayout(new BorderLayout());
     mediaTracker = new MediaTracker(this);
     setBackground(backColor);
     componentPanel = new toolBarPanel();

     int totButtons = buttonImg.getNumButtonImages();
     for (int i = 0; i < totButtons; i++) 
         {
          ImageButton l_butn = new ImageButton();
          l_butn.setImageURL(buttonImg.getUpsURL(i));
          mediaTracker.addImage(l_butn.getImage(), 0);
          componentPanel.add( l_butn );
          l_butn.setBounds(topLeft, top,
                         l_butn.getPreferredSize().width, l_butn.getPreferredSize().height);
          l_butn.setLocation(topLeft ,top );
          topLeft = l_butn.getPreferredSize().width + topLeft + x_space;

          }
          add(componentPanel);
          useTopBar(true); // Positions the component panel

        }
    public toolPanel(buttonImages bi) {
        super();
        buttonImg = bi;
        init();
        // need vector of images,listeners to pass to ImageButton

        }

    public toolPanel() {
        super();
        buttonImg = new buttonImages("toolBar");
        init();
      }

    public toolPanel(Frame f) {
        this();
      }
        
  public Dimension getPreferredSize() {
    Insets insets = getInsets();
    Dimension dimension1 = new Dimension(0, 0);
    int i = getComponentCount();
    Rectangle rectangle1 = new Rectangle(0, 0);
    for (int j = 0; j < i; j++)
    {
        Component component = getComponent(j);
        Dimension dimension2 = component.getPreferredSize();
        Rectangle rectangle2 = new Rectangle(component.getLocation());
        rectangle1.width = dimension2.width;
        rectangle1.height = dimension2.height;
        rectangle1 = rectangle1.union(rectangle2);
    }
    dimension1.width += insets.left + insets.right + rectangle1.width + i*x_space ;
    dimension1.height += insets.top + insets.bottom + rectangle1.height + y_space ;
    return  dimension1;

  }
  
    private void sizeToFit() {
	Dimension d = getPreferredSize();
	setSize(d.width, d.height);
	Component p = getParent();
	if (p != null) {
	    p.invalidate();
	    p.doLayout();
	}
    }

      public synchronized Dimension getMinimumSize() {
        Insets insets = getInsets();
        Dimension dimension1 = new Dimension(0, 0);
        int i = getComponentCount();
        Rectangle rectangle1 = new Rectangle(0, 0);
        for (int j = 0; j < i; j++)
        {
            Component component = getComponent(j);
                Dimension dimension2 = component.getMinimumSize();
                Rectangle rectangle2 = new Rectangle(component.getLocation());
                rectangle1.width = dimension2.width;
                rectangle1.height = dimension2.height;
                rectangle1 = rectangle1.union(rectangle2);
        }
        dimension1.width += insets.left + insets.right + rectangle1.width + i*x_space;
        dimension1.height += insets.top + insets.bottom + rectangle1.height + y_space;
        return dimension1;

      }
 
    // Methods for registering/deregistering event listeners

     

    public synchronized void addActionListener(ActionListener l) {
	pushListeners.addElement(l);
    }

     
    public synchronized void removeActionListener(ActionListener l) {
	pushListeners.removeElement(l);
    }

    /**
     * The specified PropertyChangeListeners <b>propertyChange</b> method will
     * be called each time the value of any bound property is changed.
     * The PropertyListener object is addded to a list of PropertyChangeListeners
     * managed by this button, it can be removed with removePropertyChangeListener.
     * Note: the JavaBeans specification does not require PropertyChangeListeners
     * to run in any particular order.
     *
     * @see #removePropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void addPropertyChangeListener(PropertyChangeListener l) {
	changes.addPropertyChangeListener(l);
    }

    /** 
     * Remove this PropertyChangeListener from the buttons internal list.  
     * If the PropertyChangeListener isn't on the list, silently do nothing.
     * 
     * @see #addPropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void removePropertyChangeListener(PropertyChangeListener l) {
	changes.removePropertyChangeListener(l);
    }

    //----------------------------------------------------------------------


    /** 
     * This method has the same effect as pressing the button.
     * 
     * @see #addActionListener
     */      
    public void fireAction() {
	if (debug) {
	    System.err.println("toolPanel action");
	}
	Vector targets;
	synchronized (this) {
	    targets = (Vector) pushListeners.clone();
	}
	ActionEvent actionEvt = new ActionEvent(this, 0, null);
	for (int i = 0; i < targets.size(); i++) {
	    ActionListener target = (ActionListener)targets.elementAt(i);
	    target.actionPerformed(actionEvt);
	}

        Component parent = getParent();
	if (parent != null) {
	   // parent.dispatchEvent(new MouseEvent(this,MouseEvent.MOUSE_PRESSED,nullWHEN,nullModifiers,));//postEvent(new Event(this, Event.MOUSE_DOWN, null));
	}
    }



    /** 
     * Enable debugging output.  Currently a message is printed each time
     * the button is clicked.  This is a bound property.
     * 
     * @see #getDebug
     * @see #addPropertyChangeListener
     */      
    public void setDebug(boolean x) {
	boolean old = debug;
	debug = x;
	changes.firePropertyChange("debug", new Boolean(old), new Boolean(x));
    }

}
