#*****************************************************************
#	Virtual Theater
#		open the door
#		Programmed by TN Feb.20,1996
#	(c)Copyright 1996 Sony Corporation. All rights reserved.
#
#*****************************************************************
# Init the door
#-----------------------------------------------------------------
#*****************************************************************
proc vs_H_InitDoor { obj event userdata } {
	vsNewVariable $obj count 0	;# angle count
	vsNewVariable $obj id 0		;# EventHandler ID
	vsNewVariable $obj flg 0	;# door status
}
proc vs_H_InitDoorReverse { obj event userdata } {
	vsNewVariable $obj count 0	;# angle count
	vsNewVariable $obj id 0		;# EventHandler ID
	vsNewVariable $obj flg 2	;# door status(reverse)
}

#*****************************************************************
# Pick the door (Event)
#-----------------------------------------------------------------
# door status flg
#	0: close
#	1: opening
#	2: open
#	3: closing
#*****************************************************************
proc vs_H_Event_PickDoor { obj event userdata } {
	global vsTclScript vsPeriodicTask vsContinue

	set flg [ vsGetVariable $obj flg ]

	if { $flg == 0 } {
		vsSetVariable $obj flg 1
		set id [vsAddTimeOutHandler $obj 300 $vsTclScript "" vs_H_PeriodicOpenDoor 0 $vsPeriodicTask]
		vsSetVariable $obj id $id
	} elseif { $flg == 2 } {
		vsSetVariable $obj flg 3
		set id [vsAddTimeOutHandler $obj 300 $vsTclScript "" vs_H_PeriodicOpenDoor 0 $vsPeriodicTask]
		vsSetVariable $obj id $id
	}
	return $vsContinue
}

#*****************************************************************
# Open the Door (Periodic)
#-----------------------------------------------------------------
#	open/close 5 times to rotate with 16degree.
#*****************************************************************
proc vs_H_PeriodicOpenDoor { obj event userdata } {
	global vsContinue vsStop
        global vsCSLocal vsRelative

	set count [ vsGetVariable $obj count ]
	set flg [ vsGetVariable $obj flg ]

	if { $flg == 1 } {
	        vsObjectRotateAngle $obj  0.0 -16.0 0.0 $vsCSLocal $vsRelative
	} elseif { $flg == 3 } {
	        vsObjectRotateAngle $obj  0.0 +16.0 0.0 $vsCSLocal $vsRelative
	}
	incr count
	if { $count > 4 } {
		vsSetVariable $obj count 0

		if { $flg == 1 } {
			vsSetVariable $obj flg 2
		} else {
			vsSetVariable $obj flg 0
		}
		set id [ vsGetVariable $obj id ]
		vsRemoveTimeOutHandler $obj $id
		return $vsStop
	}
	vsSetVariable $obj count $count

	return $vsContinue
}

