#*****************************************************************
#	Virtual Theater
#		move the golden seat
#		Programmed by TN Feb.20,1996
#	(c)Copyright 1996 Sony Corporation. All rights reserved.
#
#*****************************************************************
# Init the seat
#-----------------------------------------------------------------
#*****************************************************************
proc vs_H_InitSeat { obj event userdata } {
        global vsCSWorld vsAbsolute

	vsNewVariable $obj count 0	;# angle count
	vsNewVariable $obj id 0		;# EventHandler ID
	vsNewVariable $obj flg 0	;# door status

	# change camera toward the doors.
	set camera [ vsGetPerson ]
        vsRotateAngle $camera 0.0 180.0 0.0 $vsCSWorld $vsAbsolute
}
#*****************************************************************
# Move Y-axis
#-----------------------------------------------------------------
#*****************************************************************
proc vs_H_PeriodicMoveSeat { obj event userdata } {
	global vsContinue vsStop
        global vsCSWorld vsRelative

	set count [ vsGetVariable $obj count ]
	if { $count < 5 } {
		vsTranslate $obj 0.0 0.1 0.0 $vsCSWorld $vsRelative
	} else {
		vsTranslate $obj 0.0 -0.1 0.0 $vsCSWorld $vsRelative
	}
	incr count
	if { $count >= 10 } {
		set count 0
	}
	vsSetVariable $obj count $count

	return $vsContinue
}
#*****************************************************************
# Sit down
#-----------------------------------------------------------------
#*****************************************************************
proc vs_H_Event_PickSeat { obj event userdata } {
        global vsCSLocal vsRelative vsSuccess vsCSWorld vsAbsolute
        global vsContinue vsStop
	global vsSuccess vsPick vsTclScript 
	global vsObjAttrComment 

	# sit down to the reserved golden seat
	# move the camera to seat
	set camera [ vsGetPerson ]
	vsTranslate $camera 0.2 0.8 -5.9 $vsCSWorld $vsAbsolute
        vsRotateAngle $camera 0.0 180.0 0.0 $vsCSWorld $vsAbsolute

	# add video to screen

	set screen_obj [ vsGetObjByName screen ]         
	set ret [vsAddEventHandler $screen_obj $vsPick \
		$vsTclScript "scripts/seat.tcl" "vs_H_Event_PickScreen" "data"]
	if {$ret != $vsSuccess} { 
#        	vsWarning "vsAddEventHandler failed"
	}
	vsSetObjAttribute $screen_obj $vsObjAttrComment "play VIDEO CLIP"

	return $vsContinue
}

#*****************************************************************
# Pick the Screen to play the video
#-----------------------------------------------------------------
#*****************************************************************
proc vs_H_Event_PickScreen { obj event userdata } {
	global vsContinue

	vsWarning "video"

	return $vsContinue
}