#################################
# header
##################################
vstkInit
##################################
# for rotate action
##################################
set  rotcount 0
##################################
# true then curnrent person is sleeping
##################################
set  sleeping 0

#***********************************
# local functions
#***********************************
image create photo hello_bmp -file $tk_library/../ppm/hello1.ppm -palette 8/8/8
image create photo smile_bmp -file $tk_library/../ppm/smile1.ppm -palette 8/8/8
image create photo umm_bmp -file $tk_library/../ppm/umm1.ppm -palette 8/8/8
image create photo wao_bmp -file $tk_library/../ppm/wao1.ppm -palette 8/8/8
image create photo wooo_bmp -file $tk_library/../ppm/wooo1.ppm -palette 8/8/8
image create photo sad_bmp -file $tk_library/../ppm/sad1.ppm -palette 8/8/8
image create photo sleep_bmp -file $tk_library/../ppm/sleep.ppm -palette 8/8/8
image create photo active_bmp -file $tk_library/../ppm/active.ppm -palette 8/8/8
image create photo bye_bmp -file $tk_library/../ppm/bye.ppm -palette 8/8/8

image create photo rot90_bmp -file $tk_library/../ppm/36.ppm -palette 8/8/8
image create photo rot180_bmp -file $tk_library/../ppm/180.ppm -palette 8/8/8
image create photo rot360_bmp -file $tk_library/../ppm/360.ppm -palette 8/8/8
image create photo lrot90_bmp -file $tk_library/../ppm/l36.ppm -palette 8/8/8
image create photo lrot180_bmp -file $tk_library/../ppm/l180.ppm -palette 8/8/8

####################################
# avatarmenu management.
####################################
proc menuManage {notuse notuse1 type} {

    global vsMenuAvatarColor
    if { "in" == "$type" } {
        set v 1
    } {
        set v 0
    }
    if {"" != "[info command vsMenuStatus]"} {
        vsMenuStatus $vsMenuAvatarColor $v
    }
}

####################################
# set the button state.
####################################
proc SetState {t} {
    foreach d { .sf.sac.hello .sf.sac.smile .sf.sac.umm
                .sf.sac.wao  .sf.sac.wooo .sf.sac.sad  .sf.sac.bye
                .sf.r.1.rot90 .sf.r.2.rot180
                .sf.r.1.rot_90 .sf.r.2.rot_180 .sf.r.3.rot360 } {
        if {$t} {
            set mode normal
        } {
            set mode disabled
        }
        $d configure -state $mode
    }
}

##############################################
# SendAction
# Set  specified object's kinemation frame
# to specified no on all the clients
# in aura.
# If [ev] not 0, this function called by
# timeouthandler to animate the specified object.
##############################################
proc SendAction {obj ev action} {
    global vscpAllClientsInAuraExceptMe sleeping

    if {$sleeping && $ev && "$action" == "normal"} {
    	return
    }
    switch $action {
	hello  { set arg "3 S3" }
	smile { set arg "4 S4" }
	umm  { set arg "7 S7" }
	wao   { set arg "6 S6" }
	wooo { set arg "5 S5" }
	sad    { set arg "8 S8" }
	bye0  { set arg "10 {}" }
	bye1  { set arg "11 {}" }
	sleep { set arg "12 {}" }
	normal {set arg  "0 {}"}
	default {return}
    }
    vscpSendApplSpecificMsgWithDist [vsGetPerson] ActOnClients "$arg" \
           		$vscpAllClientsInAuraExceptMe
}

##############################################
# send_action :
##############################################
proc send_action {arg} {
   global vsSporadicTask vsTclScript

    if {[regexp {^rot} "$arg"]} {
	switch $arg {
	    rot90 { act_rotate  "-" "0" }
	    rot180 { act_rotate "-"  "5" }
	    rot360 { act_rotate "-"  "10" }
	    rot_90 { act_rotate  "+" "0" }
	    rot_180 { act_rotate "+"  "5" }
	    rot_360 { act_rotate "+"  "10" }
	}
    }  {
	set person [vsGetPerson]
	switch $arg {
	    sleep { TglSleep }
            bye0 {
                SendAction [vsGetPerson] 0 $arg
		vsAddTimeOutHandler $person 1000 $vsTclScript "" \
			SendAction "bye1" $vsSporadicTask
		vsAddTimeOutHandler $person 6000 $vsTclScript "" \
			SendAction "normal" $vsSporadicTask
            }
	    default {
		SendAction [vsGetPerson] 0 $arg
		vsAddTimeOutHandler $person 3000 $vsTclScript "" \
			SendAction "normal" $vsSporadicTask
	    }
        }
    }
}
##############################################
# TglSleep
##############################################
proc TglSleep {} {
    global sleeping
    if {! $sleeping} {
	set sleeping 1
	SendAction  [vsGetPerson] 0 sleep
	SetState 0
        .sleep configure -image sleep_bmp
    } {
	set sleeping 0
	SendAction [vsGetPerson] 0 normal
	SetState 1
        .sleep configure -image active_bmp
    }
    if {"" != "[info command sendSetColor]"} {
        sendSetColor [vsGetPerson] 0 0
    }
    if {"" != "[info command vscpSendKeepConnection]"} {
        vscpSendKeepConnection $sleeping
    }
}
##############################################
##############################################
proc rotate_obj {obj ev da} {
    global  vsStop vsContinue vsCSLocal vsRelative rotcount

    if { "$da" == "-" } {
        set r -36.0
    } {
        set r 36.0
    }
    vscpRotateAngle $obj 0.0 $r 0.0 $vsCSLocal $vsRelative
    set rotcount [ expr $rotcount - 1 ]
    if { $rotcount == 0 } {
        return $vsStop
    } else {
        return $vsContinue
    }
}
##############################################
##############################################
proc act_rotate { mode udata } {
    global vsCSLocal vsRelative rotcount vsTclScript vsPeriodicTask

    if { $rotcount != 0 } return;
    set p [vsGetPerson]

    if {! $p} {return ;  }
    if {"$mode" == "-" } {
        set r -36.0
    } {
        set r 36.0
    }
    vscpRotateAngle $p 0.0 $r 0.0 $vsCSLocal $vsRelative
    if { $udata == "0" } {
        return;
    }
    if { $udata == "5" } {
        set rotcount 4
        vsAddTimeOutHandler $p 400 $vsTclScript "" rotate_obj \
                     $mode $vsPeriodicTask
    } else {
        set rotcount 9
        vsAddTimeOutHandler $p 500 $vsTclScript "" rotate_obj \
                     $mode $vsPeriodicTask
    }
}
#############################################
# create the person action panel
#############################################
proc ShowWindow {args} {# xf ignore me 7

  # Window manager configurations
  global tkVersion
  wm positionfrom . user
  wm sizefrom . ""
  wm maxsize . 1280 1024
  wm title . {Action}
  wm protocol . WM_DELETE_WINDOW "wm deiconify ."


  if { "" == [info command .sleep] } {
    button .sleep  -bg black -relief flat -image active_bmp -command "send_action sleep"

    frame .sf ; # frame of action button
    frame .sf.sac ; # frame of action button
    frame .sf.r ; # frame of rotate button
    frame .sf.r.1 ; # frame of rotate button
    frame .sf.r.2 ; # frame of rotate button
    frame .sf.r.3 ; # frame of rotate button

    button .sf.sac.hello   -bg black -relief flat -image hello_bmp -command "send_action hello"
    button .sf.sac.smile   -bg black -relief flat -image smile_bmp -command "send_action smile"
    button .sf.sac.umm     -bg black -relief flat -image umm_bmp -command "send_action umm"
    button .sf.sac.wao     -bg black -relief flat -image wao_bmp -command "send_action wao"
    button .sf.sac.wooo    -bg black -relief flat -image wooo_bmp -command "send_action wooo"
    button .sf.sac.sad     -bg black -relief flat -image sad_bmp -command "send_action sad"

    button .sf.sac.bye  -bg black -relief flat   -image bye_bmp -command  "send_action bye0"

    button .sf.r.1.rot90    -bg black -relief flat -image rot90_bmp -command "send_action rot_90"
    button .sf.r.1.rot_90   -bg black -relief flat -image lrot90_bmp -command "send_action rot90"
    button .sf.r.2.rot180   -bg black -relief flat -image rot180_bmp -command "send_action rot_180"
    button .sf.r.2.rot_180  -bg black -relief flat -image lrot180_bmp -command "send_action rot180"
    button .sf.r.3.rot360   -bg black -relief flat -image rot360_bmp -command "send_action rot360"


    pack .sleep .sf -side left
    pack .sf.sac .sf.r
    pack .sf.r.1 .sf.r.2 .sf.r.3 -side left  -ipadx .6
    pack .sf.sac.hello .sf.sac.smile .sf.sac.wao .sf.sac.wooo \
	 .sf.sac.umm .sf.sac.sad .sf.sac.bye -side left
    pack .sf.r.1.rot90 .sf.r.1.rot_90  -side left
    pack .sf.r.2.rot180 .sf.r.2.rot_180  -side left
    pack .sf.r.3.rot360   -side left
  }
}

ShowWindow
wm deiconify .

#*********************************************
# remote functions
#*********************************************
##############################################
# ActOnClients :
# this function called by vscpSendApplSpecificMsgWithDist() in SendActiom().
# set the specified object's kinemation frame to specified no.
# and if specified, play the sound.
##############################################
proc ActOnClients {person notuse args} {
    global vsTclScript vsSporadicTask vsObjAttrName
    global vsObjAttrNode vsObjAttrVisible vsTrue vsSuccess

    set args [lindex $args 0]
    set kinframe [lindex $args 0]
    set soundPostfix [lindex $args 1]

    set ret [ vsGetObjAttribute $person $vsObjAttrNode node]
    if {$ret != $vsSuccess} {
        return
    }
    if { $soundPostfix != "" } {
      set ret [ vsGetObjAttribute $person $vsObjAttrName name ]
      vsPlayAmbientSoundByName ${name}${soundPostfix} 0
    }
    set switchkin [vsGetObjByName $person "KINBODY" -r]
    if { $switchkin == 0 } {
      vsMessageDlg "Can't find KINBODY"
      return
    }
    set body [lindex [vsGetObjChildren $switchkin] 0]
    if { $body != "" } {
      vsKinSetFrame $body $kinframe
    }
}
################## end of smile.tcl ##################

