import com.ibm.xml.parser.FormatPrintVisitor;
import com.ibm.xml.parser.NonRecursivePreorderTreeTraversal;
import com.ibm.xml.parser.Visitor;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;


public class SQLX 
{
	public static void main(String argv[])
	{
	String xmlin=null;
	if(argv.length > 0)
		xmlin=argv[0];
	if(xmlin==null)
	{
		System.out.println("SQL { input filename} {variable1=value1} ... {variablenn=valuenn}");
		System.out.println("where {input filename} is the filename of a SQL XML file [required]");
		System.out.println("where {variablenn=valuenn} is a variable=value param pair used to dynamically  substitute values into the SQL statement [optional]");
		System.out.println("\nExample:SQLX sample.xml: salary=40000");
		System.out.println("Would use the SQL XML file named 'sample.xml', subtituting the variable named ':salary' with a value of '40000'");
		System.out.println("\nSQLX resultset is written to {input filename}.out");
		return;
	}
	
	try
	{
		SQLXParser parser=new SQLXParser(xmlin);
		parser.getInputSpecElements().override(argv);
		SQLXResults results=new SQLXResults(parser);
		Visitor visitor=new FormatPrintVisitor(new PrintWriter(System.out));
		NonRecursivePreorderTreeTraversal tree=new NonRecursivePreorderTreeTraversal(visitor);
		tree.traverse(results.getDoc());
		visitor=new FormatPrintVisitor(new PrintWriter(openFile(xmlin+".out")));
		tree=new NonRecursivePreorderTreeTraversal(visitor);
		tree.traverse(results.getDoc());
	}
	catch(Exception exec)
	{
		System.out.println(exec.toString());
	}
	}		

	public static OutputStream openFile(String filename) throws java.io.IOException
	{
		File file=new File(filename);
		FileOutputStream fos=new FileOutputStream(file);
		return new DataOutputStream(fos);
	}
}
