import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

public class SQLXResults
{

private ResultSet resultSet=null;
private SQLXDocument doc=null;

public SQLXResults(SQLXParser parser) throws java.sql.SQLException, ClassNotFoundException
{
	 String sql=parser.getExecuteElement().getSql();
	if(parser.getInputSpecElements()!=null)
		sql=parser.getInputSpecElements().substitute(sql);
	execute(parser.getExecuteElement().getDriver(),
		parser.getExecuteElement().getUrl(),
		parser.getExecuteElement().getUser(),
		parser.getExecuteElement().getPassword(),sql);
}


public SQLXResults(String aDriver,String aUrl,String aUser,String aPassword,String aSql) throws java.sql.SQLException, ClassNotFoundException
{
	execute(aDriver,aUrl,aUser,aPassword,aSql);
}


public void execute(String aDriver,String aUrl,String aUser,String aPassword,String aSql) throws java.sql.SQLException, ClassNotFoundException
{
	Class.forName(aDriver);
	Connection connection=DriverManager.getConnection(aUrl,aUser,aPassword);
	Statement statement=connection.createStatement();
	statement.execute(aSql);
	setResultset(statement.getResultSet());
	getDoc();
}

public SQLXDocument getDoc() throws java.sql.SQLException
{
        if(doc==null)
                doc=new SQLXDocument(this);
        return doc;
}

public ResultSet getResultSet()
{
        return resultSet;
}

public void setResultset(ResultSet param)
{
        resultSet=param;
}           
}
