<?xml version="1.0"?>

<HTML xmlns:xsl="http://www.w3.org/TR/WD-xsl">
  <HEAD>
    <STYLE>
      BODY {margin:0}
      .bg {font:8pt Verdana; background-color:purple; color:white}
      H1 {font:bold 14pt Verdana; width:100%; margin-top:1em}
      .row {font:8pt Verdana; border-bottom:1px solid #CC88CC}
      .header {font:bold 9pt Verdana; cursor:hand; padding:2px; border:2px outset gray}
    </STYLE>
    <XML id="portfolio">
      <xsl:apply-templates select="portfolio">
        <xsl:template><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-templates/></xsl:copy></xsl:template>
      </xsl:apply-templates>
    </XML>
    <XML id="sorted"><xsl:eval/></XML>
    <XML id="sortStocks" src="sort-stocks.xsl"><xsl:eval/></XML>
  </HEAD>
  
  <SCRIPT><xsl:comment><![CDATA[
    function sort(field)
    {
      sortField.value=field;
      sorted.XMLDocument.loadXML(portfolio.transformNode(sortStocks.XMLDocument));
    }
  ]]></xsl:comment></SCRIPT>

  <SCRIPT for="window" event="onload"><xsl:comment><![CDATA[
    sortField = sortStocks.selectSingleNode("//@order-by");
    sort("price");
  ]]></xsl:comment></SCRIPT>
  
  <BODY>
    <TABLE width="100%" cellspacing="0">
      <TR><TD class="bg"/><TD class="bg"><H1>Stock Index for <xsl:value-of select="portfolio/date"/></H1></TD></TR>
      <TR>
        <TD class="bg" width="120" valign="top">
          <P>Click on the column headings to sort by that field.</P>
          <P>Note that sorting is by string value only and not numeric</P>
        </TD>
        <TD valign="top">
          <TABLE class="listing" datasrc="#sorted">
            <THEAD>
              <TD width="200"><DIV class="header" onClick="sort('name')">Company</DIV></TD>
              <TD width="80"><DIV class="header" onClick="sort('symbol')">Symbol</DIV></TD>
              <TD width="80"><DIV class="header" onClick="sort('price')">Price</DIV></TD>
              <TD width="80"><DIV class="header" onClick="sort('change')">Change</DIV></TD>
              <TD width="80"><DIV class="header" onClick="sort('percent')">%Change</DIV></TD>
            </THEAD>
            <TR>
              <TD><DIV class="row" datafld="name"><xsl:eval/></DIV></TD>
              <TD><DIV class="row" datafld="symbol"><xsl:eval/></DIV></TD>
              <TD><DIV class="row" datafld="price" STYLE="text-align:right"><xsl:eval/></DIV></TD>
              <TD><DIV class="row" datafld="change" STYLE="text-align:right"><xsl:eval/></DIV></TD>
              <TD><DIV class="row" datafld="percent" STYLE="text-align:right"><xsl:eval/></DIV></TD>
            </TR>
          </TABLE>
        </TD>
      </TR>
    </TABLE>    
  </BODY>
</HTML>