<?xml version="1.0"?>

<!-- Generic stylesheet for viewing XML -->
<xsl:template xmlns:xsl="http://www.w3.org/TR/WD-xsl">

  <DIV STYLE="font-family:Courier; font-size:10pt; margin-bottom:2em">
    <xsl:apply-templates select="."/>
  </DIV>
  
  <xsl:templates>
    <xsl:template><xsl:apply-templates/></xsl:template>

    <xsl:template match="*">
      <DIV STYLE="margin-left:1em; color:gray">
        &lt;<xsl:nodeName/><xsl:apply-templates for="@*"/>/&gt;
      </DIV>
    </xsl:template>

    <xsl:template match="*[node()]">
      <DIV STYLE="margin-left:1em">
        <SPAN STYLE="color:gray">&lt;<xsl:nodeName/><xsl:apply-templates select="@*"/>&gt;</SPAN><xsl:apply-templates select="node()"/><SPAN STYLE="color:gray">&lt;/<xsl:nodeName/>&gt;</SPAN>
      </DIV>
    </xsl:template>

    <xsl:template match="@*">
      <SPAN STYLE="color:navy"> <xsl:nodeName/>="<SPAN STYLE="color:black"><xsl:get-value /></SPAN>"</SPAN>
    </xsl:template>

    <xsl:template match="pi()">
      <DIV STYLE="margin-left:1em; color:maroon">&lt;?<xsl:nodeName/><xsl:apply-templates select="@*"/>?&gt;</DIV>
    </xsl:template>

    <xsl:template match="cdata()"><pre>&lt;![CDATA[<xsl:get-value />]]&gt;</pre></xsl:template>

    <xsl:template match="textnode()"><xsl:get-value /></xsl:template>
  </xsl:templates>
</xsl:template>
