// Copyright  1998 Sun Microsystems, Inc. All Rights Reserved.
//
package examples.activation; 

import java.rmi.*;
import java.rmi.activation.*;

public class MyClass implements examples.activation.AnotherRemoteInterface {

    private String result = null;

    // The constructor for activation and export; this constructor is
    // called by the method ActivationInstantiator.newInstance during
    // activation, to construct the object.
    //
    public MyClass(ActivationID id, MarshalledObject data) 
	throws RemoteException {

	// Register the object with the activation system
	// then export it on an anonymous port
	//
	Activatable.exportObject(this, id, 0);
    }

    // Define the method declared in AnotherRemoteInterface
    // to accept a String, modify it, and return it to the client
    //
    public String calltheServer(String takeThis) throws RemoteException {

	result = takeThis + "I'm here!";
	return result;
    }

}
