// Fig. 6.5: Time3.java
// Time3 class definition
package com.deitel.jhtp2.ch06;   // place Time3 in a package
import java.text.DecimalFormat;  // used for number formatting

public class Time3 {
   private int hour;     // 0 - 23
   private int minute;   // 0 - 59
   private int second;   // 0 - 59

   // Time3 constructor initializes each instance variable
   // to zero. Ensures that Time object starts in a 
   // consistent state.
   public Time3() { setTime( 0, 0, 0 ); }

   // Time3 constructor: hour supplied, minute and second
   // defaulted to 0.
   public Time3( int h ) { setTime( h, 0, 0 ); }

   // Time3 constructor: hour and minute supplied, second
   // defaulted to 0.
   public Time3( int h, int m ) { setTime( h, m, 0 ); }

   // Time3 constructor: hour, minute and second supplied.
   public Time3( int h, int m, int s ) { setTime( h, m, s ); }

   // Set Methods
   // Set a new Time3 value using military time. Perform 
   // validity checks on the data. Set invalid values 
   // to zero.
   public void setTime( int h, int m, int s )
   {
      setHour( h );    // set the hour
      setMinute( m );  // set the minute
      setSecond( s );  // set the second
   }

   // set the hour 
   public void setHour( int h ) 
      { hour = ( ( h >= 0 && h < 24 ) ? h : 0 ); }

   // set the minute 
   public void setMinute( int m ) 
      { minute = ( ( m >= 0 && m < 60 ) ? m : 0 ); }

   // set the second 
   public void setSecond( int s ) 
      { second = ( ( s >= 0 && s < 60 ) ? s : 0 ); }

   // Get Methods
   // get the hour
   public int getHour() { return hour; }

   // get the minute
   public int getMinute() { return minute; }

   // get the second
   public int getSecond() { return second; }

   // Convert time to String in military-time format
   public String toMilitaryString()
   {
      DecimalFormat twoDigits = new DecimalFormat( "00" );

      return twoDigits.format( hour ) +
             twoDigits.format( minute );
   }

   // Convert time to String in standard-time format
   public String toString()
   {
      DecimalFormat twoDigits = new DecimalFormat( "00" );
      
      return ( ( hour == 12 || hour == 0 ) ? 12 : hour % 12 ) +
             ":" + twoDigits.format( minute ) +
             ":" + twoDigits.format( second ) +
             ( hour < 12 ? " AM" : " PM" );
   }
}
