// Fig. 18.11: BitShift.java
// Using the bitwise shift operators.
import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

public class BitShift extends Applet
             implements ActionListener {
   private TextField value, bits;
   private Button left, rightSign, rightZero;

   public void init()
   {
      add( new Label( "Integer to shift " ) );
      value = new TextField( 12 );
      value.addActionListener( this );
      add( value );      

      bits = new TextField( 33 );
      bits.setEditable( false );
      add( bits );      

      left = new Button( "<<" );
      left.addActionListener( this );
      add( left );      

      rightSign = new Button( ">>" );
      rightSign.addActionListener( this );
      add( rightSign );      

      rightZero = new Button( ">>>" );
      rightZero.addActionListener( this );
      add( rightZero );      
   }

   public void actionPerformed( ActionEvent e )
   {
      int val = Integer.parseInt( value.getText() );

      if ( e.getSource() == left )
         val <<= 1;
      else if ( e.getSource() == rightSign ) 
         val >>= 1;
      else if ( e.getSource() == rightZero )
         val >>>= 1;

      value.setText( Integer.toString( val ) );
      bits.setText( getBits( val ) );
   }

   public String getBits( int value )
   {
      int displayMask = 1 << 31;
      StringBuffer buf = new StringBuffer( 35 );

      for ( int c = 1; c <= 32; c++ ) {
         buf.append( ( value & displayMask ) == 0 ? '0' : '1' );
         value <<= 1;

         if ( c % 8 == 0 )
            buf.append( ' ' );
      }

      return buf.toString();
   }
}

