// Fig. 18.15: BitSetTest.java                                
// Using a BitSet to demonstrate the Sieve of Eratosthenes.
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class BitSetTest extends Applet
             implements ActionListener {
   private BitSet sieve;
   private Panel inputPanel;
   private TextField input;
   private TextArea primes;

   public void init()
   {
      sieve = new BitSet( 1024 );

      setLayout( new BorderLayout() );
      inputPanel = new Panel();

      inputPanel.add( new Label( "Enter a value from 1 to 1023" ) );
      input = new TextField( 10 );
      input.addActionListener( this );
      inputPanel.add( input );
      add( inputPanel, BorderLayout.NORTH );

      primes = new TextArea();
      add( primes, BorderLayout.CENTER );

      // set all bits from 1 to 1023
      int size = sieve.size();

      for ( int i = 1; i < size; i++ )
         sieve.set( i );

      // perform Sieve of Eratosthenes
      int finalBit = ( int ) Math.sqrt( sieve.size() );

      for ( int i = 2; i < finalBit; i++ ) 
         if ( sieve.get( i ) ) 
            for ( int j = 2 * i; j < size; j += i ) 
               sieve.clear( j );

      int counter = 0;

      for ( int i = 1; i < size; i++ )
         if ( sieve.get( i ) ) {
            primes.append( String.valueOf( i ) );
            primes.append(
               ++counter % 7 == 0 ? "\n" : "\t" );
         }            
   }

   public void actionPerformed( ActionEvent e )
   {
      int val = Integer.parseInt( input.getText() );

      if ( sieve.get( val ) )
         showStatus( val + " is a prime number" );
      else
         showStatus( val + " is not a prime number" );
   }
}
