/*
 * @(#)Ellipses.java	1.9 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package demos.Arcs_Curves;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Ellipse2D;
import J2DCanvas;

/**
 * Ellipse2D 25 animated expanding ellipses.
 */
public class Ellipses extends J2DCanvas {

    private Ellipse2D.Float[] ellipses;
    private Color colors[] = { Color.blue, Color.cyan, Color.green,
			Color.magenta, Color.orange, Color.pink,
			Color.red, Color.yellow, Color.lightGray,
			Color.white };
    private double esize[];
    private float estroke[];
    private double maxSize;


    public Ellipses() {
       	setBackground(Color.black);

	ellipses = new Ellipse2D.Float[25];
        for (int i = 0; i < ellipses.length; i++)
            ellipses[i] = new Ellipse2D.Float();
        esize = new double[ellipses.length];
        estroke = new float[ellipses.length];
	runnable = true;
    }


    public void setup(int i, double size) {
         esize[i] = size;
         estroke[i] = 1.0f;
         double x = Math.random() * (w-(maxSize/2));
         double y = Math.random() * (h-(maxSize/2));
         ellipses[i].setFrame(x, y, size, size);
    }


    public void drawDemo(Graphics2D g2) {

	if (newBufferedImage) {
            maxSize = w/10;
	    for (int i = 0; i < ellipses.length; i++ )
	        setup(i, maxSize * Math.random());
	}

        for (int i = 0; i < ellipses.length; i++) {
	    g2.setColor(colors[i%colors.length]);
            g2.setStroke(new BasicStroke(estroke[i]));
            estroke[i] = estroke[i] + 0.025f;
            g2.draw(ellipses[i]);
            if (esize[i]++ > maxSize)
                setup(i,1);
            else
                ellipses[i].setFrame(ellipses[i].getX(), ellipses[i].getY(),
				     esize[i], esize[i]);
        }
    }


    public static void main(String s[]) {
	final Ellipses demo = new Ellipses();
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeiconified(WindowEvent e) { demo.start(); }
	    public void windowIconified(WindowEvent e) { demo.stop(); }
	};
	Frame f = new Frame("Java2D Demo - Ellipses");
	f.addWindowListener(l);
	f.add("Center", demo);
	f.pack();
	f.setSize(new Dimension(400,300));
	f.show();
	demo.start();
    }
}
