/*
 * @(#)Caps.java	1.12 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


package demos.Lines;


import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Line2D;
import java.awt.font.TextLayout;
import J2DCanvas;


/**
 * Shows the three different styles of stroke ending.
 */
public class Caps extends J2DCanvas {

    public Caps() {
	setBackground(Color.white);
    }


    public void drawDemo(Graphics2D g2) {

	int theCaps[] = { BasicStroke.CAP_BUTT, BasicStroke.CAP_ROUND,
			    BasicStroke.CAP_SQUARE };
	String theDesc[] = { "Butt Cap", "Round Cap", "Square Cap" };

	g2.setColor(Color.black);

	for (int i=0; i < 3; i++) {
	    g2.setStroke(new BasicStroke(15.0f, theCaps[i], BasicStroke.JOIN_MITER));
	    g2.draw(new Line2D.Float(w/4,(i+1)*h/4,w-w/4,(i+1)*h/4));
	    TextLayout tl = new TextLayout(theDesc[i], g2.getFont(),g2.getFontRenderContext());
	    tl.draw(g2, (float) (w/2-tl.getBounds().getWidth()/2), (i+1)*h/4-10);
	}
    }

    public static void main(String s[]) {
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	};
	Frame f = new Frame("Java2D Demo - Caps");
	f.addWindowListener(l);
	f.add("Center", new Caps());
	f.pack();
	f.setSize(new Dimension(400,300));
	f.show();
    }

}
