/*
 * @(#)Rotate.java	1.10 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package demos.Transforms;

import java.awt.*;
import java.awt.event.*;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;
import J2DCanvas;


/**
 * Simple 45 degree rotate of a rectangle.
 */
public class Rotate extends J2DCanvas {


    public Rotate() {
	setBackground(Color.white);
    }


    public void drawDemo(Graphics2D g2) {

	Rectangle2D r = new Rectangle2D.Float(0,0,w/3,h/5);

	AffineTransform at = new AffineTransform();
	at.translate(w/3, h/3);
	g2.transform(at);

	g2.setColor(Color.black);
	new TextLayout("Simple 45% Rotate", g2.getFont(), g2.getFontRenderContext()).draw(g2, 0, -15);
	g2.setColor(Color.cyan);
	g2.fill(r);

	at = new AffineTransform();
	at.rotate((45*java.lang.Math.PI)/180); // radians=degree * pie / 180
	g2.transform(at);
	g2.setColor(Color.black);
	g2.draw(r);

	g2.setTransform(new AffineTransform());
    }


    public static void main(String s[]) {
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	};
	Frame f = new Frame("Java2D Demo - Rotate");
	f.addWindowListener(l);
	f.add("Center", new Rotate());
	f.pack();
	f.setSize(new Dimension(400,300));
	f.show();
    }
}
