/*
 * @(#)Scale.java	1.14 98/06/29
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package demos.Transforms;

import java.awt.*;
import java.awt.event.*;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;
import J2DCanvas;


/**
 * Scaling of a rectangle animated.
 */
public class Scale extends J2DCanvas {

    private double sx, sy;
    private float ssH;
    private Rectangle2D theRect = new Rectangle2D.Float(0, 0, 10, 10);
    private int scaleDir;
    private final int RIGHT = 0;
    private final int DOWN = 1;
    private final int LEFT = 2;
    private final int UP = 3;


    public Scale() {
	setBackground(Color.white);
	runnable = true;
    }


    public void drawDemo(Graphics2D g2) {

	if (newBufferedImage) {
	    sx = 1.0;
	    sy = 1.0;
	    scaleDir = RIGHT;
	}

	g2.setColor(Color.black);
	TextLayout tl = new TextLayout("Scale", g2.getFont(), g2.getFontRenderContext());
	tl.draw(g2, (float) (w/2-tl.getBounds().getWidth()/2),
			    tl.getAscent()+tl.getLeading());
	ssH = (float) (tl.getAscent()+tl.getLeading()+tl.getDescent());
	tl = new TextLayout("sx=" + String.valueOf(sx), g2.getFont(), g2.getFontRenderContext());
	float sw = (float) tl.getBounds().getWidth();
	ssH += (float) (tl.getAscent()+tl.getLeading()+tl.getDescent());
	tl.draw(g2, 10,ssH-1);
	tl = new TextLayout("sy=" + String.valueOf(sy), g2.getFont(), g2.getFontRenderContext());
	tl.draw(g2, 12+sw,ssH-1);

	AffineTransform at = new AffineTransform();
	at.translate(10,(double) ssH);
	at.scale(sx, sy);

	g2.setColor(Color.green);
	Shape r = at.createTransformedShape(theRect);
	g2.fill(r);

	if (scaleDir == RIGHT) {
	    sx += .5;
	    if (r.getBounds2D().getWidth() > w-30)
	        scaleDir = DOWN;
	} else if (scaleDir == DOWN) {
	   sy += .5;
	   if (r.getBounds2D().getHeight() > h-ssH-20)
	       scaleDir = LEFT;
	} else if (scaleDir == LEFT) {
	sx -= .5;
	if (sx == 1)
	    scaleDir = UP;
	} else if (scaleDir == UP) {
	    sy -= .5;
	    if (sy == 1)
	        scaleDir = RIGHT;
	}
    }


    public static void main(String s[]) {
	final Scale demo = new Scale();
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeiconified(WindowEvent e) { demo.start(); }
	    public void windowIconified(WindowEvent e) { demo.stop(); }
	};
	Frame f = new Frame("Java2D Demo - Scale");
	f.addWindowListener(l);
	f.add("Center", demo);
	f.pack();
	f.setSize(new Dimension(400,300));
	f.show();
	demo.start();
    }
}
