/*
 * @(#)Metalworks.java	1.4 98/04/24
 *
 * Copyright 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


/**
  * This application is a demo of the Metal Look & Feel
  *
  * @version 1.4 04/24/98
  * @author Steve Wilson
  */
public class Metalworks {

    public static void main( String[] args ) {
        try {
	    com.sun.java.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme( new com.sun.java.swing.plaf.metal.DefaultMetalTheme());
	    UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
	}  
	catch ( UnsupportedLookAndFeelException e ) {
	    System.out.println ("Metal Look & Feel not supported on this platform. \nProgram Terminated");
	    System.exit(0);
	}
	catch ( IllegalAccessException e ) {
	    System.out.println ("Metal Look & Feel could not be accessed. \nProgram Terminated");
	    System.exit(0);
	}
	catch ( ClassNotFoundException e ) {
	    System.out.println ("Metal Look & Feel could not found. \nProgram Terminated");
	    System.exit(0);
	}   
	catch ( InstantiationException e ) {
	    System.out.println ("Metal Look & Feel could not be instantiated. \nProgram Terminated");
	    System.exit(0);
	}
	catch ( Exception e ) {
	    System.out.println ("Unexpected error. \nProgram Terminated");
	    e.printStackTrace();
	    System.exit(0);
	}
        JFrame frame = new MetalworksFrame();
	frame.setVisible(true);
    }
}
