// Copyright  1998 Sun Microsystems, Inc. All Rights Reserved.
//
package examples.activation; 

import java.rmi.*;
import java.rmi.activation.*;

public class MyNonRemoteClassAdapter implements examples.activation.AnotherRemoteInterface {

    private String result = null;
    private MyNonRemoteClass mnrc;

    // The constructor for activation and export; this constructor is
    // called by the method ActivationInstantiator.newInstance during
    // activation, to construct the object.
    //
    public MyNonRemoteClassAdapter(ActivationID id, MarshalledObject data) 
        throws RemoteException {

        // Register the object with the activation system
        // then export it on an anonymous port
        //
        Activatable.exportObject(this, id, 0);

        // Create an instance of the class MyNonRemoteClass
	//
        mnrc = new MyNonRemoteClass();
    }

    // Define the method declared in AnotherRemoteInterface
    // to accept a String, modify it, and return it to the client
    //
    public String calltheServer(String takeThis) throws RemoteException {

	// Rather than modify the String here, forward
	// it on to the non-remote object impleemntation
	//
        result = mnrc.calltheServer(takeThis);
        return result;
    }

}
