/*
 * @(#)StylesheetWriter.java	1.1 98/04/21
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package com.sun.tools.doclets.standard;

import com.sun.tools.doclets.*;
import com.sun.tools.javadoc.*;
import java.io.*;
import java.lang.*;
import java.util.*;

/**
 *
 * @author Atul M Dambalkar 
 */
public class StylesheetWriter extends HtmlStandardWriter {

    /**
     * Constructor.
     */
    public StylesheetWriter(String filename) throws IOException {
        super(filename);
    }

    /**
     * Generate the style file contents.
     */
    public static void generate() throws DocletAbortException {
        StylesheetWriter stylegen;
        String filename = "";
        try {
            if (Standard.configuration().stylesheetfile.length() == 0) {
                filename = "stylesheet.css";
                stylegen = new StylesheetWriter(filename);
                stylegen.generateStyleFile();
                stylegen.close();
            }
        } catch (IOException exc) {
            Standard.configuration().standardmessage.error(
                "doclet.exception_encountered",
                exc.toString(), filename);
            throw new DocletAbortException();
        }
    }

    /**
     * Generate the style file contents.
     */
    protected void generateStyleFile() {
        print("/* "); printText("doclet.Style_line_1"); println(" */"); 
        println("");
        print("/* "); printText("doclet.Style_line_2"); println(" */");
        println("");
        print("/* "); printText("doclet.Style_line_3"); println(" */");
        println("body { background-color: #FFFFF }"); println("");
        print("/* "); printText("doclet.Style_line_4"); println(" */");
        print(".TableSummaryHeadingColor    { background: #CCCCFF }"); 
        print(" /* "); printText("doclet.Style_line_5"); println(" */");
        print(".TableInheritedHeadingColor  { background: #EEEEFF }"); 
        print(" /* "); printText("doclet.Style_line_6"); println(" */");
        print(".TableRowColor               { background: #FFFFFF }"); 
        print(" /* "); printText("doclet.Style_line_7"); println(" */");
        println("");
        print("/* "); printText("doclet.Style_line_8"); println(" */");
        println("");
        println(".FrameTitleFont  { font-size: normal; font-family: normal }");
        println(".FrameHeadingFont { font-size: normal; font-family: normal }");
        println(".FrameItemFont  { font-size: normal; font-family: normal }");
        println("");
        print("/* "); printText("doclet.Style_line_9"); println(" */");
        print("/* "); 
        print(".FrameItemFont  { font-size: 10pt; font-family: ");
        print("helvetica arial sans-serif }"); println(" */");
    }

}



