
package com.magelang;

import java.awt.Insets;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.BorderLayout;
/**
 * A simple Panel extension that provides a border and a
 * Button as a label for a sub panel of a splitter
 *
 * <p>Use this code at your own risk!  MageLang Institute is not
 * responsible for any damage caused directly or indirctly through
 * use of this code.
 * <p><p>
 * <b>SOFTWARE RIGHTS</b>
 * <p>
 * MageLang support classes, version 1.0, MageLang Institute
 * <p>
 * We reserve no legal rights to this code--it is fully in the
 * public domain. An individual or company may do whatever
 * they wish with source code distributed with it, including
 * including the incorporation of it into commerical software.
 *
 * <p>However, this code cannot be sold as a standalone product.
 * <p>
 * We encourage users to develop software with this code. However,
 * we do ask that credit is given to us for developing it
 * By "credit", we mean that if you use these components or
 * incorporate any source code into one of your programs
 * (commercial product, research project, or otherwise) that
 * you acknowledge this fact somewhere in the documentation,
 * research report, etc... If you like these components and have
 * developed a nice tool with the output, please mention that
 * you developed it using these components. In addition, we ask that
 * the headers remain intact in our source code. As long as these
 * guidelines are kept, we expect to continue enhancing this
 * system and expect to make other tools available as they are
 * completed.
 * <p>
 * The MageLang Support Classes Gang:
 * @version MageLang Support Classes 1.0, MageLang Insitute, 1997
 * @author <a href="http:www.scruz.net/~thetick">Scott Stanchfield</a>, <a href=http://www.MageLang.com>MageLang Institute</a>
 */
class BorderPanel extends java.awt.Panel {

/**
 * BorderPanel constructor comment.
 */
public BorderPanel() {
	super();
	setLayout(new BorderLayout());
}
/**
 * BorderPanel constructor comment.
 * @param layout java.awt.LayoutManager
 */
public BorderPanel(java.awt.LayoutManager layout) {
	super(layout);
}
/** Provide room for the etched border */
public Insets getInsets() {
	return new Insets(5,5,5,5);
}
/** Draw an etched border around the contained component */
public void paint(Graphics g) {
	Dimension d = getSize();
	g.setColor(getBackground());
	g.draw3DRect(2,2,d.width-5, d.height-5, true);
	g.draw3DRect(3,3,d.width-7, d.height-7, false);
}	
}