package origjava.jdbctest;

import origjava.test.*;

import java.awt.*  ;
import java.util.Vector;
import java.util.Enumeration;
import java.net.URL;
import java.sql.*;
import java.io.*;


public synchronized class RjlResultSetMetaData extends Object implements ResultSetMetaData {
    private ResultSetMetaData c_rsmd; 
    private Vector presentationStyle = new Vector();
    private Integer defaultStyle = new Integer(RJLRuntime.ACTIONTEXT);
    private boolean isVisible = false ;
    private Frame c_cont = new Frame("RjlResultSetMetaData");
    private boolean catalogNameSupported = true;
    private boolean tableNameSupported = true;

    public boolean isTableNameSupported() {
        return tableNameSupported;
        }
    public void setTableNameSupported(boolean theValue) {
        tableNameSupported = theValue;
        }
    public boolean isCatalogNameSupported() {
        return catalogNameSupported;
        }
    public void setCatalogNameSupported(boolean theValue) {
        catalogNameSupported = theValue;
        }

    public RjlResultSetMetaData(ResultSetMetaData rsmd,boolean visible, Frame cont, int style) {
	c_rsmd = rsmd;
    isVisible = visible;
    c_cont = cont;
    defaultStyle = new Integer(style);
    
		for (int i=1; i<= getColumnCount(); i++) {
            presentationStyle.addElement(defaultStyle);
		}

    }
    public ResultSetMetaData getResultSetMetaData() {
        return c_rsmd;
    }
    public int getPresentationStyle(int i ) {
        if ( i > presentationStyle.size()) return 0 ;
        if ( i < 1 ) return 0 ;
        Integer l_return  = (Integer) presentationStyle.elementAt(i-1);
        if (l_return == null ) return 0;
        return l_return.intValue();

    }
    public void setPresentationStyle(int i, int style) {
        if ( i > presentationStyle.size()) return  ;
        if ( i < 1 ) return  ;
        Integer l_value  = (Integer) presentationStyle.elementAt(i-1);
        if (l_value == null ) return ;
        presentationStyle.setElementAt( l_value, i);
    }
    public void displayExceptionMessage(SQLException ex) {
		if (! isVisible) System.out.println ("\n*** SQLException caught ***\n");
        String title = "SQL Exeception ";
        String messg;
        String seperator = "\n";
        while (ex != null) {
            if (isVisible) {
                messg = "SQLState: ".concat(ex.getSQLState()).concat(seperator).concat("Message: ").concat(
                               ex.getMessage()).concat(seperator).concat("Vendor: ").concat(
                               new Integer( ex.getErrorCode()).toString());
                messageBox errorBox = new messageBox(c_cont,messg,
                                              title,messageBoxButtons.OK);
            }
            else 
            {
                System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
                System.out.println ("");
              }

			  ex = ex.getNextException ();
				
			}

    }
    public int getColumnCount()
    {
       int l_return = 0;
            try { l_return = c_rsmd.getColumnCount(); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isAutoIncrement(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isAutoIncrement(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isCaseSensitive(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isCaseSensitive(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isSearchable(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isSearchable(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isCurrency(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isCurrency(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public int isNullable(int i)
    {
       int l_return = 0;
            try { l_return = c_rsmd.isNullable(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isSigned(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isSigned(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public int getColumnDisplaySize(int i)
    {
       int l_return = 0;
            try { l_return = c_rsmd.getColumnDisplaySize(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getColumnLabel(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getColumnLabel(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getColumnName(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getColumnName(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getSchemaName(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getSchemaName(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public int getPrecision(int i)
    {
       int l_return = 0;
            try { l_return = c_rsmd.getPrecision(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public int getScale(int i)
    {
       int l_return = 0;
            try { l_return = c_rsmd.getScale(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getTableName(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getTableName(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getCatalogName(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getCatalogName(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public int getColumnType(int i)
    {
       int l_return = 0;
            try { l_return = c_rsmd.getColumnType(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public String getColumnTypeName(int i)
    {
       String l_return = "";
            try { l_return = c_rsmd.getColumnTypeName(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isReadOnly(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isReadOnly(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isWritable(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isWritable(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }
    public boolean isDefinitelyWritable(int i)
    {
       boolean l_return = false;
            try { l_return = c_rsmd.isDefinitelyWritable(i); }
        	catch (SQLException ex) {displayExceptionMessage(ex);}
        return l_return; 
    }

}