/**
 * @(#)StatusPanel.java	1.1 04/17/97
 * 
 */
package origjava.jdbctest;
import java.awt.*;

/**
 * StatusPanel: a class for displaying status for an ongoing operation.
 * Four sub-panels are provided 1,2,3,4 (left to right).
 * Font,text,alignment, and minimumWidth can be set for each.
 * sub-panels are ThreeDLabels which is derived from Label.
 */
public class StatusPanel extends Panel
{
	private ThreeDLabel statusText1;
	private ThreeDLabel statusText2;
	private ThreeDLabel statusText3;
	private ThreeDLabel statusText4;
    Panel theStatusBar;

	public StatusPanel()
	{
		this.setBackground(Color.lightGray);
		statusText1 = new ThreeDLabel(" ",200);
		statusText2 = new ThreeDLabel( " " ,75 );
		statusText3 = new ThreeDLabel(" " ,115);
		statusText4 = new ThreeDLabel(" " ,120);
        theStatusBar = new Panel();
		theStatusBar.setLayout(new GridBagLayout());
		addToPanel( statusText1,setConstraints(
                                         GridBagConstraints.RELATIVE,//int gridx,
                                         GridBagConstraints.NONE,//int gridy,
                                         3,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         3.0,//double weighty,
                                         GridBagConstraints.EAST,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
             );
		addToPanel( statusText2,setConstraints(
                                         GridBagConstraints.RELATIVE,//int gridx,
                                         GridBagConstraints.NONE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         1.0,//double weighty,
                                         GridBagConstraints.EAST,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
             );
		addToPanel( statusText3,setConstraints(
                                         GridBagConstraints.RELATIVE,//int gridx,
                                         GridBagConstraints.NONE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         1.0,//double weighty,
                                         GridBagConstraints.EAST,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
             );
		addToPanel( statusText4,setConstraints(
                                         GridBagConstraints.RELATIVE,//int gridx,
                                         GridBagConstraints.NONE,//int gridy,
                                         2,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         2.0,//double weighty,
                                         GridBagConstraints.EAST,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
             );
        add(theStatusBar);
        doLayout();
	}
public  void addToPanel (Component l_cmp, GridBagConstraints theConstraints) {
       l_cmp.setSize(l_cmp.getPreferredSize());
       theStatusBar.add(l_cmp,theConstraints);
       theStatusBar.setSize(getPreferredSize());
}

	public void update(Graphics g)
	{
		paint(g);
	}
public GridBagConstraints setConstraints(
                                         int gridx,
                                         int gridy,
                                         int gridwidth,
                                         int gridheight,
                                         double weightx,
                                         double weighty,
                                         int anchor,
                                         int fill,
                                         Insets insets,
                                         int ipadx,
                                         int ipady
                                         )
    {
     GridBagConstraints theValue = new GridBagConstraints();
         theValue.gridx = gridx;
         theValue.gridy = gridy;
         theValue.gridwidth = gridwidth;
         theValue.gridheight = gridheight;
         theValue.weightx = weightx;
         theValue.weighty= weighty;
         theValue.anchor = anchor;
         theValue.fill = fill;
         theValue.insets = insets;
         theValue.ipadx = ipadx;
         theValue.ipady = ipady;
         return theValue;
    }
	
	public void paint(Graphics g)
	{

   		Rectangle r = this.getBounds();
        int space = 2;
        int w = r.width;
        int h = r.height;
        int topx = 0;
        int topy = 0;
        int topx2 = w-1;
        int leftx = topx ;//rectangle one
        int lefty = topy +1;
        int lefty2 = h -1;
        int rightx =  w - 1  ;
        int righty = topy; //rectangle two
        int righty2 = h ;
        int botx = topx + 1;
        int boty = h - 1 ;
        int botx2 = w -2; //rectangle three
		g.setColor( Color.gray );
        g.drawLine(topx,topy,topx2,topy);//top
        g.drawLine(leftx,lefty,leftx,lefty2);//left
        g.setColor( Color.gray );
        g.drawLine(rightx,righty,rightx,righty2); //right
        g.drawLine(botx,boty,botx2,boty); //bottom
        //inner rectangle
        int atopx = topx + space ;
        int atopy = topy + space - 1;
        int atopx2 = topx2 - space;
        int aleftx = leftx + space - 1;//rectangle one
        int alefty = lefty + space -1;
        int alefty2 = lefty2 - space + 1;
        int arightx = rightx - space;
        int arighty = righty + space; //rectangle two
        int arighty2 = righty2 - space;
        int abotx = botx + space -1;
        int aboty = boty - space;
        int abotx2 = botx2 - space; 
        g.setColor( Color.white );
        g.drawLine(atopx,atopy,atopx2,atopy);//top
        g.drawLine(aleftx,alefty,aleftx,alefty2);//left
        g.setColor( Color.white );
        g.drawLine(arightx,arighty,arightx,arighty2); //right
        g.drawLine(abotx,aboty,abotx2,aboty); //bottom

	}

	public void setText1(String text)
	{
		statusText1.setText( text );
	}
	public void setText2(String text)
	{
		statusText2.setText( text );
	}
	public void setText3(String text)
	{
		statusText3.setText( text );
	}
	public void setText4(String text)
	{
		statusText4.setText( text );
	}

	public String getText1( )
	{
		return statusText1.getText(  );
	}
	public String getText2( )
	{
		return statusText2.getText(  );
	}
	public String getText3( )
	{
		return statusText3.getText(  );
	}
	public String getText4( )
	{
		return statusText4.getText(  );
	}

	public void setFont1(Font font)
	{
		statusText1.setFont( font );
	}
	public void setFont2(Font font)
	{
		statusText2.setFont( font );
	}
	public void setFont3(Font font)
	{
		statusText3.setFont( font );
	}
	public void setFont4(Font font)
	{
		statusText4.setFont( font );
	}

	public void setMinWidth1(int theValue)
	{
		statusText1.setMinWidth( theValue );
	}
	public void setMinWidth2(int theValue)
	{
		statusText2.setMinWidth( theValue );
	}
	public void setMinWidth3(int theValue)
	{
		statusText3.setMinWidth( theValue );
	}
	public void setMinWidth4(int theValue)
	{
		statusText4.setMinWidth( theValue );
	}

	public void setAlignment1(int theValue)
	{
		statusText1.setAlignment( theValue );
	}
	public void setAlignment2(int theValue)
	{
		statusText2.setAlignment( theValue );
	}
	public void setAlignment3(int theValue)
	{
		statusText3.setAlignment( theValue );
	}
	public void setAlignment4(int theValue)
	{
		statusText4.setAlignment( theValue );
	}

}

