package origjava.jdbctest;
import java.awt.*;
import origjava.test.*;

/**
 * ThreeDLabel: a class for displaying a label with a 3DBox.
 * A minimum display width can be passed to the constructor.
 */
public class ThreeDLabel extends Label
{
    private int minWidth = 0;
    private Util uT ;

    public void setMinWidth(int theWidth){
        minWidth = theWidth;
        }
    public void setText(String theText) {
        String thePad ;
        String theOver = "" ;
        Dimension sSize = super.getMinimumSize();
        FontMetrics fm = getFontMetrics(getFont());
        int textWidth = sSize.width;
        int newWidth; 
        if (textWidth < minWidth) 
            {thePad =  uT.padIt(theText,minWidth,fm);
             if (getAlignment() == LEFT ) theOver = thePad + theText ;
             if (getAlignment() == RIGHT ) theOver = theText + thePad;
             if (getAlignment() == CENTER) 
                 {int halfLength = (int) (thePad.length()/2);
                  theOver = thePad.substring(1,halfLength) + theText + thePad.substring(1,halfLength);
                 }
              theText = theOver;
              } 
        super.setText(theText);
        }
   	public ThreeDLabel()
	{
        this("",0);
	}

	public ThreeDLabel(String text)
	{
        this(text,0);
	}
    public ThreeDLabel(String text, int theMinWidth) {
        this(" " + text,theMinWidth,LEFT,Context.getFontProperty("plainFont"));
        }
    public ThreeDLabel(String text,int theMinWidth,int alignment, Font font) {
        super(text,alignment);
        setMinWidth(theMinWidth);
        setFont(font);
        setText(text);
        this.setBackground(Color.lightGray);
        }

    public void paint(Graphics g)
    {
   		Rectangle r = this.getBounds();
		g.setColor( Color.gray );
        g.drawLine(0,0,r.width,0);//top
        g.drawLine(0,0,0,r.height);//left
        g.setColor( Color.white );
        g.drawLine(r.width-1,0,r.width-1,r.height-1); //right
        g.drawLine(0,r.height-1,r.width-1,r.height-1); //bottom
        g.setColor(Color.lightGray);
        //inner rectangle
        g.setColor( Color.gray.darker() );
        g.drawLine(1,1,r.width-2,1);//top
        g.drawLine(1,1,1,r.height-2);//left
        g.drawLine(r.width-2,2,r.width-2,r.height-2); //right
        g.drawLine(2,r.height-2,r.width-2,r.height-2); //bottom
    }

	public void update(Graphics g)
	{
		paint(g);
	}
}

