package origjava.test;

import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;
import java.net.URL;
import java.util.Vector;
import java.beans.*;
import java.io.Serializable;


public class HoverLabel extends RJLMultiLineLabel implements Serializable ,Timeable,MouseListener,MouseMotionListener
{
    private Color hoverForeGround = Color.darkGray;
    private Color hoverBackGround = new Color(200, 250, 90);
    private Vector containerLocations;
    private boolean mouseEntered = false;
    private boolean mouseExited = false;
    protected TipTimer timer ;
    protected Component listenedToObject;
    private long theTipDelay = 2500;
    private String hoverText = " Bob Leurck \n bobl@conceptsdyn.com ";
    private Container theFrame ;
    private boolean wasAdded = false;
    private Container theWrapper;
    private Integer TipOffsetX = new Integer(5);
    private Integer TipOffsetY = new Integer (8);
    private Boolean isMoveable = new Boolean(false);
    private PropertyChangeSupport changes = new PropertyChangeSupport(this);


    public Container getParentFrame()
    {
        if (listenedToObject == null ) return null ;
        Container container = (Container) listenedToObject.getParent();
        Container container1 = container;
        containerLocations = new Vector();
        containerLocations.addElement(listenedToObject.getLocation());
        
        if (container != null ) 
            {
             containerLocations.addElement(container.getLocation());
            }
      
        for ( container1 = container; ; )          
            { 
              container1 = container.getParent(); 
              if ((container1 == null) || !(container1 instanceof Container) ) break;
              container = container1;
              containerLocations.addElement(container.getLocation());
            }/* find top container && get location to this comp */ ;

        if (container != null )
           {
             return container;
            }
        else
            {return null;}
    }

    public Point getAbsolutePoint() {
        Point theReturn;
        int x = 0;
        int y = 0;
        int numCont = containerLocations.size() -1 ;
        if (numCont == 0) return new Point(0,0);
        for (int i = 1; i <= numCont ; i++ ) /*exclude last */
            {
             theReturn = ((Point) containerLocations.elementAt(i-1)) ;
             x = theReturn.x + x;
             y = theReturn.y + y;
            }
        return new Point(x,y);
        }

    public HoverLabel(String string, int i, boolean flag)
    {
        setFilename(null);
        setAlignment(i);
        setText(string);
        setBorder(flag);
        Font font = new fontDefaults().getHoverTextFont();
        setFont(font);
        setForeground(hoverForeGround);
        setBackground(hoverBackGround);
        //addMouseListener(this);
        //addMouseMotionListener(this);
    }

    public HoverLabel(String string, int i)
    {
        this(string, i, false);
    }

    public synchronized void doSetVisible(boolean ib) {
        setVisible(ib);
        }
    public HoverLabel(String string)
    {
        this(string, 0,false);
    }

    public HoverLabel()
    {
        this(RJLRuntime.EmptyString, 0,true);
    }

    public void mouseDragged(MouseEvent me) {
    }

    public void setHoverForeGround(Color theColor) {
        hoverForeGround = theColor;
        setForeground(hoverForeGround);
        }
    public Color getHoverForeGround() {
        return hoverForeGround;
        }
    public Color getHoverBackGround() {
        return hoverBackGround;
        }
    public void setHoverBackGround(Color theColor) {
        hoverBackGround = theColor;
        setBackground(hoverBackGround);
        }
    public void mouseMoved(MouseEvent me) {
    }

    public void mouseClicked(MouseEvent me) {
    }


    public void mouseEntered(MouseEvent me) {
            if (me.getSource() == this) return;
            mouseEntered = true;
            mouseExited = false;
            if(listenedToObject == null )listenedToObject = (Component) me.getSource();
            if ( listenedToObject != null ) {
            if (timer == null ) startTipTimer();
                }
    }
    public void mouseExited(MouseEvent me) {
            if (me.getSource() == this) return;
            if (listenedToObject != null ) {
                stopTipTimer();
                }
            mouseExited = true;
            mouseEntered = false;
    }
    public void mousePressed(MouseEvent me) {
    }

    public void mouseReleased(MouseEvent me) {
    }

    public void toggleHoverHelp() {
            if (isVisible() ) displayHoverHelp(false);
            if (!isVisible() ) displayHoverHelp(true);
        }
    public  void tick()
    {
        if (mouseEntered && !mouseExited ) {
            if (!isVisible() ) displayHoverHelp(true);
        }
        //if (isVisible() ) stopTipTimer();
     }
    public void startTipTimer() {
        if (timer != null ) {
            if ( isVisible() ) stopTipTimer();
            return;
            }
        if (timer == null )//&& !isVisible() )
            {timer = new TipTimer(this, theTipDelay);
            if ( isVisible() ) setVisible(false);
             timer.start();
            }
    }
    public void stopTipTimer() {
        if (timer != null) {
            timer.stop();
            timer = null;
            if (isVisible() ) displayHoverHelp(false);
            }
        }

    public synchronized void displayHoverHelp(boolean ib)
    {
        setText(getHoverText());
        setSize(preferredSize());
        Rectangle rectangle = getBounds();
        if (listenedToObject != null ) rectangle = listenedToObject.getBounds();

        if ( !wasAdded ) /* only do once unless moving this around */
           {
            Container frame = getParentFrame();
            if ( frame != null) 
               {
                theFrame = frame;
                theFrame.add(this,0);
                wasAdded = true;
               }
           }
        if ( isMoveable.booleanValue() )
            {
            Container frame = getParentFrame();
            if ( frame != null) 
               {
                theFrame = frame;
                if ( wasAdded ) theFrame.remove(this);
                theFrame.add(this,0);
                wasAdded = true;
               }

            }
        Point point = getAbsolutePoint();
        setLocation( point.x +TipOffsetX.intValue(),  rectangle.height + 
                                point.y + TipOffsetY.intValue()
                               );

        if (wasAdded)
           {
            theFrame.remove(this);
            theFrame.add(this,0);
            wasAdded = true;
           }
        setVisible(ib);
    }


    public void setTheTipDelay(long i) {
        theTipDelay = i;
    }
    public long getTheTipDelay() {
        return theTipDelay;
    }


    public void setHoverText(String newLabel) {
	String oldLabel = hoverText;
	hoverText = newLabel;
	changes.firePropertyChange("HoverText", oldLabel, newLabel);
    }

    public String getHoverText() {
        return hoverText;
        }

    public void setTipOffsetX(String l_int) {
        Integer newValue = new Integer(l_int);
    	Integer oldValue = TipOffsetX;
	    TipOffsetX = newValue;
        changes.firePropertyChange("TipOffsetX", oldValue, newValue);
     }

     public String getTipOffsetX() {
          return TipOffsetX.toString();
         }
    public void setTipOffsetY(String l_int) {
        Integer newValue = new Integer(l_int);
    	Integer oldValue = TipOffsetY;
	    TipOffsetY = newValue;
        changes.firePropertyChange("TipOffsetY", oldValue, newValue);
     }

     public String getTipOffsetY() {
          return TipOffsetY.toString() ;
         }

   public Boolean getIsMoveable() {
       return isMoveable;
       }

   public void setIsMoveable(Boolean newValue) {
       Boolean oldValue = isMoveable;
       isMoveable = newValue;
       changes.firePropertyChange("isMoveable",oldValue,newValue);
       }



    /**
     * The specified PropertyChangeListeners <b>propertyChange</b> method will
     * be called each time the value of any bound property is changed.
     * The PropertyListener object is addded to a list of PropertyChangeListeners
     * managed by this button, it can be removed with removePropertyChangeListener.
     * Note: the JavaBeans specification does not require PropertyChangeListeners
     * to run in any particular order.
     *
     * @see #removePropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void addPropertyChangeListener(PropertyChangeListener l) {
	changes.addPropertyChangeListener(l);
    }

    /** 
     * Remove this PropertyChangeListener from the buttons internal list.  
     * If the PropertyChangeListener isn't on the list, silently do nothing.
     * 
     * @see #addPropertyChangeListener
     * @param l the PropertyChangeListener
     */      
    public void removePropertyChangeListener(PropertyChangeListener l) {
	changes.removePropertyChangeListener(l);
    }

    //----------------------------------------------------------------------

}

