package origjava.test;
import java.awt.*;
import java.util.*;
import java.lang.*;

public  class InputFrame extends Frame implements RlObserver, RlObservable {
    public InputFrame(String title,buttonVector butList,maxLength  maxLngth) {

    super(title);
    setup();

    messageVector = maxLngth.messageVector1;
    maxLabelLength = maxLngth.maxLabelLength;
    m_count = messageVector.size();
    addMessage();

    init( butList);

    }

    public InputFrame( String title,buttonVector butList,TextVector txtfldlist ) {

    super( title );
    setup();

    addTextFields(txtfldlist);
    
    init( butList);


    }

public void setup() {
    setBackground(TEXT_AREA_BACKGROUND);
    theLayout = new GridBagLayout();
	setLayout(theLayout);
    }

public void init(buttonVector butList) {
    addButtons(butList);
    doLayout();
    pack();
    centerDialog();
    setVisible(true);
    }
public GridBagConstraints setConstraints(
                                         int gridx,
                                         int gridy,
                                         int gridwidth,
                                         int gridheight,
                                         double weightx,
                                         double weighty,
                                         int anchor,
                                         int fill,
                                         Insets insets,
                                         int ipadx,
                                         int ipady
                                         )
    {
     GridBagConstraints theValue = new GridBagConstraints();
         theValue.gridx = gridx;
         theValue.gridy = gridy;
         theValue.gridwidth = gridwidth;
         theValue.gridheight = gridheight;
         theValue.weightx = weightx;
         theValue.weighty= weighty;
         theValue.anchor = anchor;
         theValue.fill = fill;
         theValue.insets = insets;
         theValue.ipadx = ipadx;
         theValue.ipady = ipady;
         return theValue;
    }

public  void addToPanel (Component l_cmp, GridBagConstraints theConstraints) {

       l_cmp.setSize(l_cmp.getPreferredSize());
       add(l_cmp,theConstraints);
       setSize(getPreferredSize());
}

public boolean action(Event e, Object arg) {
    //closeWindow();
    return false;
}
 public  void centerDialog()
{
    Dimension dimension1 = getPreferredSize();
    Dimension dimension2 = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (
        (dimension2.width - (dimension1.width))/2 
        );
    int y = (
        (dimension2.height - (dimension1.height))/2 
        );
    setLocation(x, y);
}


    public void addMessage(){
    // Add a "Label" for reach line of text.
    int l_count ;

    Font l_font =   fontDef.getDialogTextFont();
    FontMetrics fM = getFontMetrics(l_font);
    Panel mP = new Panel();
    GridLayout gL = new GridLayout();
    mP.setLayout(gL);
    gL.setRows(m_count);
    l_count = 0;
    while ( m_count > 0 ) {
        String line;
        line = (new padIt( (messageVector.elementAt(l_count)).toString(),( int) maxLabelLength , fM) ).l_return;
        Label l = new Label(line);
        l.setFont(fontDef.getDialogTextFont());
        l.setBackground(LABEL_BACKGROUND);
	    mP.add("label"+ l_count,l);
	    height += 20;
        m_count = m_count - 1;
        l_count = l_count + 1;
    }
//    addToPanel(mP);
    addToPanel(mP,setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         l_count,//double weighty,
                                         GridBagConstraints.NORTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
               );

    }

    public void addTextFields(TextVector textList) {
    int ySpace = 5;
    
    int leftInset = ySpace;
    int rightInset = ySpace;
    Panel lP = new Panel();   
    GridLayout gL = new GridLayout();
	lP.setLayout(gL);
    gL.setRows(textList.TextObjects.size());
    gL.setColumns(1);
    gL.setHgap(1);
    gL.setVgap(1);

//add textfields
    for(int ib = 1; ib <= textList.TextObjects.size(); ++ib)
    {
        try {actionText lb = (actionText) textList.TextObjects.elementAt(ib-1);
             lP.add(lb);
            }
        catch (ClassCastException ex)
            {actionTextArea lb1 = (actionTextArea) textList.TextObjects.elementAt(ib-1);
             lP.add(lb1);
            }

    }

    lP.doLayout();
    lP.setSize(lP.getPreferredSize());
    //addToPanel(lP);
    addToPanel(lP,setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         textList.TextObjects.size(),//double weighty,
                                         GridBagConstraints.NORTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady
               )
               );

       
    }

    public void addButtons(buttonVector butList){

    GridBagLayout gridBag1 = new GridBagLayout();
    Panel bP = new Panel();
    bP.setLayout(gridBag1);
  	GridBagConstraints cons = new GridBagConstraints();
    cons.gridx = GridBagConstraints.RELATIVE;
    cons.gridwidth = butList.size() + 2 ; 
    cons.weightx = 1;
    cons.weighty = 1;
    cons.anchor = GridBagConstraints.SOUTH;
    cons.insets = new Insets(2,2,2,2);                  
    Label start  = new Label(" ");
    start.setAlignment(Label.RIGHT);
    gridBag1.setConstraints(start, cons);
    bP.add(start);

    for(int ib = 1; ib <= butList.buttonObjects.size(); ++ib)
    {
        actionButton lb = (actionButton) butList.buttonObjects.elementAt(ib-1);
        
	    gridBag1.setConstraints(lb, cons);
    
	    bP.add(lb);
        
    }

   Label end = new Label(" ");
   gridBag1.setConstraints(end, cons);
   bP.add(end);

//   addToPanel(bP);
   addToPanel(bP,setConstraints(
                                         GridBagConstraints.NONE,//int gridx,
                                         GridBagConstraints.RELATIVE,//int gridy,
                                         1,//int gridwidth,
                                         1,//int gridheight,
                                         1.0,//double weightx,
                                         butList.buttonObjects.size(),//double weighty,
                                         GridBagConstraints.SOUTH,//int anchor,
                                         GridBagConstraints.NONE,//int fill,
                                         new Insets(1,1,1,1),//Insets insets,
                                         1,//int ipadx,
                                         1//int ipady

               )
               );

   }

        public void closeWindow()
    {
        setVisible(false);
        dispose();
        //if (isModal)
        //    getParent().setEnabled(true);
    }

    public boolean handleEvent(Event event)
    {
        switch (event.id)
        {
        case Event.WINDOW_DESTROY:
            closeWindow();
            break;
        }
        return super.handleEvent(event);
    }

        public Vector getObservers()
    {
        if (observers == null)
            observers = new Vector();
        return observers;
    }

    public synchronized void addObserver(RlObserver rlObserver)
    {
        getObservers().addElement(rlObserver);                                                                                         
    }

    public synchronized void removeObserver(RlObserver rlObserver)
    {
        getObservers().removeElement(rlObserver);
    }

    public void notifyObservers()
    {
        notifyObservers(0, null);
    }

    public void notifyObservers(Object object)
    {
        notifyObservers(0, object);
    }

    public void notifyObservers(int i)
    {
        notifyObservers(i, null);
    }

    public void notifyObservers(int i, Object object)
    {
        for (int j = 0; j < getObservers().size(); j++)
        {
            RlObserver rlObserver = (RlObserver)getObservers().elementAt(j);
            rlObserver.update(this, i, object);
        }
    }

    public void update(RlObservable rlObservable, int i, Object object)
    {
    }

private GridBagLayout theLayout;
protected Vector observers;
private	int width = 400;
private	int height = 5;
private GridBagLayout gridBag; 
public    Color TEXT_AREA_BACKGROUND = Color.lightGray ;
public    Color LABEL_BACKGROUND = Color.white ;
public     float maxLabelLength = 0;
public Vector messageVector = new Vector(1);
private boolean mode;
private    int m_count ;
private fontDefaults fontDef = new fontDefaults();
private boolean isMessage ;
}
