package origjava.test;
/*
 * @(#)RjlSupport.java	1.8 96/12/06  
 * 
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion bdk_beta
 * 
 */

//package java.beans;

/**
 * This is a utility class that can be used by beans that support bound
 * properties.  Your can either inherit from this class or you can use 
 * an instance of this class as a member field of your bean and delegate
 * various work to it.
 */

public class RjlSupport implements java.io.Serializable {

    /**
     * @sourceBean  The bean to be given as the source for any events.
     */

    public RjlSupport(Object sourceBean) {
	source = sourceBean;
    }

    /**
     * Add a RjlListener to the listener list.
     *
     * @param listener  The RjlListener to be added
     */

    public synchronized void addRjlListener(
				RjlListener listener) {
	if (listeners == null) {
	    listeners = new java.util.Vector();
	}
	listeners.addElement(listener);
    }

    /**
     * Remove a RjlListener from the listener list.
     *
     * @param listener  The RjlListener to be removed
     */

    public synchronized void removeRjlListener(
				RjlListener listener) {
	if (listeners == null) {
	    return;
	}
	listeners.removeElement(listener);
    }

    /**
     * Report a bound property update to any registered listeners.
     * No event is fired if old and new are equal and non-null.
     *
     * @param propertyName  The programmatic name of the property
     *		that was changed.
     * @param oldValue  The old value of the property.
     * @param newValue  The new value of the property.
     */
    public void fireRjl(Object l_target){//String propertyName, 
					//Object oldValue, Object newValue) {
    
    if ( !(l_target.equals(source)))  return ;
//	if (oldValue != null && oldValue.equals(newValue)) {
//	    return;
//	}

	java.util.Vector targets;
	synchronized (this) {
	    if (listeners == null) {
	    	return;
	    }
	    targets = (java.util.Vector) listeners.clone();
	}
        RjlEvent evt = new RjlEvent(source);
                               //,propertyName, oldValue, newValue);

	for (int i = 0; i < targets.size(); i++) {
	    RjlListener target = (RjlListener)targets.elementAt(i);
//        System.out.println("RjlSupport 1");
	    target.RjlAction(evt);
//        System.out.println("RjlSupport 2");
	}
    }
    public void notifyAllListeners(RjlEvent evt){

    java.util.Vector targets;

	synchronized (this) {
        if (listeners == null) 	return;
  	    targets = (java.util.Vector) listeners.clone();    
        }
	for (int i = 0; i < targets.size(); i++) {
	    RjlListener target = (RjlListener)targets.elementAt(i);
//        System.out.println("RjlSupport 1");
	    target.RjlAction(evt);
//        System.out.println("RjlSupport 2");
	    }
    }


    private java.util.Vector listeners;
    private Object source;
}
