package origjava.test;
import java.lang.*;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.MediaTracker;
import java.util.Vector;
import java.awt.*;
import java.awt.image.*;
import java.awt.peer.ComponentPeer;


//class statusPanel extends Panel {
class statusPanel extends Canvas {
    public static final int STATUSPANEL_HEIGHT = 20;
    public static final int STATUSPANEL_WIDTH = 500;
    protected int topLeft,top;
    protected Font StatusFont;
    protected FontMetrics StatusFontMetrics;
    protected static final Color BackGroundColor = Color.green;
    protected static final Color TextColor = Color.black;
    protected String ActMessage = "Please wait";
    protected static final int STATUSLEDS_WIDTH = 20;
    boolean SimulationInitializeInProgress = false;
    boolean SimulationRunning = false;
    boolean StatusLedOn = false;
    //Panel cThis;
    Canvas cThis;
	ComponentPeer cPeer;
    Container     frame;
    Graphics      frameG;
    boolean trueSizeKnown = false;



//----------------------------------------------------------------------------
// The constructor of the status panel
//----------------------------------------------------------------------------
    public statusPanel(Container l_frame) {
        frame = l_frame;
        StatusFont = new Font("TimesRoman",Font.PLAIN,12);
        setFont(StatusFont);
        StatusFontMetrics = getFontMetrics(StatusFont);
        cThis = (Canvas) this;
        //repaint(); -- wait till know where are
    }
//----------------------------------------------------------------------------
    // called to setPeer
//----------------------------------------------------------------------------
       public void setPeer(ComponentPeer peer)
       {
           this.cPeer = peer;
       }


//----------------------------------------------------------------------------
    // called to setLocation
//----------------------------------------------------------------------------
       public void setLocation(int topLeft,int top)
       {
           this.topLeft = topLeft;
           this.top = top;
       }
//----------------------------------------------------------------------------
// Calculate the preferred size of this panel
//----------------------------------------------------------------------------
	   	// called to override Canvas default	
    public Dimension getPreferredSize() {
          return getMinimumSize();
    }

    public synchronized Dimension getMinimumSize() {
		int w = STATUSPANEL_WIDTH ;
        int h = STATUSPANEL_HEIGHT;
        return new Dimension(w, h);
    }



//----------------------------------------------------------------------------
// Draw the status LED
//----------------------------------------------------------------------------
    public void DrawStatusLED(Graphics g) {
        StatusLedOn = !StatusLedOn;
       int LedX = getSize().width - STATUSLEDS_WIDTH;
        if (true) {
            g.setColor (Color.green);
        } else if (SimulationInitializeInProgress && StatusLedOn) {
            g.setColor (Color.red);
        } else {
            g.setColor (Color.gray);
        }
        g.fillOval (LedX + 3, 3, 15, 15);
    }

//----------------------------------------------------------------------------
// Draw the status panel
//----------------------------------------------------------------------------
    public synchronized void paint(Graphics g) {
        
    if (!trueSizeKnown) 
	{
        int Width = getSize().width;
        int Height = getSize().height;

        if ((Width > 0) && (Height > 0)) 
		{
                trueSizeKnown = true;

                //Ooh... component-initiated resizing.

                setSize(Width, Height);
                frame.doLayout();
                frame.repaint();
                           }
    }



        g.setColor(BackGroundColor);
        g.fillRect(0, 0, getSize().width - STATUSLEDS_WIDTH, 20);
        g.setColor(TextColor);
        g.drawString(ActMessage, 2, StatusFontMetrics.getHeight() - 2);
        g.setColor(Color.black);
        g.fillRect (getSize().width - STATUSLEDS_WIDTH, 0, STATUSLEDS_WIDTH, 20);
        g.setColor(BackGroundColor);
        g.drawRect (getSize().width - STATUSLEDS_WIDTH, 0, STATUSLEDS_WIDTH, 20);
        DrawStatusLED(g);
        g.setColor(Color.black.darker());
        g.drawRect (0, 0, getSize().width -1 ,getSize().height -1);

    }

//    public synchronized void update(Graphics g) 
//    {
//
//		paint (g);
//	}


//----------------------------------------------------------------------------
// Display the message
//----------------------------------------------------------------------------
    public void StatusMessage(String msg) {
        ActMessage = msg;
        repaint();
    }
}


class threeWayButton extends Canvas
{
	// public variables

	Image         m_up, m_down, m_disabled, m_img;
    int           m_state, m_x,m_y,topLeft,top,m_height,compNum,m_width;
	MediaTracker  m_trk;
	boolean       m_loaded;
    String        buttonName;
    Container     frame;
    Event         m_event;
    Dimension     m_dim;
    Graphics      gThis;  
    Canvas        cThis;
    Color         c_show,c_up,c_down,c_disabled;
	String        buttonDisplay;
	ComponentPeer cPeer;
    protected Font ButtonFont;
    protected FontMetrics ButtonFontMetrics;
    boolean trueSizeKnown = false;

    private Image offScreenImage;
    private Dimension offScreenSize;
    private Graphics offScreenGraphics;

        public threeWayButton(Image up, Image down, Image disabled,
                              String b_name,
                              int p_x,int p_y, Container l_frame,
                              int topLeft,int top)
                           
	{
		// Up must not be null.  If nulls sent for other states,
		// use the up image...
                //System.out.println (b_name);
       if (up != null) {
                        m_up = up;
                        m_x = p_x;
                        m_y = p_y;
                        buttonName = b_name;
						buttonDisplay = b_name;
                        frame = l_frame;
                        }
		else
        return;

		m_trk = new MediaTracker(this);

		m_down		= (down		== null) ? up :	down;
		m_disabled	= (disabled == null) ? up : disabled;

		ButtonFont = new Font("Arial",Font.PLAIN,8);
        setFont(ButtonFont);
        ButtonFontMetrics = getFontMetrics(ButtonFont);

        this.topLeft = topLeft;
        this.top = top;
		m_trk.addImage(m_up       ,1);
		m_trk.addImage(m_down     ,1);
		m_trk.addImage(m_disabled ,1);
		
		// now set the initial state to up...
		m_state = 1;
		m_img	= m_up;
        c_up = Color.white;
        c_show = c_up;
        c_down = Color.green;
        c_disabled = Color.blue;

		try
		{
			m_trk.waitForID(1);
		}
		catch(InterruptedException e)
		{
			return;
		}

		m_loaded = true;
                m_height = m_up.getHeight(this);
                m_width = m_up.getWidth(this);
                m_dim = new Dimension(m_width,m_height);
                setBackground(c_disabled);
		        setSize( m_up.getWidth(this),m_up.getHeight(this));
                cThis = (Canvas) this;
                this.setBounds(topLeft,top,getSize().width,
                              getSize().height );
                repaint(); 
                gThis = cThis.getGraphics();

	}

	// called to override Canvas default	
    public Dimension getPreferredSize() {
          return getMinimumSize();
    }

    public synchronized Dimension getMinimumSize() {
          return m_dim;
    }

    
    // called to setCompNum
       public void setCompNum(int compNum)
       {
           this.compNum = compNum;
       }
    // called to setGraphics
       public void setGraphics(Graphics gThis)
       {
           this.gThis = gThis;
       }
//----------------------------------------------------------------------------
    // called to setPeer
//----------------------------------------------------------------------------
       public void setPeer(ComponentPeer peer)
       {
           this.cPeer = peer;
       }

    // called to setLocation
       public void setLocation(int topLeft,int top)
       {
           this.topLeft = topLeft;
           this.top = top;
       }
    // called to set the button state and change image
	public void SetState(int state)
	{		
		m_state = state;
		switch (state)
		{
			default:
			case 1:	m_img	= m_up;  
                               c_show = c_up;
							   buttonDisplay = buttonName;
			       break;
			case 2:	m_img	= m_down;
                               c_show = c_down;
							   buttonDisplay = "DOWN ";
			       break;
			case 3:	m_img	= m_disabled; 
                                c_show = c_disabled;
                                break;
		}
               // System.out.println ("m_img");
               // System.out.println (buttonName);

              //  this.setBounds(topLeft,top,m_img.getWidth(this),
              //               m_img.getHeight(this) );
        m_x = 0;
        m_y = 0;

		setBackground( c_show);
        offScreenImage =  m_img;
		repaint();
	}

    // called to determine state
	public boolean isEnabled() 
	{
		if (m_state == 3) return false;
		return true;
	}

    // called to change to enabled state
	public synchronized void setEnabled(int state ) 
	{
		SetState(state);
	}

    // called to change to disabled state
	//public synchronized void setEnabled(false) 
	//{
	//	SetState(3);
	//}

    // mouse event to handle for button state
	public boolean mouseUp(Event event, int x, int y) 
	{
		
		if (m_state == 3 /* disabled */) return true;
                m_event = event;
		SetState(1);
	    
		return false;
	}

    // mouse event to handle for button state
	public boolean mouseDown(Event event, int x, int y) 
	{
            
                       
		if (m_state == 3 /* disabled */) return true;
                m_event = event;
		
		SetState(2);

		return false;
         }	


    // paint image
	public synchronized void paint(Graphics g) 
	{
		
		if (m_img != null)
		{

           if (!trueSizeKnown) 
		   {
           int imageWidth = m_img.getWidth(this);
           int imageHeight = m_img.getHeight(this);

               if ((imageWidth > 0) && (imageHeight > 0)) 
			   {
                  trueSizeKnown = true;

                  //Ooh... component-initiated resizing.
                   setSize(imageWidth, imageHeight);
				   this.setBounds(topLeft,top,getSize().width,
                              getSize().height );
                   frame.doLayout();
                   frame.repaint();
                }
            }

		    if (cPeer != null)
		    {
			
		       Graphics cg = (cPeer.getGraphics()).create(topLeft, top, getSize().width, getSize().height);
    	       try {
		             //  cg.drawImage(m_img, m_x, m_y, this);
		            } finally 
			       {
		             //  cg.dispose();
		            }
	    


				g.drawImage(m_img, m_x, m_y, this);
				
		   }
		}
	}




}
class threeDBox extends Canvas
{
	// public variables


        int           m_x,m_y,m_w,m_h = 0;

        public threeDBox(int x,int y,int width, int height)
                           
	{
                m_x = x;
                m_y = y;
                m_w = width;
                m_h = height;
		repaint();

	}


    // reset dimensions
        public void setDimensions(int x,int y,int width, int height)
                           
	{
                m_x = x;
                m_y = y;
                m_w = width;
                m_h = height;
         }

    // mouse event to handle for button state
	public boolean mouseUp(Event event, int x, int y) 
	{
		return false;
	}

    // mouse event to handle for button state
	public boolean mouseDown(Event event, int x, int y) 
	{
		return false;
	}


    // paint image
	public void paint(Graphics g) 
	{
                        boolean raised = true;
                        g.draw3DRect(m_x,m_y,m_w,
                                     m_h,raised);
       
	}
	// update
	public void update(Graphics g) 
	{
                       // System.out.println (buttonName);
                       // System.out.println ("but update");

		paint (g);
	}

}


public class buttonImages extends Object {
        int         tot = 10;
        Image       downs[] = new Image[tot];
        Image       disabs[] = new Image[tot];
        Image       ups[] = new Image[tot];
        String      buttonName[] = new String[tot];
        String      upsURL[] = new String[tot];
        Toolkit tlkt =  java.awt.Toolkit.getDefaultToolkit();
        String       name;
        Container    frame;
       // Vector      ImageButtons;

    public buttonImages(String name,int numButtons,Image ups[],
                        Image downs[],Image disabs[], String butNames[] ,String upsURL[])
        {
         this.name = name;
         this.tot = numButtons;
         this.ups = ups;
         this.downs = downs;
         this.disabs = disabs;
         this.buttonName = butNames;
         this.upsURL = upsURL;

        }
    public void defaultInit() {

         ups[0] = tlkt.getImage("images/accpt_up.gif");
         downs[0]=tlkt.getImage("images/accpt_dn.gif");
         disabs[0]=tlkt.getImage("images/accpt_ds.gif");
         upsURL[0] = ("images/accpt_up.gif");

         buttonName[0] = "acceptPB";
      
         ups[1] = tlkt.getImage("images/edit_up.gif");
         downs[1]=tlkt.getImage("images/edit_dn.gif");
         disabs[1]=tlkt.getImage("images/edit_ds.gif");
         upsURL[1] = ("images/edit_up.gif");

         buttonName[1] = "editPB";

         ups[2] = tlkt.getImage("images/cancl_up.gif");
         downs[2]=tlkt.getImage("images/cancl_dn.gif");
         disabs[2]=tlkt.getImage("images/cancl_ds.gif");
         upsURL[2] = ("images/cancl_up.gif");

         buttonName[2] = "cancelPB";

         ups[3] = tlkt.getImage("images/delet_up.gif");
         downs[3]=tlkt.getImage("images/delet_dn.gif");
         disabs[3]=tlkt.getImage("images/delet_ds.gif");
         upsURL[3] = ("images/delet_up.gif");

         buttonName[3] = "deletePB";

         ups[4] = tlkt.getImage("images/brows_up.gif");
         downs[4]=tlkt.getImage("images/brows_dn.gif");
         disabs[4]=tlkt.getImage("images/brows_ds.gif");
         upsURL[4] = ("images/brows_up.gif");

         buttonName[4] = "browsePB";

         ups[5] = tlkt.getImage("images/first24p.gif");
         downs[5]=tlkt.getImage("images/first24d.gif");
         disabs[5]=tlkt.getImage("images/first24e.gif");
         upsURL[5] = ("images/first24p.gif");

         buttonName[0] = "firstRecordPB";

         ups[6] = tlkt.getImage("images/left24p.gif");
         downs[6]=tlkt.getImage("images/left24d.gif");
         disabs[6]=tlkt.getImage("images/left24e.gif");
         upsURL[6] = ("images/left24p.gif");

         buttonName[6] = "leftVCRPB";

         ups[7] = tlkt.getImage("images/right24p.gif");
         downs[7]=tlkt.getImage("images/right24d.gif");
         disabs[7]=tlkt.getImage("images/right24e.gif");
         upsURL[7] = ("images/right24p.gif");

         buttonName[7] = "rightVCRPB";

         ups[8] = tlkt.getImage("images/last24p.gif");
         downs[8]=tlkt.getImage("images/last24d.gif");
         disabs[8]=tlkt.getImage("images/last24e.gif");
         upsURL[8] = ("images/last24p.gif");

         buttonName[8] = "lastRecordPB";

         ups[9] = tlkt.getImage("images/graph_up.gif");
         downs[9]=tlkt.getImage("images/graph_dn.gif");
         disabs[9]=tlkt.getImage("images/graph_ds.gif");
         upsURL[9] = ("images/graph_up.gif");

         buttonName[9] = "graphPB";

        }
    public buttonImages(String label, Container l_frame) {
         name = label;
         frame = l_frame;
         defaultInit();
        }
    public buttonImages(String label) {
         name = label;
         defaultInit();
        }

        public Image getUps(int i) {
            if ( i < (tot +1) ) return ups[i];
            return null;
        }
        public String getUpsURL(int i) {
            if ( i < (tot +1) ) return upsURL[i];
            return null;
        }

        public int getNumButtonImages() {
        return tot;
        }

        public statusPanel getStatusPanel(Container l_frame) {
        return new statusPanel(l_frame);
        }

        public threeDBox get3DBox(int x,int y,int width, int height){
        return new threeDBox(x,y,width,height);
        }

        public threeWayButton getButtonByNum(int i, int topLeft, int top) {
        String l_msg ;
        if ( i < tot ) {
           return new threeWayButton(ups[i],downs[i],disabs[i],buttonName[i],
                                     0,0,frame ,topLeft,top);
           }
         
         l_msg = "Button Image does not exist";
         System.out.println(l_msg);

           return new threeWayButton(ups[0],downs[0],disabs[0],buttonName[0],
                                     0,0,frame ,topLeft,top);

         }
        public threeWayButton getButtonByName(String b_name,int topLeft, int top) {
        String l_msg ;
        for (int i = 0; i < tot; i++) {
           
           if (buttonName[i].equals(b_name)) {
           return new threeWayButton(ups[i],downs[i],disabs[i],buttonName[i],
                                     0,0,frame ,topLeft,top);

             }
           }
         l_msg = "ButtonImage does not exist";
         System.out.println(l_msg);

           return new threeWayButton(ups[0],downs[0],disabs[0],buttonName[0],
                                     0,0,frame ,topLeft,top);

         }

}
